with Arithmetic;
use Arithmetic;
with Lexemes;
with String_Map;

package Symbol_Table is
------------------------------------------------------------------------------
-- Recognition and value storage for keywords and parameters.
------------------------------------------------------------------------------
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.
--
--                  All Rights Reserved.
--
-- Permission to use, copy, modify, and distribute this software and its
-- documentation for any purpose and without fee is hereby granted,
-- provided that the above copyright notice(s) appear in all copies and that
-- both that copyright notice(s) and this permission notice appear in
-- supporting documentation, and that the name of Rational not be used in
-- advertising or publicity pertaining to distribution of the software
-- without specific, written prior permission.
--
-- Rational disclaims all warranties with regard to this software, including
-- all implied warranties of merchantability and fitness, in no event shall
-- Rational be liable for any special, indirect or consequential damages or
-- any damages whatsoever resulting from loss of use, data or profits, whether
-- in an action of contract, negligence or other tortious action, arising out
-- of or in connection with the use or performance of this software.
------------------------------------------------------------------------------

------------------------------------------------------------------------------
-- Sym_Map - Maps between symbol names and symbol values.
------------------------------------------------------------------------------

    package Symbol_Map is  
       new String_Map (Range_Type       => Lexemes.Symbol_Value,  
                       Hash_Size        => 507,  
                       Exact_Case_Match => False);

    Sym_Map : Symbol_Map.Map;       -- Our symbol=>value map

--
    procedure Parameter_Definition (Additional_Parameters : String);
------------------------------------------------------------------------------
--  Additional_Parameters - Specifies additional/different parameter values
--      than the default set
--
-- Called as an initialization procedure.  Sets up all of the default
-- parameter values and additionally adds or modifies any parameters that
-- are specified by the argument.
--
-- Specify parameter values with strings with these forms:
--
--      "Sun=>TRUE"                     -- any number of blanks are optional
--      "Sun => TRUE"                   -- any number of blanks are optional
--      "Sun"                           -- same as "Sun=>TRUE"
--      "Sun|Unix=>FALSE"               -- set several to one value
--      "Sun=>TRUE,Unix=>TRUE"          -- set several to several values
--
-- Blanks are allowed anywhere and are optional.  Each parameter must be
-- mentioned by name.
------------------------------------------------------------------------------

end Symbol_Table;
