with Text_Io;

with Vstring_Type;
use Vstring_Type;

package body Error_Log is

--
    procedure Log_Error (Msg : E_String) is
    begin
        Log_Error (To_String (Msg));
    end Log_Error;

--
    procedure Log_Error (Msg : String) is
------------------------------------------------------------------------------
-- Log an error message using the local system conventions.  This indicates
-- that someting has gone actively wrong.
------------------------------------------------------------------------------
    begin

        Text_Io.Put ("*** ");
        Text_Io.Put_Line (Msg);

    end Log_Error;

--
    procedure Log_Info (Msg : E_String) is
    begin
        Log_Info (To_String (Msg));
    end Log_Info;

--
    procedure Log_Info (Msg : String) is
------------------------------------------------------------------------------
-- Log an informational message using the local system conventions.  This
-- indicates that someting "interesting" is/has happening/ed.
------------------------------------------------------------------------------
    begin

        Text_Io.Put ("+++ ");
        Text_Io.Put_Line (Msg);

    end Log_Info;

--
    procedure Log_State (Msg : E_String) is
    begin
        Log_State (To_String (Msg));
    end Log_State;

--
    procedure Log_State (Msg : String) is
------------------------------------------------------------------------------
-- Log a program state message using the local system conventions.  This
-- indicates that the program is about to enter some major stage of processing.
------------------------------------------------------------------------------
    begin

        Text_Io.Put ("::: ");
        Text_Io.Put_Line (Msg);

    end Log_State;

--
    procedure Log_Cont (Msg : E_String) is
    begin
        Log_Cont (To_String (Msg));
    end Log_Cont;

--
    procedure Log_Cont (Msg : String) is
------------------------------------------------------------------------------
-- Log an informational message using the local system conventions.  This
-- indicates that someting "interesting" is/has happening/ed.
------------------------------------------------------------------------------
    begin

        Text_Io.Put ("--- ");
        Text_Io.Put_Line (Msg);

    end Log_Cont;

--
end Error_Log;
