with Arithmetic;
use Arithmetic;
with Vstring_Type;
use Vstring_Type;

package body Vstring_Case is
------------------------------------------------------------------------------
-- VString Case Conversion Routines
------------------------------------------------------------------------------
-- Copyright 1988 - 1991 by Rational, Santa Clara, California.
--
--                  All Rights Reserved.
--
-- Permission to use, copy, modify, and distribute this software and its
-- documentation for any purpose and without fee is hereby granted,
-- provided that the above copyright notice(s) appear in all copies and that
-- both that copyright notice(s) and this permission notice appear in
-- supporting documentation, and that the name of Rational not be used in
-- advertising or publicity pertaining to distribution of the software
-- without specific, written prior permission.
--
-- Rational disclaims all warranties with regard to this software, including
-- all implied warranties of merchantability and fitness, in no event shall
-- Rational be liable for any special, indirect or consequential damages or
-- any damages whatsoever resulting from loss of use, data or profits, whether
-- in an action of contract, negligence or other tortious action, arising out
-- of or in connection with the use or performance of this software.
------------------------------------------------------------------------------

--
    procedure Upper_Case (Vstr : in out Vstring_Data) is
    begin
        for I in reverse 1 .. Vstr.Length loop
            Vstr.Chars (I) := Uc_Char (Vstr.Chars (I));
        end loop;
    end Upper_Case;

--
    procedure Upper_Case (Vstr : Vstring) is
    begin
        for I in reverse 1 .. Vstr.Length loop
            Vstr.Chars (I) := Uc_Char (Vstr.Chars (I));
        end loop;
    end Upper_Case;

--
    procedure Lower_Case (Vstr : in out Vstring_Data) is
    begin
        for I in reverse 1 .. Vstr.Length loop
            Vstr.Chars (I) := Lc_Char (Vstr.Chars (I));
        end loop;
    end Lower_Case;

--
    procedure Lower_Case (Vstr : Vstring) is
    begin
        for I in reverse 1 .. Vstr.Length loop
            Vstr.Chars (I) := Lc_Char (Vstr.Chars (I));
        end loop;
    end Lower_Case;

--
    function Upper_Case (Str : E_String) return E_String is
        Str2 : E_String (1 .. Str'Length);
    begin
        for I in reverse S_Natural range 0 .. Str2'Last - 1 loop
            Str2 (I + 1) := Uc_Char (Str (I + Str'First));
        end loop;
        return Str2;
    end Upper_Case;

--
    procedure Upper_Case (Str : in out E_String) is
    begin
        for I in reverse Str'Range loop
            Str (I) := Uc_Char (Str (I));
        end loop;
    end Upper_Case;

--
    function Lower_Case (Str : E_String) return E_String is
        Str2 : E_String (1 .. Str'Length);
    begin
        for I in reverse S_Natural range 0 .. Str2'Last - 1 loop
            Str2 (I + 1) := Lc_Char (Str (I + Str'First));
        end loop;
        return Str2;
    end Lower_Case;

--
    procedure Lower_Case (Str : in out E_String) is
    begin
        for I in reverse Str'Range loop
            Str (I) := Uc_Char (Str (I));
        end loop;
    end Lower_Case;

--
end Vstring_Case;
