with Vstring_Type;
use Vstring_Type;

package Vstring_Case is
------------------------------------------------------------------------------
-- VString Case Conversion Routines
------------------------------------------------------------------------------
-- Copyright 1988 - 1991 by Rational, Santa Clara, California.
--
--                  All Rights Reserved.
--
-- Permission to use, copy, modify, and distribute this software and its
-- documentation for any purpose and without fee is hereby granted,
-- provided that the above copyright notice(s) appear in all copies and that
-- both that copyright notice(s) and this permission notice appear in
-- supporting documentation, and that the name of Rational not be used in
-- advertising or publicity pertaining to distribution of the software
-- without specific, written prior permission.
--
-- Rational disclaims all warranties with regard to this software, including
-- all implied warranties of merchantability and fitness, in no event shall
-- Rational be liable for any special, indirect or consequential damages or
-- any damages whatsoever resulting from loss of use, data or profits, whether
-- in an action of contract, negligence or other tortious action, arising out
-- of or in connection with the use or performance of this software.
------------------------------------------------------------------------------

    type Character_Array is array (Character) of Character;

    Uc_Char : constant Character_Array :=
       Character_Array'(Ascii.Nul, Ascii.Soh, Ascii.Stx, Ascii.Etx, Ascii.Eot,
                        Ascii.Enq, Ascii.Ack, Ascii.Bel, Ascii.Bs, Ascii.Ht,
                        Ascii.Lf, Ascii.Vt, Ascii.Ff, Ascii.Cr, Ascii.So,
                        Ascii.Si, Ascii.Dle, Ascii.Dc1, Ascii.Dc2, Ascii.Dc3,
                        Ascii.Dc4, Ascii.Nak, Ascii.Syn, Ascii.Etb, Ascii.Can,
                        Ascii.Em, Ascii.Sub, Ascii.Esc, Ascii.Fs, Ascii.Gs,
                        Ascii.Rs, Ascii.Us, ' ', '!', '"', '#', '$', '%', '&',
                        ''', '(', ')', '*', '+', ',', '-', '.', '/', '0',
                        '1', '2', '3', '4', '5', '6', '7', '8', '9', ':',
                        ';', '<', '=', '>', '?', '@', 'A', 'B', 'C', 'D',
                        'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N',
                        'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X',
                        'Y', 'Z', '[', '\', ']', '^', '_', '`', 'A', 'B',
                        'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L',
                        'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V',
                        'W', 'X', 'Y', 'Z', '{', '|', '}', '~', Ascii.Del);

    Lc_Char : constant Character_Array :=
       Character_Array'(Ascii.Nul, Ascii.Soh, Ascii.Stx, Ascii.Etx, Ascii.Eot,
                        Ascii.Enq, Ascii.Ack, Ascii.Bel, Ascii.Bs, Ascii.Ht,
                        Ascii.Lf, Ascii.Vt, Ascii.Ff, Ascii.Cr, Ascii.So,
                        Ascii.Si, Ascii.Dle, Ascii.Dc1, Ascii.Dc2, Ascii.Dc3,
                        Ascii.Dc4, Ascii.Nak, Ascii.Syn, Ascii.Etb, Ascii.Can,
                        Ascii.Em, Ascii.Sub, Ascii.Esc, Ascii.Fs, Ascii.Gs,
                        Ascii.Rs, Ascii.Us, ' ', '!', '"', '#', '$', '%', '&',
                        ''', '(', ')', '*', '+', ',', '-', '.', '/', '0',
                        '1', '2', '3', '4', '5', '6', '7', '8', '9', ':',
                        ';', '<', '=', '>', '?', '@', 'a', 'b', 'c', 'd',
                        'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n',
                        'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x',
                        'y', 'z', '[', '\', ']', '^', '_', '`', 'a', 'b',
                        'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l',
                        'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v',
                        'w', 'x', 'y', 'z', '{', '|', '}', '~', Ascii.Del);


    procedure Upper_Case (Vstr : in out Vstring_Data);
    procedure Upper_Case (Vstr : Vstring);
    procedure Lower_Case (Vstr : in out Vstring_Data);
    procedure Lower_Case (Vstr : Vstring);
    ----Called to change all alphabeticals to upper/lower case within a string.

    function  Upper_Case (Str : E_String) return E_String;
    procedure Upper_Case (Str : in out E_String);
    function  Lower_Case (Str : E_String) return E_String;
    procedure Lower_Case (Str : in out E_String);
    ----Called to change all alphabeticals to upper/lower case within a string.

end Vstring_Case;
