with Arithmetic;
use Arithmetic;
with Vstring_Type;
use Vstring_Type;

package Vstring_Compare is
------------------------------------------------------------------------------
-- VString Comparison Routines
------------------------------------------------------------------------------
-- Copyright 1988 - 1991 by Rational, Santa Clara, California.
--
--                  All Rights Reserved.
--
-- Permission to use, copy, modify, and distribute this software and its
-- documentation for any purpose and without fee is hereby granted,
-- provided that the above copyright notice(s) appear in all copies and that
-- both that copyright notice(s) and this permission notice appear in
-- supporting documentation, and that the name of Rational not be used in
-- advertising or publicity pertaining to distribution of the software
-- without specific, written prior permission.
--
-- Rational disclaims all warranties with regard to this software, including
-- all implied warranties of merchantability and fitness, in no event shall
-- Rational be liable for any special, indirect or consequential damages or
-- any damages whatsoever resulting from loss of use, data or profits, whether
-- in an action of contract, negligence or other tortious action, arising out
-- of or in connection with the use or performance of this software.
------------------------------------------------------------------------------

    subtype Result_Type is S_Long range -127 .. 127;

    function Compare (Vstr1 : Vstring_Data;  
                      Vstr2 : Vstring_Data)                  return Result_Type;
    function Compare (Vstr1 : Vstring_Data; Vstr2 : Vstring) return Result_Type;
    function Compare (Vstr1 : Vstring; Vstr2 : Vstring_Data) return Result_Type;
    function Compare (Vstr1 : Vstring; Vstr2 : Vstring)      return Result_Type;
    ----Compare two Vstrings.  Return 0 if they are equal.  Return some
    --  positive value if Vstr1 > Vstr2.  Return some negative value if
    --  Vstr1 < Vstr2.
    --  Vstrings are compared 1 character at a time from the beginning until
    --  a character is found that does not match.  If one of the strings
    --  is shorter than the other, but equal as a prefix, then the shorter
    --  string is less than the larger string.  Two strings are equal if they
    --  contain the same characters and are the same length.

    function Compare (Vstr1 : Vstring_Data;  
                      Vstr2 : E_String)   return Result_Type;
    function Compare (Vstr1 : Vstring_Data;  
                      Vstr2 : Character)  return Result_Type;
    function Compare (Vstr1  : Vstring_Data;  
                      Vstr2  : Character;  
                      Copies : S_Natural) return Result_Type;
    function Compare (Vstr1 : Vstring;  
                      Vstr2 : E_String)   return Result_Type;
    function Compare (Vstr1 : Vstring;  
                      Vstr2 : Character)  return Result_Type;
    function Compare (Vstr1  : Vstring;  
                      Vstr2  : Character;  
                      Copies : S_Natural) return Result_Type;
    ----Compare a Vstring to a string/character/N-characters.

end Vstring_Compare;
