with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  
with Xlbt_Event;  
use Xlbt_Event;  
with Xlbt_String;  
use Xlbt_String;  

package Button is  
-----------------------------------------------------------------------------  
-- Dragon - a version of Mah-Jongg for X Windows  
--  
-- Author: Gary E. Barnes        March 1989  
--  
-- Button - Deals with the command buttons on the board  
------------------------------------------------------------------------------  
-- 05/30/90 GEB  - Translate to Ada  
------------------------------------------------------------------------------  

    Cheating : Boolean := False;  -- Are we in cheating mode right now?  

    procedure Cheat        (Event : X_Button_Press_Event);  
    procedure Game_Exit    (Event : X_Button_Press_Event);  
    procedure Other        (Event : X_Button_Press_Event);  
    procedure Redraw_All   (Event : X_Button_Press_Event);  
    procedure Save_Game    (Event : X_Button_Press_Event);  
    procedure Sides        (Event : X_Button_Press_Event);  
    procedure Sync_All     (Event : X_Button_Press_Event);  
    procedure Button_Expose;  
    procedure Button_Press (Event : X_Button_Press_Event);  

    procedure Do_Button_Configuration;  
------------------------------------------------------------------------------  
-- Called when the Board changes Tile sizes.  
------------------------------------------------------------------------------  


    procedure Draw_Score (Score : S_Long;  
                          Px    : S_Short;  
                          Py    : S_Short);  
------------------------------------------------------------------------------  
-- Called to draw the score at x/y.  
------------------------------------------------------------------------------  

    procedure Draw_Text (Str : X_String;  
                         Px  : S_Short;  
                         Py  : S_Short);  
------------------------------------------------------------------------------  
-- Called to draw the vector text in some button.  
------------------------------------------------------------------------------  

    procedure Button_Release (Event : X_Button_Release_Event);  

end Button;  

