with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  

package Tile is  
------------------------------------------------------------------------------  
-- Dragon - a version of Mah-Jongg for X Windows  
--  
-- Author: Gary E. Barnes        March 1989  
--  
-- tile.c - Deals with the individual Mah-Jongg tiles.  
------------------------------------------------------------------------------  
-- 05/30/90 GEB  - Translate to Ada  
------------------------------------------------------------------------------  

    procedure Configure_Tiles (Size : S_Long);  
------------------------------------------------------------------------------  
--   size        - Specifies the tile size to use; 1..5  
--  
-- Called when the Board receives a ConfigureNotify event.  We check to see if  
-- the size of the board/tiles have changed.  If so then we reconfigure the  
-- images of the tiles.  
------------------------------------------------------------------------------  

    procedure Draw_Spring  (X : S_Short; Y : S_Short);  
    procedure Draw_Summer  (X : S_Short; Y : S_Short);  
    procedure Draw_Fall    (X : S_Short; Y : S_Short);  
    procedure Draw_Winter  (X : S_Short; Y : S_Short);  
    procedure Draw_Bamboo  (X : S_Short; Y : S_Short);  
    procedure Draw_Mum     (X : S_Short; Y : S_Short);  
    procedure Draw_Orchid  (X : S_Short; Y : S_Short);  
    procedure Draw_Plum    (X : S_Short; Y : S_Short);  
    procedure Draw_Gdragon (X : S_Short; Y : S_Short);  
    procedure Draw_Rdragon (X : S_Short; Y : S_Short);  
    procedure Draw_Wdragon (X : S_Short; Y : S_Short);  
    procedure Draw_East    (X : S_Short; Y : S_Short);  
    procedure Draw_West    (X : S_Short; Y : S_Short);  
    procedure Draw_North   (X : S_Short; Y : S_Short);  
    procedure Draw_South   (X : S_Short; Y : S_Short);  
    procedure Draw_Bam1    (X : S_Short; Y : S_Short);  
    procedure Draw_Bam2    (X : S_Short; Y : S_Short);  
    procedure Draw_Bam3    (X : S_Short; Y : S_Short);  
    procedure Draw_Bam4    (X : S_Short; Y : S_Short);  
    procedure Draw_Bam5    (X : S_Short; Y : S_Short);  
    procedure Draw_Bam6    (X : S_Short; Y : S_Short);  
    procedure Draw_Bam7    (X : S_Short; Y : S_Short);  
    procedure Draw_Bam8    (X : S_Short; Y : S_Short);  
    procedure Draw_Bam9    (X : S_Short; Y : S_Short);  
    procedure Draw_Dot1    (X : S_Short; Y : S_Short);  
    procedure Draw_Dot2    (X : S_Short; Y : S_Short);  
    procedure Draw_Dot3    (X : S_Short; Y : S_Short);  
    procedure Draw_Dot4    (X : S_Short; Y : S_Short);  
    procedure Draw_Dot5    (X : S_Short; Y : S_Short);  
    procedure Draw_Dot6    (X : S_Short; Y : S_Short);  
    procedure Draw_Dot7    (X : S_Short; Y : S_Short);  
    procedure Draw_Dot8    (X : S_Short; Y : S_Short);  
    procedure Draw_Dot9    (X : S_Short; Y : S_Short);  
    procedure Draw_Crak1   (X : S_Short; Y : S_Short);  
    procedure Draw_Crak2   (X : S_Short; Y : S_Short);  
    procedure Draw_Crak3   (X : S_Short; Y : S_Short);  
    procedure Draw_Crak4   (X : S_Short; Y : S_Short);  
    procedure Draw_Crak5   (X : S_Short; Y : S_Short);  
    procedure Draw_Crak6   (X : S_Short; Y : S_Short);  
    procedure Draw_Crak7   (X : S_Short; Y : S_Short);  
    procedure Draw_Crak8   (X : S_Short; Y : S_Short);  
    procedure Draw_Crak9   (X : S_Short; Y : S_Short);  

end Tile;  

