with Ico_Polyinfo;  
use Ico_Polyinfo;  

with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  
with Xlbt_String7;  
use Xlbt_String7;  

package Ico_Objtetra is  
------------------------------------------------------------------------------  
-- Derived from: objtetra.h - structure values for tetrahedron  
------------------------------------------------------------------------------  
--/* $Header: ico.c,v 1.4 88/02/09 13:15:08 jim Exp $ */  
--/***********************************************************  
-- Copyright 1987 by Digital Equipment Corporation, Maynard, Massachusetts,  
-- and the Massachusetts Institute of Technology, Cambridge, Massachusetts.  
--  
--                         All Rights Reserved  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice appear in all copies and that  
-- both that copyright notice and this permission notice appear in  
-- supporting documentation, and that the names of Digital or MIT not be  
-- used in advertising or publicity pertaining to distribution of the  
-- software without specific, written prior permission.  
--  
-- DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING  
-- ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL  
-- DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR  
-- ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,  
-- WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,  
-- ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS  
-- SOFTWARE.  
------------------------------------------------------------------------------  

    T : constant := 1.0;  

    Obj_Tetra : constant Poly_Info :=  
       (Long_Name  => new String'("tetrahedron"),  
        Short_Name => new String'("tetra"),  
        Dual       => new String'("cube"),  
        Num_Verts  => 6,  
        Num_Edges  => 12,  
        Num_Faces  => 8,  
        V          =>  
           new Point_3d_Array'  
                  ( -- vertices (x,y,z)  
                    -- all points must be within radius 1 of the origin  
                   (T, 0.0, 0.0), (-T, 0.0, 0.0), (0.0, T, 0.0),  
                   (0.0, -T, 0.0), (0.0, 0.0, T), (0.0, 0.0, -T)),  
        F          =>  
           new S_Natural_Array'  
                  ( -- faces (numfaces + indexes into vertices)  
                    -- faces must be specified clockwise from the outside  
                   3, 0, 4, 2, 3, 0, 2, 5, 3, 0, 5, 3, 3, 0, 3, 4,  
                   3, 1, 2, 4, 3, 1, 5, 2, 3, 1, 3, 5, 3, 1, 4, 3));  
end Ico_Objtetra;  

