with Xlbt_Event3;  
use Xlbt_Event3;  

with Xlbmp_Generic_Converters;  
use Xlbmp_Generic_Converters;  

package Xlbip_Event_Converters is  
------------------------------------------------------------------------------  
-- X Library Internal X_Event/X_Raw_Data Conversions  
--  
-- Xlbip_Event_Converters - Conversions to/from system data types.  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the name of Rational not be used in  
-- advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- Rational disclaims all warranties with regard to this software, including  
-- all implied warranties of merchantability and fitness, in no event shall  
-- Rational be liable for any special, indirect or consequential damages or  
-- any damages whatsoever resulting from loss of use, data or profits, whether  
-- in an action of contract, negligence or other tortious action, arising out  
-- of or in connection with the use or performance of this software.  
------------------------------------------------------------------------------  

--
    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Button_Event);  
    procedure To_Raw   is  
       new Convert_Private_To_Raw (X_Button_Event);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Circulate_Notify_Event);  
    procedure To_Raw   is  
       new Convert_Private_To_Raw (X_Circulate_Notify_Event);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Circulate_Request_Event);  
    procedure To_Raw   is  
       new Convert_Private_To_Raw (X_Circulate_Request_Event);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Client_Message_Event);  
    procedure To_Raw   is  
       new Convert_Private_To_Raw (X_Client_Message_Event);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Colormap_Notify_Event);  
    procedure To_Raw   is  
       new Convert_Private_To_Raw (X_Colormap_Notify_Event);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Configure_Notify_Event);  
    procedure To_Raw   is  
       new Convert_Private_To_Raw (X_Configure_Notify_Event);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Configure_Request_Event);  
    procedure To_Raw   is  
       new Convert_Private_To_Raw (X_Configure_Request_Event);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Create_Notify_Event);  
    procedure To_Raw   is  
       new Convert_Private_To_Raw (X_Create_Notify_Event);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Destroy_Notify_Event);  
    procedure To_Raw   is  
       new Convert_Private_To_Raw (X_Destroy_Notify_Event);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Enter_Leave_Event);  
    procedure To_Raw   is  
       new Convert_Private_To_Raw (X_Enter_Leave_Event);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Expose_Event);  
    procedure To_Raw   is  
       new Convert_Private_To_Raw (X_Expose_Event);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Focus_Event);  
    procedure To_Raw   is  
       new Convert_Private_To_Raw (X_Focus_Event);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Graphics_Expose_Event);  
    procedure To_Raw   is  
       new Convert_Private_To_Raw (X_Graphics_Expose_Event);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Gravity_Notify_Event);  
    procedure To_Raw   is  
       new Convert_Private_To_Raw (X_Gravity_Notify_Event);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Keymap_Notify_Event);  
    procedure To_Raw   is  
       new Convert_Private_To_Raw (X_Keymap_Notify_Event);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Key_Event);  
    procedure To_Raw   is  
       new Convert_Private_To_Raw (X_Key_Event);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Mapping_Notify_Event);  
    procedure To_Raw   is  
       new Convert_Private_To_Raw (X_Mapping_Notify_Event);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Map_Notify_Event);  
    procedure To_Raw   is  
       new Convert_Private_To_Raw (X_Map_Notify_Event);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Map_Request_Event);  
    procedure To_Raw   is  
       new Convert_Private_To_Raw (X_Map_Request_Event);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Motion_Notify_Event);  
    procedure To_Raw   is  
       new Convert_Private_To_Raw (X_Motion_Notify_Event);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_No_Expose_Event);  
    procedure To_Raw   is  
       new Convert_Private_To_Raw (X_No_Expose_Event);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Property_Notify_Event);  
    procedure To_Raw   is  
       new Convert_Private_To_Raw (X_Property_Notify_Event);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Reparent_Notify_Event);  
    procedure To_Raw   is  
       new Convert_Private_To_Raw (X_Reparent_Notify_Event);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Resize_Request_Event);  
    procedure To_Raw   is  
       new Convert_Private_To_Raw (X_Resize_Request_Event);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Selection_Clear_Event);  
    procedure To_Raw   is  
       new Convert_Private_To_Raw (X_Selection_Clear_Event);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Selection_Notify_Event);  
    procedure To_Raw   is  
       new Convert_Private_To_Raw (X_Selection_Notify_Event);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Selection_Request_Event);  
    procedure To_Raw   is  
       new Convert_Private_To_Raw (X_Selection_Request_Event);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Unmap_Notify_Event);  
    procedure To_Raw   is  
       new Convert_Private_To_Raw (X_Unmap_Notify_Event);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Visibility_Notify_Event);  
    procedure To_Raw   is  
       new Convert_Private_To_Raw (X_Visibility_Notify_Event);  

end Xlbip_Event_Converters;  

