with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  
with Xlbt_Basic;  
use Xlbt_Basic;  
with Xlbt_Font;  
use Xlbt_Font;  
with Xlbt_Font2;  
use Xlbt_Font2;  
with Xlbt_Key;  
use Xlbt_Key;  
with Xlbt_Key2;  
use Xlbt_Key2;  
with Xlbt_Pointer;  
use Xlbt_Pointer;  
with Xlbt_Reply;  
use Xlbt_Reply;  
with Xlbt_Request;  
use Xlbt_Request;  
with Xlbt_String;  
use Xlbt_String;  
with Xlbt_String16;  
use Xlbt_String16;  

with Xlbmt_Network_Types;  
use Xlbmt_Network_Types;  

with Xlbip_Base_Converters;  
use Xlbip_Base_Converters;  
with Xlbip_Wire_Converters;  
use Xlbip_Wire_Converters;  
with Xlbip_Reply_Converters;  
use Xlbip_Reply_Converters;  

with Xlbmp_Get;  
use Xlbmp_Get;  

pragma Elaborate (Xlbmp_Get);  

package Xlbip_Get_Reply is  
------------------------------------------------------------------------------  
-- X Library Internal Network I/O Get-Reply Routines  
--  
-- Xlbip_Get_Reply - Receive a specific type of reply from an input buffer  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the name of Rational not be used in  
-- advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- Rational disclaims all warranties with regard to this software, including  
-- all implied warranties of merchantability and fitness, in no event shall  
-- Rational be liable for any special, indirect or consequential damages or  
-- any damages whatsoever resulting from loss of use, data or profits, whether  
-- in an action of contract, negligence or other tortious action, arising out  
-- of or in connection with the use or performance of this software.  
------------------------------------------------------------------------------  

--
    -- procedure Get_String is  
    --    new Get_Small_Data_1d (Character,  
    --                           Positive,  
    --                           String,  
    --                           From_Raw,  
    --                           Original_Size => 1);  

    procedure Get_X_String is  
       new Get_Small_Data_1d (X_Character,  
                              S_Natural,  
                              X_String,  
                              From_Raw);  

    procedure Get_U_Char_Array is  
       new Get_Small_Data_1d (U_Char,  
                              S_Natural,  
                              U_Char_Array,  
                              From_Raw);  


    procedure Get_X_Atom_Array is  
       new Get_Large_Data_1d (X_Atom,  
                              S_Natural,  
                              X_Atom_Array,  
                              From_Raw);  

--/ if not TeleGen2_2d_Bug then  
  
    procedure Get_X_Char_Struct_Array_2d is  
       new Get_Data_2d (X_Char_Struct,  
                        U_Char,  
                        U_Char,  
                        X_Char_Struct_Array_2d,  
                        From_Raw,  
                        From_Raw);  
  
--/ else  
 
    procedure Get_X_Char_Struct_Array_2d is  
       new Get_Data_2d (X_Char_Struct,  
                        Telegen2_2d_Bug,  
                        U_Char,  
                        X_Char_Struct_Array_2d,  
                        From_Raw,  
                        From_Raw);  
 
--/ end if;  


    procedure Get_X_Colormap_Array is  
       new Get_Large_Data_1d (X_Colormap,  
                              S_Natural,  
                              X_Colormap_Array,  
                              From_Raw);  

    procedure Get_X_Font_Prop_Array is  
       new Get_Large_Data_1d (X_Font_Prop,  
                              S_Natural,  
                              X_Font_Prop_Array,  
                              From_Raw);  


    procedure Get_X_Key_Code_Array is  
       new Get_Small_Data_1d (X_Key_Code,  
                              S_Natural,  
                              X_Key_Code_Array,  
                              From_Raw);  


--/ if not TeleGen2_2d_Bug then  
  
    procedure Get_X_Key_Sym_Array_2d is  
       new Get_Data_2d (X_Key_Sym,  
                        X_Key_Code,  
                        U_Char,  
                        X_Key_Sym_Array_2d,  
                        From_Raw,  
                        From_Raw);  
  
--/ else  
 
    procedure Get_X_Key_Sym_Array_2d is  
       new Get_Data_2d (X_Key_Sym,  
                        Telegen2_2d_Bug,  
                        U_Char,  
                        X_Key_Sym_Array_2d,  
                        From_Raw,  
                        From_Raw);  
 
--/ end if;  
    procedure Get_X_Modifier_Key_Code_Array is  
       new Get_Large_Data_1d (X_Modifier_Key_Code_Sub_Array,  
                              S_Natural,  
                              X_Modifier_Key_Code_Array,  
                              From_Raw);  

    procedure Get_X_Pixel_Array is  
       new Get_Large_Data_1d (X_Pixel,  
                              S_Natural,  
                              X_Pixel_Array,  
                              From_Raw);  

    procedure Get_X_Plane_Mask_Array is  
       new Get_Large_Data_1d (X_Plane_Mask,  
                              S_Natural,  
                              X_Plane_Mask_Array,  
                              From_Raw);  

    procedure Get_X_Rgb is  
       new Get_Data_Private (X_Rgb,  
                             From_Raw);  

    procedure Get_X_Rgb_Array is  
       new Get_Large_Data_1d (X_Rgb,  
                              S_Natural,  
                              X_Rgb_Array,  
                              From_Raw);  

    procedure Get_X_Time_Coord_Array is  
       new Get_Large_Data_1d (X_Time_Coord,  
                              S_Natural,  
                              X_Time_Coord_Array,  
                              From_Raw);  

    procedure Get_X_Window_Array is  
       new Get_Large_Data_1d (X_Window,  
                              S_Natural,  
                              X_Window_Array,  
                              From_Raw);  

    procedure Get_X_Wire_Host_Reply is  
       new Get_Data_Private (X_Wire_Host_Reply,  
                             From_Raw);  

--
    procedure Get_Reply is  
       new Get_Reply_Generic (X_Reply_Contents,  
                              Internal_Wire_To_Reply);  
------------------------------------------------------------------------------  
-- procedure Get_Reply (Display :     X_Display;  
--                      Code    :     X_Request_Code;  
--                      Reply   : out X_Reply_Contents;  
--                      Extra   :     S_Natural;  
--                      Discard :     Boolean;  
--                      Status  : out X_Status);  
--  
-- Read something out of the network connection.  You should only request  
-- multiples of 4 bytes.  
--  Display     - the display to read from  
--  Code        - the code for the request indicates the format of the reply  
--  Reply       - where to put the reply; if one is received  
--  Extra       - many replies receive extra data; we require at least this  
--                much extra to be present or we regard it as an I/O error  
--  Discard     - True to discard any extra extra data that may appear with the  
--                reply  
--  Status      - Failed if we got an Error instead of a Reply  
------------------------------------------------------------------------------  

    procedure Eat_Raw_Data (Display : X_Display;  
                            Amount  : S_Natural) renames Xlbmp_Get.Eat_Data_Raw;  
------------------------------------------------------------------------------  
-- Read and discard some data from the network connection.  Typically only  
-- called when we are trying to recover from some error, e.g. a Storage_Error  
-- exception, and we need to get rid of junk in the protocol stream that  
-- we requested but which we cannot allocate heap space to hold.  
-- We read and discard Amount X_Raw_Data items.  
------------------------------------------------------------------------------  

end Xlbip_Get_Reply;  

