with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  
with Xlbt_Basic;  
use Xlbt_Basic;  
with Xlbt_Graphics;  
use Xlbt_Graphics;  
with Xlbt_Key;  
use Xlbt_Key;  
with Xlbt_Key2;  
use Xlbt_Key2;  
with Xlbt_Keyboard;  
use Xlbt_Keyboard;  
with Xlbt_Misc;  
use Xlbt_Misc;  
with Xlbt_Request;  
use Xlbt_Request;  
with Xlbt_String;  
use Xlbt_String;  
with Xlbt_String16;  
use Xlbt_String16;  

with Xlbmt_Network_Types;  
use Xlbmt_Network_Types;  

with Xlbip_Base_Converters;  
use Xlbip_Base_Converters;  
with Xlbip_Graphic_Converters;  
use Xlbip_Graphic_Converters;  
with Xlbip_Request_Converters;  
use Xlbip_Request_Converters;  

with Xlbmp_Put;  
use Xlbmp_Put;  

pragma Elaborate (Xlbmp_Put);  

package Xlbip_Put_Request is  
------------------------------------------------------------------------------  
-- X Library Internal Network I/O Put-Request Routines  
--  
-- Xlbip_Put_Request - Place a specific type of request into an output buffer  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the name of Rational not be used in  
-- advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- Rational disclaims all warranties with regard to this software, including  
-- all implied warranties of merchantability and fitness, in no event shall  
-- Rational be liable for any special, indirect or consequential damages or  
-- any damages whatsoever resulting from loss of use, data or profits, whether  
-- in an action of contract, negligence or other tortious action, arising out  
-- of or in connection with the use or performance of this software.  
------------------------------------------------------------------------------  
--
    procedure Put_X_Alloc_Color_Request is  
       new Put_Request (X_Alloc_Color_Request,  
                        To_Raw);  

    procedure Put_X_Alloc_Color_Cells_Request is  
       new Put_Request (X_Alloc_Color_Cells_Request,  
                        To_Raw);  

    procedure Put_X_Alloc_Color_Planes_Request is  
       new Put_Request (X_Alloc_Color_Planes_Request,  
                        To_Raw);  

    procedure Put_X_Alloc_Named_Color_Request is  
       new Put_Request_Extra (X_Alloc_Named_Color_Request,  
                              To_Raw);  

    procedure Put_X_Allow_Events_Request is  
       new Put_Request (X_Allow_Events_Request,  
                        To_Raw);  

    procedure Put_X_Bell_Request is  
       new Put_Request (X_Bell_Request,  
                        To_Raw);  

    procedure Put_X_Change_Active_Pointer_Grab_Request is  
       new Put_Request (X_Change_Active_Pointer_Grab_Request,  
                        To_Raw);  

    procedure Put_X_Change_Gc_Request is  
       new Put_Request_Extra (X_Change_Gc_Request,  
                              To_Raw);  

    procedure Put_X_Change_Hosts_Request is  
       new Put_Request_Extra (X_Change_Hosts_Request,  
                              To_Raw);  

    procedure Put_X_Change_Keyboard_Control_Request is  
       new Put_Request_Extra (X_Change_Keyboard_Control_Request,  
                              To_Raw);  

    procedure Put_X_Change_Keyboard_Mapping_Request is  
       new Put_Request_Extra (X_Change_Keyboard_Mapping_Request,  
                              To_Raw);  

    procedure Put_X_Change_Pointer_Control_Request is  
       new Put_Request (X_Change_Pointer_Control_Request,  
                        To_Raw);  

    procedure Put_X_Change_Property_Request is  
       new Put_Request_Extra (X_Change_Property_Request,  
                              To_Raw);  

    procedure Put_X_Change_Save_Set_Request is  
       new Put_Request (X_Change_Save_Set_Request,  
                        To_Raw);  

    procedure Put_X_Change_Window_Attributes_Request is  
       new Put_Request_Extra (X_Change_Window_Attributes_Request,  
                              To_Raw);  

    procedure Put_X_Circulate_Window_Request is  
       new Put_Request (X_Circulate_Window_Request,  
                        To_Raw);  

    procedure Put_X_Clear_Area_Request is  
       new Put_Request (X_Clear_Area_Request,  
                        To_Raw);  

    procedure Put_X_Close_Font_Request is  
       new Put_Request (X_Close_Font_Request,  
                        To_Raw);  

    procedure Put_X_Configure_Window_Request is  
       new Put_Request_Extra (X_Configure_Window_Request,  
                              To_Raw);  

    procedure Put_X_Convert_Selection_Request is  
       new Put_Request (X_Convert_Selection_Request,  
                        To_Raw);  

    procedure Put_X_Copy_Area_Request is  
       new Put_Request (X_Copy_Area_Request,  
                        To_Raw);  

    procedure Put_X_Copy_Colormap_And_Free_Request is  
       new Put_Request (X_Copy_Colormap_And_Free_Request,  
                        To_Raw);  

    procedure Put_X_Copy_Gc_Request is  
       new Put_Request (X_Copy_Gc_Request,  
                        To_Raw);  

    procedure Put_X_Copy_Plane_Request is  
       new Put_Request (X_Copy_Plane_Request,  
                        To_Raw);  

    procedure Put_X_Create_Colormap_Request is  
       new Put_Request (X_Create_Colormap_Request,  
                        To_Raw);  

    procedure Put_X_Create_Cursor_Request is  
       new Put_Request (X_Create_Cursor_Request,  
                        To_Raw);  

    procedure Put_X_Create_Gc_Request is  
       new Put_Request_Extra (X_Create_Gc_Request,  
                              To_Raw);  

    procedure Put_X_Create_Glyph_Cursor_Request is  
       new Put_Request (X_Create_Glyph_Cursor_Request,  
                        To_Raw);  

    procedure Put_X_Create_Pixmap_Request is  
       new Put_Request (X_Create_Pixmap_Request,  
                        To_Raw);  

    procedure Put_X_Create_Window_Request is  
       new Put_Request_Extra (X_Create_Window_Request,  
                              To_Raw);  

    procedure Put_X_Delete_Property_Request is  
       new Put_Request (X_Delete_Property_Request,  
                        To_Raw);  

    procedure Put_X_Destroy_Subwindows_Request is  
       new Put_Request (X_Destroy_Subwindows_Request,  
                        To_Raw);  

    procedure Put_X_Destroy_Window_Request is  
       new Put_Request (X_Destroy_Window_Request,  
                        To_Raw);  

    procedure Put_X_Fill_Poly_Request is  
       new Put_Request_Extra (X_Fill_Poly_Request,  
                              To_Raw);  

    procedure Put_X_Fill_Poly_Request is  
       new Place_Reserved_Request (X_Fill_Poly_Request,  
                                   To_Raw);  

    procedure Reserve_X_Fill_Poly_Request is  
       new Reserve_Request_Large_1d (X_Fill_Poly_Request,  
                                     X_Point,  
                                     S_Natural,  
                                     X_Point_Array,  
                                     To_Raw,  
                                     To_Raw);  

    procedure Put_X_Force_Screen_Saver_Request is  
       new Put_Request (X_Force_Screen_Saver_Request,  
                        To_Raw);  

    procedure Put_X_Free_Colormap_Request is  
       new Put_Request (X_Free_Colormap_Request,  
                        To_Raw);  

    procedure Put_X_Free_Colors_Request is  
       new Put_Request_Extra (X_Free_Colors_Request,  
                              To_Raw);  

    procedure Put_X_Free_Cursor_Request is  
       new Put_Request (X_Free_Cursor_Request,  
                        To_Raw);  

    procedure Put_X_Free_Gc_Request is  
       new Put_Request (X_Free_Gc_Request,  
                        To_Raw);  

    procedure Put_X_Free_Pixmap_Request is  
       new Put_Request (X_Free_Pixmap_Request,  
                        To_Raw);  

    procedure Put_X_Get_Atom_Name_Request is  
       new Put_Request (X_Get_Atom_Name_Request,  
                        To_Raw);  

    procedure Put_X_Get_Font_Path_Request is  
       new Put_Request (X_Get_Font_Path_Request,  
                        To_Raw);  

    procedure Put_X_Get_Geometry_Request is  
       new Put_Request (X_Get_Geometry_Request,  
                        To_Raw);  

    procedure Put_X_Get_Image_Request is  
       new Put_Request (X_Get_Image_Request,  
                        To_Raw);  

    procedure Put_X_Get_Input_Focus_Request is  
       new Put_Request (X_Get_Input_Focus_Request,  
                        To_Raw);  

    procedure Put_X_Get_Keyboard_Control_Request is  
       new Put_Request (X_Get_Keyboard_Control_Request,  
                        To_Raw);  

    procedure Put_X_Get_Keyboard_Mapping_Request is  
       new Put_Request (X_Get_Keyboard_Mapping_Request,  
                        To_Raw);  

    procedure Put_X_Get_Modifier_Mapping_Request is  
       new Put_Request (X_Get_Modifier_Mapping_Request,  
                        To_Raw);  

    procedure Put_X_Get_Motion_Events_Request is  
       new Put_Request (X_Get_Motion_Events_Request,  
                        To_Raw);  

    procedure Put_X_Get_Pointer_Control_Request is  
       new Put_Request (X_Get_Pointer_Control_Request,  
                        To_Raw);  

    procedure Put_X_Get_Pointer_Mapping_Request is  
       new Put_Request (X_Get_Pointer_Mapping_Request,  
                        To_Raw);  

    procedure Put_X_Get_Property_Request is  
       new Put_Request (X_Get_Property_Request,  
                        To_Raw);  

    procedure Put_X_Get_Screen_Saver_Request is  
       new Put_Request (X_Get_Screen_Saver_Request,  
                        To_Raw);  

    procedure Put_X_Get_Selection_Owner_Request is  
       new Put_Request (X_Get_Selection_Owner_Request,  
                        To_Raw);  

    procedure Put_X_Get_Window_Attributes_Request is  
       new Put_Request (X_Get_Window_Attributes_Request,  
                        To_Raw);  

    procedure Put_X_Grab_Button_Request is  
       new Put_Request (X_Grab_Button_Request,  
                        To_Raw);  

    procedure Put_X_Grab_Key_Request is  
       new Put_Request (X_Grab_Key_Request,  
                        To_Raw);  

    procedure Put_X_Grab_Keyboard_Request is  
       new Put_Request (X_Grab_Keyboard_Request,  
                        To_Raw);  

    procedure Put_X_Grab_Pointer_Request is  
       new Put_Request (X_Grab_Pointer_Request,  
                        To_Raw);  

    procedure Put_X_Grab_Server_Request is  
       new Put_Request (X_Grab_Server_Request,  
                        To_Raw);  

    procedure Put_X_Image_Text16_Request is  
       new Put_Request_Extra (X_Image_Text16_Request,  
                              To_Raw);  

    procedure Put_X_Image_Text8_Request is  
       new Put_Request_Extra (X_Image_Text8_Request,  
                              To_Raw);  

    procedure Put_X_Install_Colormap_Request is  
       new Put_Request (X_Install_Colormap_Request,  
                        To_Raw);  

    procedure Put_X_Intern_Atom_Request is  
       new Put_Request_Extra (X_Intern_Atom_Request,  
                              To_Raw);  

    procedure Put_X_Kill_Client_Request is  
       new Put_Request (X_Kill_Client_Request,  
                        To_Raw);  

    procedure Put_X_List_Extensions_Request is  
       new Put_Request (X_List_Extensions_Request,  
                        To_Raw);  

    procedure Put_X_List_Fonts_Request is  
       new Put_Request_Extra (X_List_Fonts_Request,  
                              To_Raw);  

    procedure Put_X_List_Fonts_With_Info_Request is  
       new Put_Request_Extra (X_List_Fonts_With_Info_Request,  
                              To_Raw);  

    procedure Put_X_List_Hosts_Request is  
       new Put_Request (X_List_Hosts_Request,  
                        To_Raw);  

    procedure Put_X_List_Installed_Colormaps_Request is  
       new Put_Request (X_List_Installed_Colormaps_Request,  
                        To_Raw);  

    procedure Put_X_List_Properties_Request is  
       new Put_Request (X_List_Properties_Request,  
                        To_Raw);  

    procedure Put_X_Lookup_Color_Request is  
       new Put_Request_Extra (X_Lookup_Color_Request,  
                              To_Raw);  

    procedure Put_X_Map_Subwindows_Request is  
       new Put_Request (X_Map_Subwindows_Request,  
                        To_Raw);  

    procedure Put_X_Map_Window_Request is  
       new Put_Request (X_Map_Window_Request,  
                        To_Raw);  

    procedure Put_X_No_Operation_Request is  
       new Put_Request (X_No_Operation_Request,  
                        To_Raw);  

    procedure Put_X_Open_Font_Request is  
       new Put_Request_Extra (X_Open_Font_Request,  
                              To_Raw);  

    procedure Put_X_Poly_Arc_Request is  
       new Put_Request_Extra (X_Poly_Arc_Request,  
                              To_Raw);  

    procedure Put_X_Poly_Fill_Arc_Request is  
       new Put_Request_Extra (X_Poly_Fill_Arc_Request,  
                              To_Raw);  

    procedure Put_X_Poly_Fill_Arc_Request is  
       new Place_Reserved_Request (X_Poly_Fill_Arc_Request,  
                                   To_Raw);  

    procedure Reserve_X_Poly_Fill_Arc_Request is  
       new Reserve_Request_Large_1d (X_Poly_Fill_Arc_Request,  
                                     X_Arc,  
                                     S_Natural,  
                                     X_Arc_Array,  
                                     To_Raw,  
                                     To_Raw);  

    procedure Put_X_Poly_Fill_Rectangle_Request is  
       new Put_Request_Extra (X_Poly_Fill_Rectangle_Request,  
                              To_Raw);  

    procedure Put_X_Poly_Fill_Rectangle_Request is  
       new Place_Reserved_Request (X_Poly_Fill_Rectangle_Request,  
                                   To_Raw);  

    procedure Reserve_X_Poly_Fill_Rectangle_Request is  
       new Reserve_Request_Large_1d (X_Poly_Fill_Rectangle_Request,  
                                     X_Rectangle,  
                                     S_Natural,  
                                     X_Rectangle_Array,  
                                     To_Raw,  
                                     To_Raw);  

    procedure Put_X_Poly_Line_Request is  
       new Put_Request_Extra (X_Poly_Line_Request,  
                              To_Raw);  

    procedure Put_X_Poly_Line_Request is  
       new Place_Reserved_Request (X_Poly_Line_Request,  
                                   To_Raw);  

    procedure Reserve_X_Poly_Line_Request is  
       new Reserve_Request_Large_1d (X_Poly_Line_Request,  
                                     X_Point,  
                                     S_Natural,  
                                     X_Point_Array,  
                                     To_Raw,  
                                     To_Raw);  

    procedure Put_X_Poly_Point_Request is  
       new Put_Request_Extra (X_Poly_Point_Request,  
                              To_Raw);  

    procedure Put_X_Poly_Point_Request is  
       new Place_Reserved_Request (X_Poly_Point_Request,  
                                   To_Raw);  

    procedure Reserve_X_Poly_Point_Request is  
       new Reserve_Request_Large_1d (X_Poly_Point_Request,  
                                     X_Point,  
                                     S_Natural,  
                                     X_Point_Array,  
                                     To_Raw,  
                                     To_Raw);  

    procedure Put_X_Poly_Rectangle_Request is  
       new Put_Request_Extra (X_Poly_Rectangle_Request,  
                              To_Raw);  

    procedure Put_X_Poly_Rectangle_Request is  
       new Place_Reserved_Request (X_Poly_Rectangle_Request,  
                                   To_Raw);  

    procedure Reserve_X_Poly_Rectangle_Request is  
       new Reserve_Request_Large_1d (X_Poly_Rectangle_Request,  
                                     X_Rectangle,  
                                     S_Natural,  
                                     X_Rectangle_Array,  
                                     To_Raw,  
                                     To_Raw);  

    procedure Put_X_Poly_Segment_Request is  
       new Put_Request_Extra (X_Poly_Segment_Request,  
                              To_Raw);  

    procedure Put_X_Poly_Segment_Request is  
       new Place_Reserved_Request (X_Poly_Segment_Request,  
                                   To_Raw);  

    procedure Reserve_X_Poly_Segment_Request is  
       new Reserve_Request_Large_1d (X_Poly_Segment_Request,  
                                     X_Segment,  
                                     S_Natural,  
                                     X_Segment_Array,  
                                     To_Raw,  
                                     To_Raw);  

    procedure Put_X_Poly_Text16_Request is  
       new Put_Request_Extra (X_Poly_Text16_Request,  
                              To_Raw);  

    procedure Put_X_Poly_Text8_Request is  
       new Put_Request_Extra (X_Poly_Text8_Request,  
                              To_Raw);  

    procedure Put_X_Put_Image_Request is  
       new Put_Request_Extra (X_Put_Image_Request,  
                              To_Raw);  

    procedure Put_X_Query_Best_Size_Request is  
       new Put_Request (X_Query_Best_Size_Request,  
                        To_Raw);  

    procedure Put_X_Query_Colors_Request is  
       new Put_Request_Extra (X_Query_Colors_Request,  
                              To_Raw);  

    procedure Put_X_Query_Extension_Request is  
       new Put_Request_Extra (X_Query_Extension_Request,  
                              To_Raw);  

    procedure Put_X_Query_Font_Request is  
       new Put_Request (X_Query_Font_Request,  
                        To_Raw);  

    procedure Put_X_Query_Keymap_Request is  
       new Put_Request (X_Query_Keymap_Request,  
                        To_Raw);  

    procedure Put_X_Query_Pointer_Request is  
       new Put_Request (X_Query_Pointer_Request,  
                        To_Raw);  

    procedure Put_X_Query_Text_Extents_Request is  
       new Put_Request (X_Query_Text_Extents_Request,  
                        To_Raw);  

    procedure Put_X_Query_Tree_Request is  
       new Put_Request (X_Query_Tree_Request,  
                        To_Raw);  

    procedure Put_X_Recolor_Cursor_Request is  
       new Put_Request (X_Recolor_Cursor_Request,  
                        To_Raw);  

    procedure Put_X_Reparent_Window_Request is  
       new Put_Request (X_Reparent_Window_Request,  
                        To_Raw);  

    procedure Put_X_Rotate_Properties_Request is  
       new Put_Request (X_Rotate_Properties_Request,  
                        To_Raw);  

    procedure Put_X_Send_Event_Request is  
       new Put_Request (X_Send_Event_Request,  
                        To_Raw);  

    procedure Put_X_Set_Access_Control_Request is  
       new Put_Request (X_Set_Access_Control_Request,  
                        To_Raw);  

    procedure Put_X_Set_Clip_Rectangles_Request is  
       new Put_Request (X_Set_Clip_Rectangles_Request,  
                        To_Raw);  

    procedure Put_X_Set_Close_Down_Mode_Request is  
       new Put_Request (X_Set_Close_Down_Mode_Request,  
                        To_Raw);  

    procedure Put_X_Set_Dashes_Request is  
       new Put_Request_Extra (X_Set_Dashes_Request,  
                              To_Raw);  

    procedure Put_X_Set_Font_Path_Request is  
       new Put_Request_Extra (X_Set_Font_Path_Request,  
                              To_Raw);  

    procedure Put_X_Set_Input_Focus_Request is  
       new Put_Request (X_Set_Input_Focus_Request,  
                        To_Raw);  

    procedure Put_X_Set_Modifier_Mapping_Request is  
       new Put_Request_Extra (X_Set_Modifier_Mapping_Request,  
                              To_Raw);  

    procedure Put_X_Set_Pointer_Mapping_Request is  
       new Put_Request_Extra (X_Set_Pointer_Mapping_Request,  
                              To_Raw);  

    procedure Put_X_Set_Screen_Saver_Request is  
       new Put_Request (X_Set_Screen_Saver_Request,  
                        To_Raw);  

    procedure Put_X_Set_Selection_Owner_Request is  
       new Put_Request (X_Set_Selection_Owner_Request,  
                        To_Raw);  

    procedure Put_X_Store_Colors_Request is  
       new Put_Request_Extra (X_Store_Colors_Request,  
                              To_Raw);  

    procedure Put_X_Store_Named_Color_Request is  
       new Put_Request_Extra (X_Store_Named_Color_Request,  
                              To_Raw);  

    procedure Put_X_Translate_Coords_Request is  
       new Put_Request (X_Translate_Coords_Request,  
                        To_Raw);  

    procedure Put_X_Ungrab_Button_Request is  
       new Put_Request (X_Ungrab_Button_Request,  
                        To_Raw);  

    procedure Put_X_Ungrab_Key_Request is  
       new Put_Request (X_Ungrab_Key_Request,  
                        To_Raw);  

    procedure Put_X_Ungrab_Keyboard_Request is  
       new Put_Request (X_Ungrab_Keyboard_Request,  
                        To_Raw);  

    procedure Put_X_Ungrab_Pointer_Request is  
       new Put_Request (X_Ungrab_Pointer_Request,  
                        To_Raw);  

    procedure Put_X_Ungrab_Server_Request is  
       new Put_Request (X_Ungrab_Server_Request,  
                        To_Raw);  

    procedure Put_X_Uninstall_Colormap_Request is  
       new Put_Request (X_Uninstall_Colormap_Request,  
                        To_Raw);  

    procedure Put_X_Unmap_Subwindows_Request is  
       new Put_Request (X_Unmap_Subwindows_Request,  
                        To_Raw);  

    procedure Put_X_Unmap_Window_Request is  
       new Put_Request (X_Unmap_Window_Request,  
                        To_Raw);  

    procedure Put_X_Warp_Pointer_Request is  
       new Put_Request (X_Warp_Pointer_Request,  
                        To_Raw);  

--
    -- procedure Put_String is  
    --    new Put_Small_Data_1d (Character,  
    --                           Positive,  
    --                           String,  
    --                           To_Raw,  
    --                           Original_Size => 1);  

    -- procedure Put_String_Unaligned is  
    --    new Put_Small_Data_1d_Unaligned (Character,  
    --                                     Positive,  
    --                                     String,  
    --                                     To_Raw,  
    --                                     Original_Size => 1);  

    procedure Put_X_String is  
       new Put_Small_Data_1d (X_Character,  
                              S_Natural,  
                              X_String,  
                              To_Raw);  

    procedure Put_X_String_Unaligned is  
       new Put_Small_Data_1d_Unaligned (X_Character,  
                                        S_Natural,  
                                        X_String,  
                                        To_Raw);  

    procedure Put_X_String16 is  
       new Put_Small_Data_1d (X_Character16,  
                              S_Natural,  
                              X_String16,  
                              To_Raw);  

    procedure Put_X_String16_Unaligned is  
       new Put_Small_Data_1d_Unaligned (X_Character16,  
                                        S_Natural,  
                                        X_String16,  
                                        To_Raw);  

    procedure Put_X_Arc is  
       new Put_Data_Private (X_Arc,  
                             To_Raw);  


    procedure Put_X_Arc_Array is  
       new Put_Large_Data_1d (X_Arc,  
                              S_Natural,  
                              X_Arc_Array,  
                              To_Raw);  

    procedure Put_X_Atom_Array is  
       new Put_Large_Data_1d (X_Atom,  
                              S_Natural,  
                              X_Atom_Array,  
                              To_Raw);  

    procedure Put_X_Color_Item is  
       new Put_Data_Private (X_Color_Item,  
                             To_Raw);  

    procedure Put_X_Event_Mask is  
       new Put_Data_Private (X_Event_Mask,  
                             To_Raw);  

    procedure Put_X_Id is  
       new Put_Data_Private (X_Id,  
                             To_Raw);  

    procedure Put_X_Key_Code_Array is  
       new Put_Small_Data_1d (X_Key_Code,  
                              S_Natural,  
                              X_Key_Code_Array,  
                              To_Raw);  

--/ if not TeleGen2_2d_Bug then  
  
    procedure Put_X_Key_Sym_Array_2d is  
       new Put_Data_2d (X_Key_Sym,  
                        X_Key_Code,  
                        U_Char,  
                        X_Key_Sym_Array_2d,  
                        To_Raw,  
                        To_Raw);  
  
--/ else  
 
    procedure Put_X_Key_Sym_Array_2d is  
       new Put_Data_2d (X_Key_Sym,  
                        Telegen2_2d_Bug,  
                        U_Char,  
                        X_Key_Sym_Array_2d,  
                        To_Raw,  
                        To_Raw);  
 
--/ end if;  
    procedure Put_X_Led_Bits is  
       new Put_Data_Private (X_Led_Bits,  
                             To_Raw);  

    procedure Put_X_Modifier_Key_Code_Array is  
       new Put_Large_Data_1d (X_Modifier_Key_Code_Sub_Array,  
                              S_Natural,  
                              X_Modifier_Key_Code_Array,  
                              To_Raw);  


    procedure Put_X_Pixel is  
       new Put_Data_Private (X_Pixel,  
                             To_Raw);  

    procedure Put_X_Pixel_Array is  
       new Put_Large_Data_1d (X_Pixel,  
                              S_Natural,  
                              X_Pixel_Array,  
                              To_Raw);  

    procedure Put_X_Plane_Mask is  
       new Put_Data_Private (X_Plane_Mask,  
                             To_Raw);  

    procedure Put_X_Point is  
       new Put_Data_Private (X_Point,  
                             To_Raw);  


    procedure Put_X_Point_Array is  
       new Put_Large_Data_1d (X_Point,  
                              S_Natural,  
                              X_Point_Array,  
                              To_Raw);  

    procedure Put_X_Rectangle is  
       new Put_Data_Private (X_Rectangle,  
                             To_Raw);  

    procedure Put_X_Rectangle_Array is  
       new Put_Large_Data_1d (X_Rectangle,  
                              S_Natural,  
                              X_Rectangle_Array,  
                              To_Raw);  

    procedure Put_X_Segment is  
       new Put_Data_Private (X_Segment,  
                             To_Raw);  

    procedure Put_X_Segment_Array      is  
       new Put_Large_Data_1d (X_Segment,  
                              S_Natural,  
                              X_Segment_Array,  
                              To_Raw);  
    procedure Put_X_Text_Elt_Unaligned is  
       new Put_Data_Private_Unaligned (X_Text_Elt,  
                                       To_Raw);  

    procedure Put_S_Long is  
       new Put_Data_Private (S_Long,  
                             To_Raw);  

    procedure Put_U_Char_Array is  
       new Put_Small_Data_1d (U_Char,  
                              S_Natural,  
                              U_Char_Array,  
                              To_Raw);  

    procedure Put_U_Char_Array_Unaligned is  
       new Put_Small_Data_1d_Unaligned (U_Char,  
                                        S_Natural,  
                                        U_Char_Array,  
                                        To_Raw);  

--
--     procedure Put_X_Raw_Data_Array (display   : X_Display;  
--                                     Extra : X_Raw_Data_Array)  
--         renames Xlbmp_Put.Put_Data_Raw;  
-- ------------------------------------------------------------------------------  
-- -- Put Extra data into the Display buffer; we are appending to a request begun  
-- -- with Put_Request.  The Extra data is padded with 0's until it has a length  
-- -- rem 4 = 0.  We assume that the data fits into the Display's buffer; this will  
-- -- be true if Put_Request was supplied with the correct Extra value.  
-- ------------------------------------------------------------------------------  

--
end Xlbip_Put_Request;  

