with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  
with Xlbt_Reply3;  
use Xlbt_Reply3;  

with Xlbmp_Generic_Converters;  
use Xlbmp_Generic_Converters;  

package Xlbip_Reply_Converters is  
------------------------------------------------------------------------------  
-- X Library Internal X_Reply/X_Raw_Data Converters  
--  
-- Xlbip_Reply_Converters - Conversions to/from system data types.  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the name of Rational not be used in  
-- advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- Rational disclaims all warranties with regard to this software, including  
-- all implied warranties of merchantability and fitness, in no event shall  
-- Rational be liable for any special, indirect or consequential damages or  
-- any damages whatsoever resulting from loss of use, data or profits, whether  
-- in an action of contract, negligence or other tortious action, arising out  
-- of or in connection with the use or performance of this software.  
------------------------------------------------------------------------------  
--
    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Alloc_Color_Reply);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Alloc_Color_Cells_Reply);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Alloc_Color_Planes_Reply);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Alloc_Named_Color_Reply);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Get_Atom_Name_Reply);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Get_Font_Path_Reply);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Get_Geometry_Reply);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Get_Image_Reply);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Get_Input_Focus_Reply);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Get_Keyboard_Control_Reply);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Get_Keyboard_Mapping_Reply);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Get_Modifier_Mapping_Reply);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Get_Motion_Events_Reply);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Get_Pointer_Control_Reply);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Get_Pointer_Mapping_Reply);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Get_Property_Reply);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Get_Screen_Saver_Reply);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Get_Selection_Owner_Reply);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Get_Window_Attributes_Reply);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Grab_Keyboard_Reply);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Grab_Pointer_Reply);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Intern_Atom_Reply);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_List_Extensions_Reply);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_List_Fonts_Reply);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_List_Fonts_With_Info_Reply);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_List_Hosts_Reply);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Wire_Host_Reply);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_List_Installed_Colormaps_Reply);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_List_Properties_Reply);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Lookup_Color_Reply);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Query_Best_Size_Reply);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Query_Colors_Reply);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Query_Extension_Reply);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Query_Font_Reply);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Query_Keymap_Reply);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Query_Pointer_Reply);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Query_Text_Extents_Reply);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Query_Tree_Reply);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Rgb);  

    procedure From_Raw is  
       new Convert_Raw_To_Array (Original       => X_Rgb,  
                                 Index          => S_Natural,  
                                 Original_Array => X_Rgb_Array);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Set_Modifier_Mapping_Reply);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Set_Pointer_Mapping_Reply);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Translate_Coords_Reply);  

--
end Xlbip_Reply_Converters;  

