with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  
with Xlbt_Basic;  
use Xlbt_Basic;  
with Xlbt_Error;  
use Xlbt_Error;  
with Xlbt_Reply;  
use Xlbt_Reply;  
with Xlbt_Request;  
use Xlbt_Request;  

with Xlbmt_Network_Types;  
use Xlbmt_Network_Types;  

package Xlbip_Wire_Converters is  
------------------------------------------------------------------------------  
-- X Library Internal Protocol/Record Conversions  
--  
-- Xlbip_Wire_Converters - Converts between network byte streams and our Ada  
--                         data types  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the name of Rational not be used in  
-- advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- Rational disclaims all warranties with regard to this software, including  
-- all implied warranties of merchantability and fitness, in no event shall  
-- Rational be liable for any special, indirect or consequential damages or  
-- any damages whatsoever resulting from loss of use, data or profits, whether  
-- in an action of contract, negligence or other tortious action, arising out  
-- of or in connection with the use or performance of this software.  
------------------------------------------------------------------------------  

--
------------------------------------------------------------------------------  
-- Protocol conversion routines  
------------------------------------------------------------------------------  

    procedure Internal_Wire_To_Error  
                 (Display    :     X_Display;  
                  Raw        :     X_Raw_Data_Array;  
                  Send_Event :     Boolean;  
                  Error      : out X_Error_Contents);  

    procedure Internal_Wire_To_Event  
                 (Display    :     X_Display;  
                  Raw        :     X_Raw_Data_Array;  
                  Send_Event :     Boolean;  
                  Event      : out X_Event;  
                  Status     : out X_Status);  

    procedure Internal_Wire_To_Reply  
                 (Code       :     X_Request_Code;  
                  Raw        :     X_Raw_Data_Array;  
                  Send_Event :     Boolean;  
                  Reply      : out X_Reply_Contents;  
                  Length     : out S_Natural);  

    procedure Internal_Event_To_Wire  
                 (Display :     X_Display;  
                  Event   :     X_Event;  
                  Raw     : out X_Raw_Data_Array;  
                  Status  : out X_Status);  

end Xlbip_Wire_Converters;  

