with Xlbt_Basic;  
use Xlbt_Basic;  
with Xlbt_String;  
use Xlbt_String;  

package Xlbp_Atom is  
------------------------------------------------------------------------------  
-- X Library Atoms  
--  
-- Xlbp_Atom - Create and lookup "atoms" (X server string shorthand)  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  
--
    function X_Get_Atom_Name (Display : X_Display;  
                              Atom    : X_Atom) return X_String;  
------------------------------------------------------------------------------  
--  Display - Specifies the display to use.  
--  Atom    - Specifies the atom whose name is required.  
--  
-- Returns "" if there is no such atom and the string form of  
-- the atom otherwise.  
------------------------------------------------------------------------------  

    function X_Intern_Atom (Display        : X_Display;  
                            Name           : X_String;  
                            Only_If_Exists : Boolean) return X_Atom;  
------------------------------------------------------------------------------  
--  Display        - Specifies the display to use.  
--  Name           - Specifies the contents of the new atom.  
--  Only_If_Exists - Specifies True if a new atom is not to be created.  
--  
-- Returns the atom corresponding to the string.  Creates a new atom if no  
-- such atom currently exists and if Only_If_Exists = False.  
------------------------------------------------------------------------------  

end Xlbp_Atom;  

