with Xlbt_Basic;  
use Xlbt_Basic;  
with Xlbt_Context_Manager;  
use Xlbt_Context_Manager;  
with Xlbt_Rm;  
use Xlbt_Rm;  
with Xlbt_String;  
use Xlbt_String;  

package Xlbp_Context_Manager is  
------------------------------------------------------------------------------  
-- X Library Context Management  
--  
-- Xlbp_Context_Manager - Used to associate data with a window.  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1987 - 1989 by Digital Equipment Corporation, Maynard, Mass.  
-- Copyright 1987 - 1989 by Massachusetts Institute of Technology,  
--                          Cambridge, Massachusetts.  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of Digital, MIT, or Rational  
-- not be used in advertising or publicity pertaining to distribution of  
-- the software without specific, written prior permission.  
--  
-- Digital, MIT, and Rational disclaim all warranties with regard to this  
-- software, including all implied warranties of merchantability and fitness,  
-- in no event shall Digital, MIT, or Rational be liable for any special,  
-- indirect or consequential damages or any damages whatsoever resulting from  
-- loss of use, data or profits, whether in an action of contract, negligence  
-- or other tortious action, arising out of or in connection with the use or  
-- performance of this software.  
------------------------------------------------------------------------------  

--/ if OLD_CONTEXT_MANAGER then  
--
  
    function X_Delete_Context  
                (Display : X_Display;  
                 Window  : X_Window;  
                 Context : X_Context) return X_Associative_Returns;  
------------------------------------------------------------------------------  
--  Display  - Specifies the display to use.  
--  Window   - Specifies the window the data is associated with.  
--  Context  - Specifies the context the data is associated with.  
--  
-- Delete an entry in the context manager for a particular [Window,Context]  
-- pair.  
------------------------------------------------------------------------------  
 
    procedure X_Find_Context (Display :     X_Display;  
                              Window  :     X_Window;  
                              Context :     X_Context;  
                              Data    : out X_Rm_Value;  
                              Status  : out X_Associative_Returns);  
------------------------------------------------------------------------------  
--  Display  - Specifies the display to use.  
--  Window   - Specifies the window the data is associated with.  
--  Context  - Specifies the context the data is associated with.  
--  Data     - Receives the data associated with the [Window,Context].  
--  Status   - Receives the status of the fetch.  
--  
-- Fetch an entry in the context manager for a particular [Window,Context]  
-- pair.  
------------------------------------------------------------------------------  
 
    function X_Save_Context (Display : X_Display;  
                             Window  : X_Window;  
                             Context : X_Context;  
                             Data    : X_Rm_Value) return X_Associative_Returns;  
------------------------------------------------------------------------------  
--  Display  - Specifies the display to use.  
--  Window   - Specifies the window the data is associated with.  
--  Context  - Specifies the context the data is associated with.  
--  Data     - Specifies the data to associate with the [Window,Context].  
--  
-- Place an entry in the context manager for a particular [Window,Context]  
-- pair.  
------------------------------------------------------------------------------  
 
    function X_String_To_Context (Name : X_String) return X_Context;  
------------------------------------------------------------------------------  
--  Name    - Specifies the name use in creating an X_Context.  
--  
-- Returns an X_Context corresponding to the Name.  
------------------------------------------------------------------------------  
 
    function X_Context_To_String (Context : X_Context) return X_String;  
------------------------------------------------------------------------------  
--  Context    - Specifies the X_Context to convert.  
--  
-- Returns the original string name of a context.  
------------------------------------------------------------------------------  
 
    function X_Unique_Context return X_Context;  
------------------------------------------------------------------------------  
-- Returns a new and unique X_Context for use with this package.  
------------------------------------------------------------------------------  
 
--/ end if;  
--
end Xlbp_Context_Manager;  

