with Xlbt_Basic;  
use Xlbt_Basic;  
with Xlbt_Keyboard;  
use Xlbt_Keyboard;  

package Xlbp_Keyboard_Control is  
------------------------------------------------------------------------------  
-- X Library Keyboard Controls  
--  
-- Xlbp_Keyboard_Control - Controls over physical portions of the keyboard  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
    procedure X_Auto_Repeat_On (Display : X_Display);  
------------------------------------------------------------------------------  
--  Display - Specifies the display to use.  
--  
-- Turn on auto-repeat for the keyboard.  
------------------------------------------------------------------------------  

    procedure X_Auto_Repeat_Off (Display : X_Display);  
------------------------------------------------------------------------------  
--  Display - Specifies the display to use.  
--  
-- Turn off auto-repeat for the keyboard.  
------------------------------------------------------------------------------  

    procedure X_Bell (Display : X_Display;  
                      Percent : S_Percent);  
------------------------------------------------------------------------------  
--  Display - Specifies the display to use.  
--  Percent - Specifies the bell volume.  
--  
-- Rings the bell on the display.  
-- Percent >= 0 --> rings at base - (base * percent) / 100 + percent  
-- Percent <  0 --> rings at base + (base * percent) / 100  
------------------------------------------------------------------------------  

    procedure X_Change_Keyboard_Control (Display     : X_Display;  
                                         Values_Mask : X_Keyboard_Control_Flags;  
                                         Values      : X_Keyboard_Control);  
------------------------------------------------------------------------------  
--  Display     - Specifies the display to use.  
--  Values_Mask - Specifies which of the Values elements are to change.  
--  Values      - Specifies a list of changes to be made in the keyboard.  
--  
-- Changes those attributes of the keyboard which are flagged in Mask; the  
-- new values are taken from Values.  
------------------------------------------------------------------------------  

    procedure X_Get_Keyboard_Control (Display :     X_Display;  
                                      State   : out X_Keyboard_State);  
------------------------------------------------------------------------------  
--  Display - Specifies the display to use.  
--  State   - Receives the current keyboard state.  
------------------------------------------------------------------------------  

    procedure X_Query_Keymap (Display :     X_Display;  
                              Keys    : out X_Keyboard_As_Bits);  
------------------------------------------------------------------------------  
--  Display - Specifies the display to use.  
--  Keys    - Receives the state of the keyboard.  
--  
-- A '1' bit in the Keys indicates that the respective key is depressed.  
-- The bit for key N is is Keys(N/8) and can be tested by AND'ing with the  
-- mask 2**(N rem 8).  (** is faster than the Shift procedure.)  
------------------------------------------------------------------------------  

end Xlbp_Keyboard_Control;  

