with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  
with Xlbt_Basic;  
use Xlbt_Basic;  
with Xlbt_Key;  
use Xlbt_Key;  
with Xlbt_Keyboard;  
use Xlbt_Keyboard;  

package Xlbp_Pointer_Control is  
------------------------------------------------------------------------------  
-- X Library Pointer Controls  
--  
-- Xlbp_Pointer_Control - Controls over pointer motion and button encoding  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
    procedure X_Change_Pointer_Control (Display                : X_Display;  
                                        Do_Accelerate          : Boolean;  
                                        Do_Threshold           : Boolean;  
                                        Accelerate_Numerator   : S_Short;  
                                        Accelerate_Denominator : S_Short;  
                                        Threshold              : S_Short);  
------------------------------------------------------------------------------  
--  Display                 - Specifies the display to use.  
--  Do_Accelerate           - True if the Accelerate values are to be set.  
--  Do_Threshold            - True if the threshold is to be set.  
--  Accelerate_Numerator    - Specifies the numerator of the acceleration  
--                            multiplier.  
--  Accelerate_Denominator  - Specifies the denominator of the acceleration  
--                            procedure.  
--  Threshold               - Specifies the acceleration threshold.  
--  
-- Sets the pointer acceleration controls.  
------------------------------------------------------------------------------  

    procedure X_Get_Pointer_Control (Display                :     X_Display;  
                                     Accelerate_Numerator   : out U_Short;  
                                     Accelerate_Denominator : out U_Short;  
                                     Threshold              : out U_Short);  
------------------------------------------------------------------------------  
--  Display     - Specifies the display to use.  
--  Accelerate_Numerator    - Specifies the numerator of the acceleration  
--                            multiplier.  
--  Accelerate_Denominator  - Specifies the denominator of the acceleration  
--                            procedure.  
--  Threshold               - Specifies the acceleration threshold.  
--  
-- Returns the current pointer acceleration controls.  
------------------------------------------------------------------------------  

    procedure X_Get_Pointer_Mapping (Display :     X_Display;  
                                     Map     : out X_Key_Code_List;  
                                     Status  : out X_Mapping_Status);  
------------------------------------------------------------------------------  
--  Display - Specifies the display to use.  
--  Map     - Receives the mapping list.  
--  Status  - Receives the success of the operation; Mapping_Success = OK.  
--  
-- Returns the current mapping of the pointer.  Elements of the list are  
-- indexed starting from one.  The length of the list indicates the number  
-- of physical buttons.  The nominal mapping for a pointer is the identity  
-- mapping: map[i] = i.  
------------------------------------------------------------------------------  

    procedure X_Set_Pointer_Mapping (Display :     X_Display;  
                                     Map     :     X_Key_Code_Array;  
                                     Status  : out X_Mapping_Status);  
------------------------------------------------------------------------------  
--  Display - Specifies the display to use.  
--  Map     - Specifies the mapping list.  
--  Status  - Receives the success of the operation; Mapping_Success = OK.  
--  
-- Sets the pointer mapping.  
------------------------------------------------------------------------------  

end Xlbp_Pointer_Control;  

