with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  
with Xlbt_Basic;  
use Xlbt_Basic;  
with Xlbt_Pointer;  
use Xlbt_Pointer;  

package Xlbp_Pointer_Motion is  
------------------------------------------------------------------------------  
-- X Library Pointer Motion  
--  
-- Xlbp_Pointer_Motion - Obtaining pointer motion history.  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
    function X_Display_Motion_Buffer_Size (Display : X_Display) return S_Long;  
------------------------------------------------------------------------------  
--  Display - Specifies the display to use.  
--  
-- Returns the size of the motion buffer on this connection.  
------------------------------------------------------------------------------  

    function X_Get_Motion_Events (Display : X_Display;  
                                  Window  : X_Window;  
                                  Start   : X_Time;  
                                  Stop    : X_Time)  
                                 return X_Time_Coord_List;  
------------------------------------------------------------------------------  
--  Display - Specifies the display to use  
--  Window  - Specifies the window to use.  
--  Start   - Specifies a starting time; or Current_Time.  
--  Stop    - Specifies a stopping time; or Current_Time.  
--  
-- Returns a list of motion events occurring during that time interval.  
--  
-- Free the list after use with the Free_X_Time_Coord_List routine.  
------------------------------------------------------------------------------  

end Xlbp_Pointer_Motion;  

