with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  
with Xlbt_Basic;  
use Xlbt_Basic;  
with Xlbt_Screen_Saver;  
use Xlbt_Screen_Saver;  

package Xlbp_Screen_Saver is  
------------------------------------------------------------------------------  
-- X Library Screen Saver  
--  
-- Xlbp_Screen_Saver - Control of the server Screen-Saver facility  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
    procedure X_Activate_Screen_Saver (Display : X_Display);  
------------------------------------------------------------------------------  
--  Display             - Specifies the display to use.  
--  
-- Activates the screen saver.  
------------------------------------------------------------------------------  

    procedure X_Force_Screen_Saver (Display : X_Display;  
                                    Mode    : X_Screen_Saver_Mode);  
------------------------------------------------------------------------------  
--  Display - Specifies the display to use.  
--  Mode    - Specifies Screen_Saver_Reset (off) or Screen_Saver_Active (on).  
--  
-- Forces the screen save on or off.  
------------------------------------------------------------------------------  

    procedure X_Get_Screen_Saver  
                 (Display         :     X_Display;  
                  Timeout         : out U_Short;  
                  Interval        : out U_Short;  
                  Prefer_Blanking : out X_Screen_Saver_Blanking;  
                  Allow_Exposures : out X_Screen_Saver_Exposures);  
------------------------------------------------------------------------------  
--  Display             - Specifies the display to use.  
--  Timeout             - Receives timeout in seconds until the saver turns on.  
--  Interval            - Receives the interval between screen saver  
--                        invocations.  
--  Prefer_Blanking     - Receives whether to enable screen blanking.  
--  Allow_Exposures     - Receives the current screen save control values.  
--  
-- Returns the current controls on screen blanking.  
------------------------------------------------------------------------------  

    procedure X_Reset_Screen_Saver (Display : X_Display);  
------------------------------------------------------------------------------  
--  Display             - Specifies the display to use.  
--  
-- Deactivates the screen saver.  
------------------------------------------------------------------------------  

    Disable_Screen_Saver    : constant U_Short := 0;  
    Disable_Screen_Interval : constant U_Short := 0;  

    procedure X_Set_Screen_Saver (Display         : X_Display;  
                                  Timeout         : U_Short;  
                                  Interval        : U_Short;  
                                  Prefer_Blanking : X_Screen_Saver_Blanking;  
                                  Allow_Exposures : X_Screen_Saver_Exposures);  
------------------------------------------------------------------------------  
--  Display             - Specifies the display to use.  
--  Timeout             - Specifies timeout in seconds until the saver turns on.  
--  Interval            - Specifies the interval between screen saver  
--                        invocations.  
--  Prefer_Blanking     - Specifies whether to enable screen blanking.  
--  Allow_Exposures     - Specifies the current screen save control values.  
--  
-- Turns screen blanking on or off and sets the control values.  
------------------------------------------------------------------------------  

end Xlbp_Screen_Saver;  

