with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  

package body Xlbt_Basic3 is  
------------------------------------------------------------------------------  
-- X Library Basic Types - Full Interface  
--  
-- Xlbt_Basic3 - Types are declared here because they are "low level" types.  
-- They are types which are used to create many other composite types.  
-- They are in some sense "primitive" types.  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
    function X_Event_Mask_Short_To_Long  
                (A : X_Event_Mask_Short) return X_Event_Mask is  
-----------------------------------------------------------------------------  
--  A   - Specifies a short event mask  
--  
-- Called to convert a short event mask into a long event mask.  
------------------------------------------------------------------------------  
    begin  

--/ if Bit0_Sign_Bit then  

        return X_Event_Mask  
                  ((X_Event_Mask_Index'Val (0) .. X_Event_Mask_Index'Val (15)  
                        => False)  
                    & X_Event_Mask_Array (A));  

--/ else  
 
       return  
          X_Event_Mask  
             ((X_Event_Mask_Array (A)  
                & (X_Event_Mask_Index'Val (16) .. X_Event_Mask_Index'Val (31)  
                      => False)));  
 
--/ end if;  

    end X_Event_Mask_Short_To_Long;  

--
end Xlbt_Basic3;  

