with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  

package Xlbt_Cursor_Font is  
------------------------------------------------------------------------------  
-- X Library Standard Cursor Font  
--  
-- Xlbt_Cursor_Font - Defines the standard X server cursor font  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
    type X_Cursor_Font is new U_Short;  

    Xc_Num_Glyphs : constant X_Cursor_Font := 154;  

    Xc_X_Cursor            : constant X_Cursor_Font := 0;  
    Xc_Arrow               : constant X_Cursor_Font := 2;  
    Xc_Based_Arrow_Down    : constant X_Cursor_Font := 4;  
    Xc_Based_Arrow_Up      : constant X_Cursor_Font := 6;  
    Xc_Boat                : constant X_Cursor_Font := 8;  
    Xc_Bogosity            : constant X_Cursor_Font := 10;  
    Xc_Bottom_Left_Corner  : constant X_Cursor_Font := 12;  
    Xc_Bottom_Right_Corner : constant X_Cursor_Font := 14;  
    Xc_Bottom_Side         : constant X_Cursor_Font := 16;  
    Xc_Bottom_Tee          : constant X_Cursor_Font := 18;  
    Xc_Box_Spiral          : constant X_Cursor_Font := 20;  
    Xc_Center_Ptr          : constant X_Cursor_Font := 22;  
    Xc_Circle              : constant X_Cursor_Font := 24;  
    Xc_Clock               : constant X_Cursor_Font := 26;  
    Xc_Coffee_Mug          : constant X_Cursor_Font := 28;  
    Xc_Cross               : constant X_Cursor_Font := 30;  
    Xc_Cross_Reverse       : constant X_Cursor_Font := 32;  
    Xc_Crosshair           : constant X_Cursor_Font := 34;  
    Xc_Diamond_Cross       : constant X_Cursor_Font := 36;  
    Xc_Dot                 : constant X_Cursor_Font := 38;  
    Xc_Dot_Box_Mask        : constant X_Cursor_Font := 40;  
    Xc_Double_Arrow        : constant X_Cursor_Font := 42;  
    Xc_Draft_Large         : constant X_Cursor_Font := 44;  
    Xc_Draft_Small         : constant X_Cursor_Font := 46;  
    Xc_Draped_Box          : constant X_Cursor_Font := 48;  
    Xc_Exchange            : constant X_Cursor_Font := 50;  
    Xc_Fleur               : constant X_Cursor_Font := 52;  
    Xc_Gobbler             : constant X_Cursor_Font := 54;  
    Xc_Gumby               : constant X_Cursor_Font := 56;  
    Xc_Hand1               : constant X_Cursor_Font := 58;  
    Xc_Hand2               : constant X_Cursor_Font := 60;  
    Xc_Heart               : constant X_Cursor_Font := 62;  
    Xc_Icon                : constant X_Cursor_Font := 64;  
    Xc_Iron_Cross          : constant X_Cursor_Font := 66;  
    Xc_Left_Ptr            : constant X_Cursor_Font := 68;  
    Xc_Left_Side           : constant X_Cursor_Font := 70;  
    Xc_Left_Tee            : constant X_Cursor_Font := 72;  
    Xc_Leftbutton          : constant X_Cursor_Font := 74;  
    Xc_Ll_Angle            : constant X_Cursor_Font := 76;  
    Xc_Lr_Angle            : constant X_Cursor_Font := 78;  
    Xc_Man                 : constant X_Cursor_Font := 80;  
    Xc_Middlebutton        : constant X_Cursor_Font := 82;  
    Xc_Mouse               : constant X_Cursor_Font := 84;  
    Xc_Pencil              : constant X_Cursor_Font := 86;  
    Xc_Pirate              : constant X_Cursor_Font := 88;  
    Xc_Plus                : constant X_Cursor_Font := 90;  
    Xc_Question_Arrow      : constant X_Cursor_Font := 92;  
    Xc_Right_Ptr           : constant X_Cursor_Font := 94;  
    Xc_Right_Side          : constant X_Cursor_Font := 96;  
    Xc_Right_Tee           : constant X_Cursor_Font := 98;  
    Xc_Rightbutton         : constant X_Cursor_Font := 100;  
    Xc_Rtl_Logo            : constant X_Cursor_Font := 102;  
    Xc_Sailboat            : constant X_Cursor_Font := 104;  
    Xc_Sb_Down_Arrow       : constant X_Cursor_Font := 106;  
    Xc_Sb_H_Double_Arrow   : constant X_Cursor_Font := 108;  
    Xc_Sb_Left_Arrow       : constant X_Cursor_Font := 110;  
    Xc_Sb_Right_Arrow      : constant X_Cursor_Font := 112;  
    Xc_Sb_Up_Arrow         : constant X_Cursor_Font := 114;  
    Xc_Sb_V_Double_Arrow   : constant X_Cursor_Font := 116;  
    Xc_Shuttle             : constant X_Cursor_Font := 118;  
    Xc_Sizing              : constant X_Cursor_Font := 120;  
    Xc_Spider              : constant X_Cursor_Font := 122;  
    Xc_Spraycan            : constant X_Cursor_Font := 124;  
    Xc_Star                : constant X_Cursor_Font := 126;  
    Xc_Target              : constant X_Cursor_Font := 128;  
    Xc_Tcross              : constant X_Cursor_Font := 130;  
    Xc_Top_Left_Arrow      : constant X_Cursor_Font := 132;  
    Xc_Top_Left_Corner     : constant X_Cursor_Font := 134;  
    Xc_Top_Right_Corner    : constant X_Cursor_Font := 136;  
    Xc_Top_Side            : constant X_Cursor_Font := 138;  
    Xc_Top_Tee             : constant X_Cursor_Font := 140;  
    Xc_Trek                : constant X_Cursor_Font := 142;  
    Xc_Ul_Angle            : constant X_Cursor_Font := 144;  
    Xc_Umbrella            : constant X_Cursor_Font := 146;  
    Xc_Ur_Angle            : constant X_Cursor_Font := 148;  
    Xc_Watch               : constant X_Cursor_Font := 150;  
    Xc_Xterm               : constant X_Cursor_Font := 152;  

end Xlbt_Cursor_Font;  

