with Xlbt_Font3;  

package Xlbt_Font is  
------------------------------------------------------------------------------  
-- X Library Font - Normal User Interface  
--  
-- Xlbt_Font - Types relating to X Server fonts.  
--------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
    package F3 renames Xlbt_Font3;  

------------------------------------------------------------------------------  
-- X_Char_Struct - Font Character Structure  
------------------------------------------------------------------------------  

    subtype X_Char_Struct         is F3.X_Char_Struct;  
    subtype X_Char_Struct_List_2d is F3.X_Char_Struct_List_2d;  

    None_X_Char_Struct         : X_Char_Struct renames F3.None_X_Char_Struct;  
    None_X_Char_Struct_List_2d : F3.X_Char_Struct_List_2d  
        renames F3.None_X_Char_Struct_List_2d;  

    function "=" (A, B : X_Char_Struct_List_2d) return Boolean renames F3."=";  

    procedure Free_X_Char_Struct_List_2d (List : in out X_Char_Struct_List_2d)  
        renames F3.Free_X_Char_Struct_List_2d;  

    function Ci_Non_Exist_Char (Char : X_Char_Struct) return Boolean  
        renames F3.Ci_Non_Exist_Char;  
    ----Returns true if this character doesn't really exist in this font.  

------------------------------------------------------------------------------  
-- Font_Direction - used in X_Query_Font -- drawing direction  
------------------------------------------------------------------------------  

    subtype X_Font_Direction is F3.X_Font_Direction;  

    Font_Left_To_Right : constant X_Font_Direction := F3.Font_Left_To_Right;  
    Font_Right_To_Left : constant X_Font_Direction := F3.Font_Right_To_Left;  

    None_X_Font_Direction : X_Font_Direction renames F3.None_X_Font_Direction;  

------------------------------------------------------------------------------  
-- X_Font_Struct  
------------------------------------------------------------------------------  

    subtype X_Font_Struct      is F3.X_Font_Struct;  
    subtype X_Font_Struct_List is F3.X_Font_Struct_List;  

    None_X_Font_Struct      : X_Font_Struct renames F3.None_X_Font_Struct;  
    None_X_Font_Struct_List : X_Font_Struct_List  
        renames F3.None_X_Font_Struct_List;  

    function "=" (A, B : X_Font_Struct)      return Boolean renames F3."=";  
    function "=" (A, B : X_Font_Struct_List) return Boolean renames F3."=";  

    procedure Free_X_Font_Struct      (Font : in out X_Font_Struct)  
        renames F3.Free_X_Font_Struct;  
    procedure Free_X_Font_Struct_List (List : in out X_Font_Struct_List)  
        renames F3.Free_X_Font_Struct_List;  

------------------------------------------------------------------------------  
-- X_Fonts_With_Info  
------------------------------------------------------------------------------  

    subtype X_Fonts_With_Info is F3.X_Fonts_With_Info;  

    procedure Free_X_Fonts_With_Info (Info : in out X_Fonts_With_Info)  
        renames F3.Free_X_Fonts_With_Info;  

------------------------------------------------------------------------------  
-- X_Per_Char_Flags - Font Metric Information.  
------------------------------------------------------------------------------  

    subtype X_Per_Char_Flags_Index is F3.X_Per_Char_Flags_Index;  

    Xpcfi15 : constant X_Per_Char_Flags_Index := F3.Xpcfi15;  
    Xpcfi14 : constant X_Per_Char_Flags_Index := F3.Xpcfi14;  
    Xpcfi13 : constant X_Per_Char_Flags_Index := F3.Xpcfi13;  
    Xpcfi12 : constant X_Per_Char_Flags_Index := F3.Xpcfi12;  
    Xpcfi11 : constant X_Per_Char_Flags_Index := F3.Xpcfi11;  
    Xpcfi10 : constant X_Per_Char_Flags_Index := F3.Xpcfi10;  
    Xpcfi09 : constant X_Per_Char_Flags_Index := F3.Xpcfi09;  
    Xpcfi08 : constant X_Per_Char_Flags_Index := F3.Xpcfi08;  
    Xpcfi07 : constant X_Per_Char_Flags_Index := F3.Xpcfi07;  
    Xpcfi06 : constant X_Per_Char_Flags_Index := F3.Xpcfi06;  
    Xpcfi05 : constant X_Per_Char_Flags_Index := F3.Xpcfi05;  
    Xpcfi04 : constant X_Per_Char_Flags_Index := F3.Xpcfi04;  
    Xpcfi03 : constant X_Per_Char_Flags_Index := F3.Xpcfi03;  
    Xpcfi02 : constant X_Per_Char_Flags_Index := F3.Xpcfi02;  
    Xpcfi01 : constant X_Per_Char_Flags_Index := F3.Xpcfi01;  
    Xpcfi00 : constant X_Per_Char_Flags_Index := F3.Xpcfi00;  

    subtype X_Per_Char_Flags is F3.X_Per_Char_Flags;  

    None_X_Per_Char_Flags : X_Per_Char_Flags renames F3.None_X_Per_Char_Flags;  

    function "=" (A, B : X_Per_Char_Flags_Index) return Boolean renames F3."=";  
    function "=" (A, B : X_Per_Char_Flags)       return Boolean renames F3."=";  

end Xlbt_Font;  

