with Unchecked_Deallocation;  

with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  
with Xlbt_String;  
use Xlbt_String;  

package body Xlbt_Font3 is  
------------------------------------------------------------------------------  
-- X Library Font - Full Interface  
--  
-- Xlbt_Font2 - Types relating to X Server fonts.  
--------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

    procedure Heap_Free_X_Font_Struct_List is  
       new Unchecked_Deallocation (X_Font_Struct_Array,  
                                   X_Font_Struct_List);  

--
    function Ci_Non_Exist_Char (Char : X_Char_Struct) return Boolean is  
        ----Returns true if this character doesn't really exist in this font.  
    begin  
        return Char.Width = 0 and then  
                  Char.Rbearing = 0 and then Char.Lbearing = 0;  
    end Ci_Non_Exist_Char;  

--
    procedure Free_X_Font_Struct_List (List : in out X_Font_Struct_List) is  
    begin  
        for I in List'Range loop  
            Free_X_Font_Struct (List (I));  
        end loop;  
        Heap_Free_X_Font_Struct_List (List);  
    end Free_X_Font_Struct_List;  

--
    procedure Free_X_Fonts_With_Info (Info : in out X_Fonts_With_Info) is  
    begin  
        Free_X_Font_Struct_List (Info.Info);  
        Free_X_String_Pointer_List (Info.Name);  
    end Free_X_Fonts_With_Info;  

--
end Xlbt_Font3;  

