package Xlbt_Geometry is  
------------------------------------------------------------------------------  
-- X Library Window Geometry Parsing  
--  
-- Xlbt_Geometry - Types dealing with window geometry  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
------------------------------------------------------------------------------  
-- X_Parse_Geometry_Flags - Bitmask returned by X_Parse_Geometry().  Each bit  
-- tells if the corresponding value (x, y, width, height) was found in the  
-- parsed string.  
------------------------------------------------------------------------------  

--/ if Bit0_Sign_Bit then  

    type X_Parse_Geometry_Flags_Index is  
       (Xpgfi31, Xpgfi30, Xpgfi29, Xpgfi28, Xpgfi27, Xpgfi26, Xpgfi25,  
        Xpgfi24, Xpgfi23, Xpgfi22, Xpgfi21, Xpgfi20, Xpgfi19, Xpgfi18,  
        Xpgfi17, Xpgfi16, Xpgfi15, Xpgfi14, Xpgfi13, Xpgfi12, Xpgfi11,  
        Xpgfi10, Xpgfi09, Xpgfi08, Xpgfi07, Xpgfi06, -- Unused  
        Y_Negative,  
        X_Negative,  
        Height_Value,  
        Width_Value,  
        Y_Value,  
        X_Value);  

--/ else -- not Bit0_Sign_Bit then  
 
    type X_Parse_Geometry_Flags_Index is  
       (X_Value,  
        Y_Value,  
        Width_Value,  
        Height_Value,  
        X_Negative,  
        Y_Negative,  
        Xpgfi06, Xpgfi07, Xpgfi08, Xpgfi09, Xpgfi10, Xpgfi11,  
        Xpgfi12, Xpgfi13, Xpgfi14, Xpgfi15, Xpgfi16, Xpgfi17,  
        Xpgfi18, Xpgfi19, Xpgfi20, Xpgfi21, Xpgfi22, Xpgfi23,  
        Xpgfi24, Xpgfi25, Xpgfi26, Xpgfi27, Xpgfi28,  
        Xpgfi29, Xpgfi30, Xpgfi31); -- Unused  
 
--/ end if;  

    type X_Parse_Geometry_Flags is  
       array (X_Parse_Geometry_Flags_Index) of Boolean;  

--/ if Length_Clauses and not TeleGen2_Length_Bug then  
    for X_Parse_Geometry_Flags'Size use 32;  
--/ elsif Pack then  
    pragma Pack (X_Parse_Geometry_Flags);  
--/ end if;  

    None_X_Parse_Geometry_Flags : constant X_Parse_Geometry_Flags :=  
       X_Parse_Geometry_Flags'(others => False);  

    All_Values : constant X_Parse_Geometry_Flags :=  
       X_Parse_Geometry_Flags'  
          (X_Value | Y_Value | Width_Value | Height_Value => True,  
           others => False);  

end Xlbt_Geometry;  

