with Xlbt_Hint3;  

package Xlbt_Hint is  
------------------------------------------------------------------------------  
-- X Library Window Manager Hints - Normal User Interface  
--  
-- Xlbt_Hint - Structures used to give hints to window managers.  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1987 - 1989 by Digital Equipment Corporation, Maynard, Mass.  
-- Copyright 1987 - 1989 by Massachusetts Institute of Technology,  
--                          Cambridge, Massachusetts.  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of Digital, MIT, or Rational  
-- not be used in advertising or publicity pertaining to distribution of  
-- the software without specific, written prior permission.  
--  
-- Digital, MIT, and Rational disclaim all warranties with regard to this  
-- software, including all implied warranties of merchantability and fitness,  
-- in no event shall Digital, MIT, or Rational be liable for any special,  
-- indirect or consequential damages or any damages whatsoever resulting from  
-- loss of use, data or profits, whether in an action of contract, negligence  
-- or other tortious action, arising out of or in connection with the use or  
-- performance of this software.  
------------------------------------------------------------------------------  

--
    package H3 renames Xlbt_Hint3;  

------------------------------------------------------------------------------  
-- Class Hints  
------------------------------------------------------------------------------  

    subtype X_Class_Hint is H3.X_Class_Hint;  

    None_X_Class_Hint : X_Class_Hint renames H3.None_X_Class_Hint;  

------------------------------------------------------------------------------  
-- X_Icon_Size hints  
------------------------------------------------------------------------------  

    subtype X_Icon_Size       is H3.X_Icon_Size;  
    subtype X_Icon_Size_Array is H3.X_Icon_Size_Array;  
    subtype X_Icon_Size_List  is H3.X_Icon_Size_List;  

    None_X_Icon_Size      : X_Icon_Size      renames H3.None_X_Icon_Size;  
    None_X_Icon_Size_List : X_Icon_Size_List renames H3.None_X_Icon_Size_List;  

    function "=" (A, B : X_Icon_Size_List) return Boolean renames H3."=";  

    procedure Free_X_Icon_Size_List (List : in out X_Icon_Size_List)  
        renames H3.Free_X_Icon_Size_List;  

------------------------------------------------------------------------------  
-- X_Initial_Window_State  
--  
--      Withdrawn_State - for windows that are not mapped  
--      Normal_State    - most applications want to start this way  
--      Iconic_State    - application want to start as an icon  
------------------------------------------------------------------------------  

    subtype X_Initial_Window_State is H3.X_Initial_Window_State;  

    Withdrawn_State : constant X_Initial_Window_State := H3.Withdrawn_State;  
    Normal_State    : constant X_Initial_Window_State := H3.Normal_State;  
    Iconic_State    : constant X_Initial_Window_State := H3.Iconic_State;  

    None_X_Initial_Window_State : X_Initial_Window_State  
        renames H3.None_X_Initial_Window_State;  

    function "=" (A, B : X_Initial_Window_State) return Boolean renames H3."=";  

------------------------------------------------------------------------------  
-- X_Size_Hints_Flags - Argument flags for Property Size and Size hints  
--  
--      P_Aspect        - program specified min and max aspect ratios  
--      P_Resize_Inc    - program specified resize increments  
--      P_Max_Size      - program specified maximum size  
--      P_Min_Size      - program specified minimum size  
--      P_Size          - program specified size  
--      P_Position      - program specified position  
--      U_S_Size        - user specified width, height  
--      U_S_Position    - user specified x, y  
------------------------------------------------------------------------------  

    subtype X_Size_Hints_Flags_Index is H3.X_Size_Hints_Flags_Index;  
    subtype X_Size_Hints_Flags       is H3.X_Size_Hints_Flags;  

    P_Base_Size   : constant X_Size_Hints_Flags_Index := H3.P_Base_Size;  
    P_Win_Gravity : constant X_Size_Hints_Flags_Index := H3.P_Win_Gravity;  
    P_Aspect      : constant X_Size_Hints_Flags_Index := H3.P_Aspect;  
    P_Resize_Inc  : constant X_Size_Hints_Flags_Index := H3.P_Resize_Inc;  
    P_Max_Size    : constant X_Size_Hints_Flags_Index := H3.P_Max_Size;  
    P_Min_Size    : constant X_Size_Hints_Flags_Index := H3.P_Min_Size;  
    P_Size        : constant X_Size_Hints_Flags_Index := H3.P_Size;  
    P_Position    : constant X_Size_Hints_Flags_Index := H3.P_Position;  
    U_S_Size      : constant X_Size_Hints_Flags_Index := H3.U_S_Size;  
    U_S_Position  : constant X_Size_Hints_Flags_Index := H3.U_S_Position;  

    None_X_Size_Hints_Flags : X_Size_Hints_Flags  
        renames H3.None_X_Size_Hints_Flags;  

    function "="   (A, B : X_Size_Hints_Flags_Index) return Boolean  
        renames H3."=";  
    function "="   (A, B : X_Size_Hints_Flags) return Boolean renames H3."=";  
    function "and" (A, B : X_Size_Hints_Flags) return X_Size_Hints_Flags  
        renames H3."and";  
    function "or"  (A, B : X_Size_Hints_Flags) return X_Size_Hints_Flags  
        renames H3."or";  
    function "xor" (A, B : X_Size_Hints_Flags) return X_Size_Hints_Flags  
        renames H3."xor";  
    function "not" (A : X_Size_Hints_Flags) return X_Size_Hints_Flags  
        renames H3."not";  

------------------------------------------------------------------------------  
-- X_Size_Hints  
------------------------------------------------------------------------------  

    subtype X_Size_Hints is H3.X_Size_Hints;  

    None_X_Size_Hints : X_Size_Hints renames H3.None_X_Size_Hints;  

------------------------------------------------------------------------------  
-- X_Standard_Colormap - This defines a window manager property that  
-- clients may use to share standard color maps of type RGB_COLOR_MAP:  
------------------------------------------------------------------------------  

    subtype X_Standard_Colormap       is H3.X_Standard_Colormap;  
    subtype X_Standard_Colormap_Array is H3.X_Standard_Colormap_Array;  
    subtype X_Standard_Colormap_List  is H3.X_Standard_Colormap_List;  

    None_X_Standard_Colormap      : X_Standard_Colormap  
        renames H3.None_X_Standard_Colormap;  
    None_X_Standard_Colormap_List : X_Standard_Colormap_List  
        renames H3.None_X_Standard_Colormap_List;  

    function "=" (A, B : X_Standard_Colormap_List) return Boolean  
        renames H3."=";  

    procedure Free_X_Standard_Colormap_List  
                 (List : in out X_Standard_Colormap_List)  
        renames H3.Free_X_Standard_Colormap_List;  

------------------------------------------------------------------------------  
-- X_Text_Property - Structure for manipulating TEXT properties; used with  
-- Wm_Name, Wm_Icon_Name, Wm_Client_Machine, and Wm_Command.  
------------------------------------------------------------------------------  

    subtype X_Text_Property is H3.X_Text_Property;  

    None_X_Text_Property : X_Text_Property renames H3.None_X_Text_Property;  
    function "=" (A, B : X_Text_Property) return Boolean renames H3."=";  

------------------------------------------------------------------------------  
-- X_Wm_Hints_Flags - Argument flags for X_WM_Hints  
--  
--      Window_Group_Hint  
--      Icon_Mask_Hint  
--      Icon_Position_Hint  
--      Icon_Window_Hint  
--      Icon_Pixmap_Hint  
--      State_Hint  
--      Input_Hint  
------------------------------------------------------------------------------  

    subtype X_Wm_Hints_Flags_Index is H3.X_Wm_Hints_Flags_Index;  
    subtype X_Wm_Hints_Flags       is H3.X_Wm_Hints_Flags;  

    subtype Xwhfi is X_Wm_Hints_Flags_Index;  

    Window_Group_Hint  : constant Xwhfi := H3.Window_Group_Hint;  
    Icon_Mask_Hint     : constant Xwhfi := H3.Icon_Mask_Hint;  
    Icon_Position_Hint : constant Xwhfi := H3.Icon_Position_Hint;  
    Icon_Window_Hint   : constant Xwhfi := H3.Icon_Window_Hint;  
    Icon_Pixmap_Hint   : constant Xwhfi := H3.Icon_Pixmap_Hint;  
    State_Hint         : constant Xwhfi := H3.State_Hint;  
    Input_Hint         : constant Xwhfi := H3.Input_Hint;  

    None_X_Wm_Hints_Flags : X_Wm_Hints_Flags renames H3.None_X_Wm_Hints_Flags;  
    All_Hints             : X_Wm_Hints_Flags renames H3.All_Hints;  

    function "=" (A, B : X_Wm_Hints_Flags_Index) return Boolean renames H3."=";  
    function "=" (A, B : X_Wm_Hints_Flags)       return Boolean renames H3."=";  

------------------------------------------------------------------------------  
-- X_Wm_Hints - Window Manager Hints  
------------------------------------------------------------------------------  

    subtype X_Wm_Hints is H3.X_Wm_Hints;  

    None_X_Wm_Hints : X_Wm_Hints renames H3.None_X_Wm_Hints;  

end Xlbt_Hint;  

