with Xlbt_Key;  
use Xlbt_Key;  

package Xlbt_Key_Defs_Arabic is  
------------------------------------------------------------------------------  
-- X Library Key Symbol Definitions - Arabic  
--  
-- Xlbt_Key_Defs_Arabic - Definitions of the various pre-defined X Key Symbols  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
------------------------------------------------------------------------------  
--  Arabic  
--  Byte 3 = 5  
------------------------------------------------------------------------------  

    Xk_Arabic_Comma          : constant X_Key_Sym := 16#05AC#;  
    Xk_Arabic_Semicolon      : constant X_Key_Sym := 16#05BB#;  
    Xk_Arabic_Question_Mark  : constant X_Key_Sym := 16#05BF#;  
    Xk_Arabic_Hamza          : constant X_Key_Sym := 16#05C1#;  
    Xk_Arabic_Maddaonalef    : constant X_Key_Sym := 16#05C2#;  
    Xk_Arabic_Hamzaonalef    : constant X_Key_Sym := 16#05C3#;  
    Xk_Arabic_Hamzaonwaw     : constant X_Key_Sym := 16#05C4#;  
    Xk_Arabic_Hamzaunderalef : constant X_Key_Sym := 16#05C5#;  
    Xk_Arabic_Hamzaonyeh     : constant X_Key_Sym := 16#05C6#;  
    Xk_Arabic_Alef           : constant X_Key_Sym := 16#05C7#;  
    Xk_Arabic_Beh            : constant X_Key_Sym := 16#05C8#;  
    Xk_Arabic_Tehmarbuta     : constant X_Key_Sym := 16#05C9#;  
    Xk_Arabic_Teh            : constant X_Key_Sym := 16#05CA#;  
    Xk_Arabic_Theh           : constant X_Key_Sym := 16#05CB#;  
    Xk_Arabic_Jeem           : constant X_Key_Sym := 16#05CC#;  
    Xk_Arabic_Hah            : constant X_Key_Sym := 16#05CD#;  
    Xk_Arabic_Khah           : constant X_Key_Sym := 16#05CE#;  
    Xk_Arabic_Dal            : constant X_Key_Sym := 16#05CF#;  
    Xk_Arabic_Thal           : constant X_Key_Sym := 16#05D0#;  
    Xk_Arabic_Ra             : constant X_Key_Sym := 16#05D1#;  
    Xk_Arabic_Zain           : constant X_Key_Sym := 16#05D2#;  
    Xk_Arabic_Seen           : constant X_Key_Sym := 16#05D3#;  
    Xk_Arabic_Sheen          : constant X_Key_Sym := 16#05D4#;  
    Xk_Arabic_Sad            : constant X_Key_Sym := 16#05D5#;  
    Xk_Arabic_Dad            : constant X_Key_Sym := 16#05D6#;  
    Xk_Arabic_Tah            : constant X_Key_Sym := 16#05D7#;  
    Xk_Arabic_Zah            : constant X_Key_Sym := 16#05D8#;  
    Xk_Arabic_Ain            : constant X_Key_Sym := 16#05D9#;  
    Xk_Arabic_Ghain          : constant X_Key_Sym := 16#05DA#;  
    Xk_Arabic_Tatweel        : constant X_Key_Sym := 16#05E0#;  
    Xk_Arabic_Feh            : constant X_Key_Sym := 16#05E1#;  
    Xk_Arabic_Qaf            : constant X_Key_Sym := 16#05E2#;  
    Xk_Arabic_Kaf            : constant X_Key_Sym := 16#05E3#;  
    Xk_Arabic_Lam            : constant X_Key_Sym := 16#05E4#;  
    Xk_Arabic_Meem           : constant X_Key_Sym := 16#05E5#;  
    Xk_Arabic_Noon           : constant X_Key_Sym := 16#05E6#;  
    Xk_Arabic_Ha             : constant X_Key_Sym := 16#05E7#;  
    Xk_Arabic_Waw            : constant X_Key_Sym := 16#05E8#;  
    Xk_Arabic_Alefmaksura    : constant X_Key_Sym := 16#05E9#;  
    Xk_Arabic_Yeh            : constant X_Key_Sym := 16#05EA#;  
    Xk_Arabic_Fathatan       : constant X_Key_Sym := 16#05EB#;  
    Xk_Arabic_Dammatan       : constant X_Key_Sym := 16#05EC#;  
    Xk_Arabic_Kasratan       : constant X_Key_Sym := 16#05ED#;  
    Xk_Arabic_Fatha          : constant X_Key_Sym := 16#05EE#;  
    Xk_Arabic_Damma          : constant X_Key_Sym := 16#05EF#;  
    Xk_Arabic_Kasra          : constant X_Key_Sym := 16#05F0#;  
    Xk_Arabic_Shadda         : constant X_Key_Sym := 16#05F1#;  
    Xk_Arabic_Sukun          : constant X_Key_Sym := 16#05F2#;  
    Xk_Arabic_Switch         : constant X_Key_Sym := 16#FF7E#;  
--                                          -- Alias for mode_switch  

end Xlbt_Key_Defs_Arabic;  

