with Xlbt_Key;  
use Xlbt_Key;  

package Xlbt_Key_Defs_Cyrillic is  
------------------------------------------------------------------------------  
-- X Library Key Symbol Definitions - Cyrillic  
--  
-- Xlbt_Key_Defs_Cyrillic - Definitions of the various pre-defined X Key Symbols  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
------------------------------------------------------------------------------  
-- Cyrillic  
-- Byte 3 = 6  
------------------------------------------------------------------------------  

    Xk_Serbian_Dje           : constant X_Key_Sym := 16#06A1#; -- dje  
    Xk_Macedonia_Gje         : constant X_Key_Sym := 16#06A2#; -- gje  
    Xk_Cyrillic_Io           : constant X_Key_Sym := 16#06A3#; -- io  
    Xk_Ukrainian_Ie          : constant X_Key_Sym := 16#06A4#; -- je  
    Xk_Macedonia_Dse         : constant X_Key_Sym := 16#06A5#; -- dse  
    Xk_Ukrainian_I           : constant X_Key_Sym := 16#06A6#; -- i  
    Xk_Ukrainian_Yi          : constant X_Key_Sym := 16#06A7#; -- yi  
    Xk_Cyrillic_Je           : constant X_Key_Sym := 16#06A8#; -- je  
    Xk_Cyrillic_Lje          : constant X_Key_Sym := 16#06A9#; -- lje  
    Xk_Cyrillic_Nje          : constant X_Key_Sym := 16#06AA#; -- nje  
    Xk_Serbian_Tshe          : constant X_Key_Sym := 16#06AB#; -- tshe  
    Xk_Macedonia_Kje         : constant X_Key_Sym := 16#06AC#; -- kje  
    Xk_Byelorussian_Shortu   : constant X_Key_Sym := 16#06AE#; -- shortu  
    Xk_Cyrillic_Dzhe         : constant X_Key_Sym := 16#06AF#; -- dzhe  
    Xk_Numerosign            : constant X_Key_Sym := 16#06B0#; -- numerosign  
    Xk_Serbian_S_Dje         : constant X_Key_Sym := 16#06B1#; -- DJE  
    Xk_Macedonia_S_Gje       : constant X_Key_Sym := 16#06B2#; -- GJE  
    Xk_Cyrillic_S_Io         : constant X_Key_Sym := 16#06B3#; -- IO  
    Xk_Ukrainian_S_Ie        : constant X_Key_Sym := 16#06B4#; -- IE  
    Xk_Macedonia_S_Dse       : constant X_Key_Sym := 16#06B5#; -- DSE  
    Xk_Ukrainian_S_I         : constant X_Key_Sym := 16#06B6#; -- I  
    Xk_Ukrainian_S_Yi        : constant X_Key_Sym := 16#06B7#; -- YI  
    Xk_Cyrillic_S_Je         : constant X_Key_Sym := 16#06B8#; -- JE  
    Xk_Cyrillic_S_Lje        : constant X_Key_Sym := 16#06B9#; -- LJE  
    Xk_Cyrillic_S_Nje        : constant X_Key_Sym := 16#06BA#; -- NJE  
    Xk_Serbian_S_Tshe        : constant X_Key_Sym := 16#06BB#; -- TSHE  
    Xk_Macedonia_S_Kje       : constant X_Key_Sym := 16#06BC#; -- KJE  
    Xk_Byelorussian_S_Shortu : constant X_Key_Sym := 16#06BE#; -- SHORTU  
    Xk_Cyrillic_S_Dzhe       : constant X_Key_Sym := 16#06BF#; -- DZHE  
    Xk_Cyrillic_Yu           : constant X_Key_Sym := 16#06C0#; -- yu  
    Xk_Cyrillic_A            : constant X_Key_Sym := 16#06C1#; -- a  
    Xk_Cyrillic_Be           : constant X_Key_Sym := 16#06C2#; -- be  
    Xk_Cyrillic_Tse          : constant X_Key_Sym := 16#06C3#; -- tse  
    Xk_Cyrillic_De           : constant X_Key_Sym := 16#06C4#; -- de  
    Xk_Cyrillic_Ie           : constant X_Key_Sym := 16#06C5#; -- ie  
    Xk_Cyrillic_Ef           : constant X_Key_Sym := 16#06C6#; -- ef  
    Xk_Cyrillic_Ghe          : constant X_Key_Sym := 16#06C7#; -- ghe  
    Xk_Cyrillic_Ha           : constant X_Key_Sym := 16#06C8#; -- ha  
    Xk_Cyrillic_I            : constant X_Key_Sym := 16#06C9#; -- i  
    Xk_Cyrillic_Shorti       : constant X_Key_Sym := 16#06CA#; -- shorti  
    Xk_Cyrillic_Ka           : constant X_Key_Sym := 16#06CB#; -- ka  
    Xk_Cyrillic_El           : constant X_Key_Sym := 16#06CC#; -- el  
    Xk_Cyrillic_Em           : constant X_Key_Sym := 16#06CD#; -- em  
    Xk_Cyrillic_En           : constant X_Key_Sym := 16#06CE#; -- en  
    Xk_Cyrillic_O            : constant X_Key_Sym := 16#06CF#; -- o  
    Xk_Cyrillic_Pe           : constant X_Key_Sym := 16#06D0#; -- pe  
    Xk_Cyrillic_Ya           : constant X_Key_Sym := 16#06D1#; -- ya  
    Xk_Cyrillic_Er           : constant X_Key_Sym := 16#06D2#; -- er  
    Xk_Cyrillic_Es           : constant X_Key_Sym := 16#06D3#; -- es  
    Xk_Cyrillic_Te           : constant X_Key_Sym := 16#06D4#; -- te  
    Xk_Cyrillic_U            : constant X_Key_Sym := 16#06D5#; -- u  
    Xk_Cyrillic_Zhe          : constant X_Key_Sym := 16#06D6#; -- zhe  
    Xk_Cyrillic_Ve           : constant X_Key_Sym := 16#06D7#; -- ve  
    Xk_Cyrillic_Softsign     : constant X_Key_Sym := 16#06D8#; -- softsign  
    Xk_Cyrillic_Yeru         : constant X_Key_Sym := 16#06D9#; -- yeru  
    Xk_Cyrillic_Ze           : constant X_Key_Sym := 16#06DA#; -- ze  
    Xk_Cyrillic_Sha          : constant X_Key_Sym := 16#06DB#; -- sha  
    Xk_Cyrillic_E            : constant X_Key_Sym := 16#06DC#; -- e  
    Xk_Cyrillic_Shcha        : constant X_Key_Sym := 16#06DD#; -- shcha  
    Xk_Cyrillic_Che          : constant X_Key_Sym := 16#06DE#; -- che  
    Xk_Cyrillic_Hardsign     : constant X_Key_Sym := 16#06DF#; -- hardsign  
    Xk_Cyrillic_S_Yu         : constant X_Key_Sym := 16#06E0#; -- YU  
    Xk_Cyrillic_S_A          : constant X_Key_Sym := 16#06E1#; -- A  
    Xk_Cyrillic_S_Be         : constant X_Key_Sym := 16#06E2#; -- BE  
    Xk_Cyrillic_S_Tse        : constant X_Key_Sym := 16#06E3#; -- TSE  
    Xk_Cyrillic_S_De         : constant X_Key_Sym := 16#06E4#; -- DE  
    Xk_Cyrillic_S_Ie         : constant X_Key_Sym := 16#06E5#; -- IE  
    Xk_Cyrillic_S_Ef         : constant X_Key_Sym := 16#06E6#; -- EF  
    Xk_Cyrillic_S_Ghe        : constant X_Key_Sym := 16#06E7#; -- GHE  
    Xk_Cyrillic_S_Ha         : constant X_Key_Sym := 16#06E8#; -- HA  
    Xk_Cyrillic_S_I          : constant X_Key_Sym := 16#06E9#; -- I  
    Xk_Cyrillic_S_Shorti     : constant X_Key_Sym := 16#06EA#; -- SHORTI  
    Xk_Cyrillic_S_Ka         : constant X_Key_Sym := 16#06EB#; -- KA  
    Xk_Cyrillic_S_El         : constant X_Key_Sym := 16#06EC#; -- EL  
    Xk_Cyrillic_S_Em         : constant X_Key_Sym := 16#06ED#; -- EM  
    Xk_Cyrillic_S_En         : constant X_Key_Sym := 16#06EE#; -- EN  
    Xk_Cyrillic_S_O          : constant X_Key_Sym := 16#06EF#; -- O  
    Xk_Cyrillic_S_Pe         : constant X_Key_Sym := 16#06F0#; -- PE  
    Xk_Cyrillic_S_Ya         : constant X_Key_Sym := 16#06F1#; -- YA  
    Xk_Cyrillic_S_Er         : constant X_Key_Sym := 16#06F2#; -- ER  
    Xk_Cyrillic_S_Es         : constant X_Key_Sym := 16#06F3#; -- ES  
    Xk_Cyrillic_S_Te         : constant X_Key_Sym := 16#06F4#; -- TE  
    Xk_Cyrillic_S_U          : constant X_Key_Sym := 16#06F5#; -- U  
    Xk_Cyrillic_S_Zhe        : constant X_Key_Sym := 16#06F6#; -- ZHE  
    Xk_Cyrillic_S_Ve         : constant X_Key_Sym := 16#06F7#; -- VE  
    Xk_Cyrillic_S_Softsign   : constant X_Key_Sym := 16#06F8#; -- SOFTSIGN  
    Xk_Cyrillic_S_Yeru       : constant X_Key_Sym := 16#06F9#; -- YERU  
    Xk_Cyrillic_S_Ze         : constant X_Key_Sym := 16#06FA#; -- ZE  
    Xk_Cyrillic_S_Sha        : constant X_Key_Sym := 16#06FB#; -- SHA  
    Xk_Cyrillic_S_E          : constant X_Key_Sym := 16#06FC#; -- E  
    Xk_Cyrillic_S_Shcha      : constant X_Key_Sym := 16#06FD#; -- SHCHA  
    Xk_Cyrillic_S_Che        : constant X_Key_Sym := 16#06FE#; -- CHE  
    Xk_Cyrillic_S_Hardsign   : constant X_Key_Sym := 16#06FF#; -- HARDSIGN  

end Xlbt_Key_Defs_Cyrillic;  

