with Xlbt_Key;  
use Xlbt_Key;  

package Xlbt_Key_Defs_Greek is  
------------------------------------------------------------------------------  
-- X Library Key Symbol Definitions - Greek  
--  
-- Xlbt_Key_Defs_Greek - Definitions of the various pre-defined X Key Symbols  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
------------------------------------------------------------------------------  
-- Greek  
-- Byte 3 = 7  
------------------------------------------------------------------------------  

    Xk_Greek_S_Alphaaccent      : constant X_Key_Sym := 16#07A1#; -- ALPHA  
    Xk_Greek_S_Epsilonaccent    : constant X_Key_Sym := 16#07A2#; -- EPSILON  
    Xk_Greek_S_Etaaccent        : constant X_Key_Sym := 16#07A3#; -- ETA  
    Xk_Greek_S_Iotaaccent       : constant X_Key_Sym := 16#07A4#; -- IOTA  
    Xk_Greek_Iotadiaeresis      : constant X_Key_Sym := 16#07A5#;  
    Xk_Greek_S_Omicronaccent    : constant X_Key_Sym := 16#07A7#; -- OMICRON  
    Xk_Greek_S_Upsilonaccent    : constant X_Key_Sym := 16#07A8#; -- UPSILON  
    Xk_Greek_S_Upsilondieresis  : constant X_Key_Sym := 16#07A9#; -- UPSILON  
    Xk_Greek_S_Omegaaccent      : constant X_Key_Sym := 16#07AB#; -- OMEGA  
    Xk_Greek_Accentdieresis     : constant X_Key_Sym := 16#07AE#;  
    Xk_Greek_Horizbar           : constant X_Key_Sym := 16#07AF#;  
    Xk_Greek_Alphaaccent        : constant X_Key_Sym := 16#07B1#; -- alpha  
    Xk_Greek_Epsilonaccent      : constant X_Key_Sym := 16#07B2#; -- epsilon  
    Xk_Greek_Etaaccent          : constant X_Key_Sym := 16#07B3#; -- eta  
    Xk_Greek_Iotaaccent         : constant X_Key_Sym := 16#07B4#; -- iota  
    Xk_Greek_Iotadieresis       : constant X_Key_Sym := 16#07B5#;  
    Xk_Greek_Iotaaccentdieresis : constant X_Key_Sym := 16#07B6#;  
    Xk_Greek_Omicronaccent      : constant X_Key_Sym := 16#07B7#; -- omicron  
    Xk_Greek_Upsilonaccent      : constant X_Key_Sym := 16#07B8#; -- upsilon  
    Xk_Greek_Upsilondieresis    : constant X_Key_Sym := 16#07B9#; -- upsilon  
    Xk_Greek_Upsilonaccentdieresis  
        : constant X_Key_Sym                         := 16#07BA#; -- upsilon  
    Xk_Greek_Omegaaccent        : constant X_Key_Sym := 16#07BB#; -- omega  
    Xk_Greek_S_Alpha            : constant X_Key_Sym := 16#07C1#; -- ALPHA  
    Xk_Greek_S_Beta             : constant X_Key_Sym := 16#07C2#; -- BETA  
    Xk_Greek_S_Gamma            : constant X_Key_Sym := 16#07C3#; -- GAMMA  
    Xk_Greek_S_Delta            : constant X_Key_Sym := 16#07C4#; -- DELTA  
    Xk_Greek_S_Epsilon          : constant X_Key_Sym := 16#07C5#; -- EPSILON  
    Xk_Greek_S_Zeta             : constant X_Key_Sym := 16#07C6#; -- ZETA  
    Xk_Greek_S_Eta              : constant X_Key_Sym := 16#07C7#; -- ETA  
    Xk_Greek_S_Theta            : constant X_Key_Sym := 16#07C8#; -- THETA  
    Xk_Greek_S_Iota             : constant X_Key_Sym := 16#07C9#; -- IOTA  
    Xk_Greek_S_Kappa            : constant X_Key_Sym := 16#07CA#; -- KAPPA  
    Xk_Greek_S_Lambda           : constant X_Key_Sym := 16#07CB#; -- LAMBDA  
    Xk_Greek_S_Lamda            : constant X_Key_Sym := 16#07CB#; -- (alias)  
    Xk_Greek_S_Mu               : constant X_Key_Sym := 16#07CC#; -- MU  
    Xk_Greek_S_Nu               : constant X_Key_Sym := 16#07CD#; -- NU  
    Xk_Greek_S_Xi               : constant X_Key_Sym := 16#07CE#; -- XI  
    Xk_Greek_S_Omicron          : constant X_Key_Sym := 16#07CF#; -- OMICRON  
    Xk_Greek_S_Pi               : constant X_Key_Sym := 16#07D0#; -- PI  
    Xk_Greek_S_Rho              : constant X_Key_Sym := 16#07D1#; -- RHO  
    Xk_Greek_S_Sigma            : constant X_Key_Sym := 16#07D2#; -- SIGMA  
    Xk_Greek_S_Tau              : constant X_Key_Sym := 16#07D4#; -- TAU  
    Xk_Greek_S_Upsilon          : constant X_Key_Sym := 16#07D5#; -- UPSILON  
    Xk_Greek_S_Phi              : constant X_Key_Sym := 16#07D6#; -- PHI  
    Xk_Greek_S_Chi              : constant X_Key_Sym := 16#07D7#; -- CHI  
    Xk_Greek_S_Psi              : constant X_Key_Sym := 16#07D8#; -- PSI  
    Xk_Greek_S_Omega            : constant X_Key_Sym := 16#07D9#; -- OMEGA  
    Xk_Greek_Alpha              : constant X_Key_Sym := 16#07E1#; -- alpha  
    Xk_Greek_Beta               : constant X_Key_Sym := 16#07E2#; -- beta  
    Xk_Greek_Gamma              : constant X_Key_Sym := 16#07E3#; -- gamma  
    Xk_Greek_Delta              : constant X_Key_Sym := 16#07E4#; -- delta  
    Xk_Greek_Epsilon            : constant X_Key_Sym := 16#07E5#; -- epsilon  
    Xk_Greek_Zeta               : constant X_Key_Sym := 16#07E6#; -- zeta  
    Xk_Greek_Eta                : constant X_Key_Sym := 16#07E7#; -- eta  
    Xk_Greek_Theta              : constant X_Key_Sym := 16#07E8#; -- theta  
    Xk_Greek_Iota               : constant X_Key_Sym := 16#07E9#; -- iota  
    Xk_Greek_Kappa              : constant X_Key_Sym := 16#07EA#; -- kappa  
    Xk_Greek_Lambda             : constant X_Key_Sym := 16#07EB#; -- lambda  
    Xk_Greek_Lamda              : constant X_Key_Sym := 16#07EB#; -- (alias)  
    Xk_Greek_Mu                 : constant X_Key_Sym := 16#07EC#; -- mu  
    Xk_Greek_Nu                 : constant X_Key_Sym := 16#07ED#; -- nu  
    Xk_Greek_Xi                 : constant X_Key_Sym := 16#07EE#; -- xi  
    Xk_Greek_Omicron            : constant X_Key_Sym := 16#07EF#; -- omicron  
    Xk_Greek_Pi                 : constant X_Key_Sym := 16#07F0#; -- pi  
    Xk_Greek_Rho                : constant X_Key_Sym := 16#07F1#; -- rho  
    Xk_Greek_Sigma              : constant X_Key_Sym := 16#07F2#; -- sigma  
    Xk_Greek_Finalsmallsigma    : constant X_Key_Sym := 16#07F3#;  
    Xk_Greek_Tau                : constant X_Key_Sym := 16#07F4#; -- tau  
    Xk_Greek_Upsilon            : constant X_Key_Sym := 16#07F5#; -- upsilon  
    Xk_Greek_Phi                : constant X_Key_Sym := 16#07F6#; -- phi  
    Xk_Greek_Chi                : constant X_Key_Sym := 16#07F7#; -- chi  
    Xk_Greek_Psi                : constant X_Key_Sym := 16#07F8#; -- psi  
    Xk_Greek_Omega              : constant X_Key_Sym := 16#07F9#; -- omega  
    Xk_Greek_Switch             : constant X_Key_Sym := 16#FF7E#;  
    --                                              -- Alias for mode_switch  

end Xlbt_Key_Defs_Greek;  

