with Xlbt_Key;  
use Xlbt_Key;  

package Xlbt_Key_Defs_Hebrew is  
------------------------------------------------------------------------------  
-- X Library Key Symbol Definitions - Hebrew  
--  
-- Xlbt_Key_Defs_Hebrew - Definitions of the various pre-defined X Key Symbols  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
------------------------------------------------------------------------------  
-- Hebrew  
-- Byte 3 = c  
------------------------------------------------------------------------------  

    Xk_Hebrew_Doublelowline : constant X_Key_Sym := 16#0CDF#;  
    Xk_Hebrew_Aleph         : constant X_Key_Sym := 16#0CE0#;  
    Xk_Hebrew_Bet           : constant X_Key_Sym := 16#0CE1#;  
    Xk_Hebrew_Gimel         : constant X_Key_Sym := 16#0CE2#;  
    Xk_Hebrew_Dalet         : constant X_Key_Sym := 16#0CE3#;  
    Xk_Hebrew_He            : constant X_Key_Sym := 16#0CE4#;  
    Xk_Hebrew_Waw           : constant X_Key_Sym := 16#0CE5#;  
    Xk_Hebrew_Zain          : constant X_Key_Sym := 16#0CE6#;  
    Xk_Hebrew_Chet          : constant X_Key_Sym := 16#0CE7#;  
    Xk_Hebrew_Tet           : constant X_Key_Sym := 16#0CE8#;  
    Xk_Hebrew_Yod           : constant X_Key_Sym := 16#0CE9#;  
    Xk_Hebrew_Finalkaph     : constant X_Key_Sym := 16#0CEA#;  
    Xk_Hebrew_Kaph          : constant X_Key_Sym := 16#0CEB#;  
    Xk_Hebrew_Lamed         : constant X_Key_Sym := 16#0CEC#;  
    Xk_Hebrew_Finalmem      : constant X_Key_Sym := 16#0CED#;  
    Xk_Hebrew_Mem           : constant X_Key_Sym := 16#0CEE#;  
    Xk_Hebrew_Finalnun      : constant X_Key_Sym := 16#0CEF#;  
    Xk_Hebrew_Nun           : constant X_Key_Sym := 16#0CF0#;  
    Xk_Hebrew_Samech        : constant X_Key_Sym := 16#0CF1#;  
    Xk_Hebrew_Ayin          : constant X_Key_Sym := 16#0CF2#;  
    Xk_Hebrew_Finalpe       : constant X_Key_Sym := 16#0CF3#;  
    Xk_Hebrew_Pe            : constant X_Key_Sym := 16#0CF4#;  
    Xk_Hebrew_Finalzade     : constant X_Key_Sym := 16#0CF5#;  
    Xk_Hebrew_Zade          : constant X_Key_Sym := 16#0CF6#;  
    Xk_Hebrew_Goph          : constant X_Key_Sym := 16#0CF7#;  
    Xk_Hebrew_Resh          : constant X_Key_Sym := 16#0CF8#;  
    Xk_Hebrew_Shin          : constant X_Key_Sym := 16#0CF9#;  
    Xk_Hebrew_Taw           : constant X_Key_Sym := 16#0CFA#;  
    Xk_Hebrew_Switch        : constant X_Key_Sym := 16#FF7E#;  
    --                                              -- Alias for mode_switch  

end Xlbt_Key_Defs_Hebrew;  

