with Xlbt_Key;  
use Xlbt_Key;  

package Xlbt_Key_Defs_Katakana is  
------------------------------------------------------------------------------  
-- X Library Key Symbol Definitions - Katakana  
--  
-- Xlbt_Key_Defs_Katakana - Definitions of the various pre-defined X Key Symbols  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
------------------------------------------------------------------------------  
-- Katakana  
-- Byte 3 = 4  
------------------------------------------------------------------------------  

    Xk_Overline            : constant X_Key_Sym := 16#047E#;  
    Xk_Kana_Fullstop       : constant X_Key_Sym := 16#04A1#;  
    Xk_Kana_Openingbracket : constant X_Key_Sym := 16#04A2#;  
    Xk_Kana_Closingbracket : constant X_Key_Sym := 16#04A3#;  
    Xk_Kana_Comma          : constant X_Key_Sym := 16#04A4#;  
    Xk_Kana_Conjunctive    : constant X_Key_Sym := 16#04A5#;  
    Xk_Kana_Wo             : constant X_Key_Sym := 16#04A6#;  
    Xk_Kana_A              : constant X_Key_Sym := 16#04A7#; -- XK_kana_a  
    Xk_Kana_I              : constant X_Key_Sym := 16#04A8#; -- XK_kana_i  
    Xk_Kana_U              : constant X_Key_Sym := 16#04A9#; -- XK_kana_u  
    Xk_Kana_E              : constant X_Key_Sym := 16#04AA#; -- XK_kana_e  
    Xk_Kana_O              : constant X_Key_Sym := 16#04AB#; -- XK_kana_o  
    Xk_Kana_Ya             : constant X_Key_Sym := 16#04AC#; -- XK_kana_ya  
    Xk_Kana_Yu             : constant X_Key_Sym := 16#04AD#; -- XK_kana_yu  
    Xk_Kana_Yo             : constant X_Key_Sym := 16#04AE#; -- XK_kana_yo  
    Xk_Kana_Tsu            : constant X_Key_Sym := 16#04AF#; -- XK_kana_tsu  
    Xk_Prolongedsound      : constant X_Key_Sym := 16#04B0#;  
    Xk_Kana_S_A            : constant X_Key_Sym := 16#04B1#; -- XK_kana_A  
    Xk_Kana_S_I            : constant X_Key_Sym := 16#04B2#; -- XK_kana_I  
    Xk_Kana_S_U            : constant X_Key_Sym := 16#04B3#; -- XK_kana_U  
    Xk_Kana_S_E            : constant X_Key_Sym := 16#04B4#; -- XK_kana_E  
    Xk_Kana_S_O            : constant X_Key_Sym := 16#04B5#; -- XK_kana_O  
    Xk_Kana_Ka             : constant X_Key_Sym := 16#04B6#;  
    Xk_Kana_Ki             : constant X_Key_Sym := 16#04B7#;  
    Xk_Kana_Ku             : constant X_Key_Sym := 16#04B8#;  
    Xk_Kana_Ke             : constant X_Key_Sym := 16#04B9#;  
    Xk_Kana_Ko             : constant X_Key_Sym := 16#04BA#;  
    Xk_Kana_Sa             : constant X_Key_Sym := 16#04BB#;  
    Xk_Kana_Shi            : constant X_Key_Sym := 16#04BC#;  
    Xk_Kana_Su             : constant X_Key_Sym := 16#04BD#;  
    Xk_Kana_Se             : constant X_Key_Sym := 16#04BE#;  
    Xk_Kana_So             : constant X_Key_Sym := 16#04BF#;  
    Xk_Kana_Ta             : constant X_Key_Sym := 16#04C0#;  
    Xk_Kana_Chi            : constant X_Key_Sym := 16#04C1#;  
    Xk_Kana_S_Tsu          : constant X_Key_Sym := 16#04C2#; -- XK_kana_TSU  
    Xk_Kana_Te             : constant X_Key_Sym := 16#04C3#;  
    Xk_Kana_To             : constant X_Key_Sym := 16#04C4#;  
    Xk_Kana_Na             : constant X_Key_Sym := 16#04C5#;  
    Xk_Kana_Ni             : constant X_Key_Sym := 16#04C6#;  
    Xk_Kana_Nu             : constant X_Key_Sym := 16#04C7#;  
    Xk_Kana_Ne             : constant X_Key_Sym := 16#04C8#;  
    Xk_Kana_No             : constant X_Key_Sym := 16#04C9#;  
    Xk_Kana_Ha             : constant X_Key_Sym := 16#04CA#;  
    Xk_Kana_Hi             : constant X_Key_Sym := 16#04CB#;  
    Xk_Kana_Fu             : constant X_Key_Sym := 16#04CC#;  
    Xk_Kana_He             : constant X_Key_Sym := 16#04CD#;  
    Xk_Kana_Ho             : constant X_Key_Sym := 16#04CE#;  
    Xk_Kana_Ma             : constant X_Key_Sym := 16#04CF#;  
    Xk_Kana_Mi             : constant X_Key_Sym := 16#04D0#;  
    Xk_Kana_Mu             : constant X_Key_Sym := 16#04D1#;  
    Xk_Kana_Me             : constant X_Key_Sym := 16#04D2#;  
    Xk_Kana_Mo             : constant X_Key_Sym := 16#04D3#;  
    Xk_Kana_S_Ya           : constant X_Key_Sym := 16#04D4#; -- XK_kana_YA  
    Xk_Kana_S_Yu           : constant X_Key_Sym := 16#04D5#; -- XK_kana_YU  
    Xk_Kana_S_Yo           : constant X_Key_Sym := 16#04D6#; -- XK_kana_YO  
    Xk_Kana_Ra             : constant X_Key_Sym := 16#04D7#;  
    Xk_Kana_Ri             : constant X_Key_Sym := 16#04D8#;  
    Xk_Kana_Ru             : constant X_Key_Sym := 16#04D9#;  
    Xk_Kana_Re             : constant X_Key_Sym := 16#04DA#;  
    Xk_Kana_Ro             : constant X_Key_Sym := 16#04DB#;  
    Xk_Kana_Wa             : constant X_Key_Sym := 16#04DC#;  
    Xk_Kana_N              : constant X_Key_Sym := 16#04DD#;  
    Xk_Voicedsound         : constant X_Key_Sym := 16#04DE#;  
    Xk_Semivoicedsound     : constant X_Key_Sym := 16#04DF#;  
    Xk_Kana_Switch         : constant X_Key_Sym := 16#FF7E#;  
    --                                              --Alias for mode switch  

end Xlbt_Key_Defs_Katakana;  

