with Xlbt_Key;  
use Xlbt_Key;  

package Xlbt_Key_Defs_Latin1 is  
------------------------------------------------------------------------------  
-- X Library Key Symbol Definitions - Latin1  
--  
-- Xlbt_Key_Defs_Latin1 - Definitions of the various pre-defined X Key Symbols  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
------------------------------------------------------------------------------  
--  Latin 1  
--  Byte 3 = 0  
------------------------------------------------------------------------------  

    Xk_Space          : constant X_Key_Sym := 16#0020#;  
    Xk_Exclam         : constant X_Key_Sym := 16#0021#;  
    Xk_Quotedbl       : constant X_Key_Sym := 16#0022#;  
    Xk_Numbersign     : constant X_Key_Sym := 16#0023#;  
    Xk_Dollar         : constant X_Key_Sym := 16#0024#;  
    Xk_Percent        : constant X_Key_Sym := 16#0025#;  
    Xk_Ampersand      : constant X_Key_Sym := 16#0026#;  
    Xk_Apostrophe     : constant X_Key_Sym := 16#0027#;  
    Xk_Parenleft      : constant X_Key_Sym := 16#0028#;  
    Xk_Parenright     : constant X_Key_Sym := 16#0029#;  
    Xk_Asterisk       : constant X_Key_Sym := 16#002A#;  
    Xk_Plus           : constant X_Key_Sym := 16#002B#;  
    Xk_Comma          : constant X_Key_Sym := 16#002C#;  
    Xk_Minus          : constant X_Key_Sym := 16#002D#;  
    Xk_Period         : constant X_Key_Sym := 16#002E#;  
    Xk_Slash          : constant X_Key_Sym := 16#002F#;  
    Xk_0              : constant X_Key_Sym := 16#0030#;  
    Xk_1              : constant X_Key_Sym := 16#0031#;  
    Xk_2              : constant X_Key_Sym := 16#0032#;  
    Xk_3              : constant X_Key_Sym := 16#0033#;  
    Xk_4              : constant X_Key_Sym := 16#0034#;  
    Xk_5              : constant X_Key_Sym := 16#0035#;  
    Xk_6              : constant X_Key_Sym := 16#0036#;  
    Xk_7              : constant X_Key_Sym := 16#0037#;  
    Xk_8              : constant X_Key_Sym := 16#0038#;  
    Xk_9              : constant X_Key_Sym := 16#0039#;  
    Xk_Colon          : constant X_Key_Sym := 16#003A#;  
    Xk_Semicolon      : constant X_Key_Sym := 16#003B#;  
    Xk_Less           : constant X_Key_Sym := 16#003C#;  
    Xk_Equal          : constant X_Key_Sym := 16#003D#;  
    Xk_Greater        : constant X_Key_Sym := 16#003E#;  
    Xk_Question       : constant X_Key_Sym := 16#003F#;  
    Xk_At             : constant X_Key_Sym := 16#0040#;  
    Xk_S_A            : constant X_Key_Sym := 16#0041#; -- XK_A  
    Xk_S_B            : constant X_Key_Sym := 16#0042#; -- XK_B  
    Xk_S_C            : constant X_Key_Sym := 16#0043#; -- XK_C  
    Xk_S_D            : constant X_Key_Sym := 16#0044#; -- XK_D  
    Xk_S_E            : constant X_Key_Sym := 16#0045#; -- XK_E  
    Xk_S_F            : constant X_Key_Sym := 16#0046#; -- XK_F  
    Xk_S_G            : constant X_Key_Sym := 16#0047#; -- XK_G  
    Xk_S_H            : constant X_Key_Sym := 16#0048#; -- XK_H  
    Xk_S_I            : constant X_Key_Sym := 16#0049#; -- XK_I  
    Xk_S_J            : constant X_Key_Sym := 16#004A#; -- XK_J  
    Xk_S_K            : constant X_Key_Sym := 16#004B#; -- XK_K  
    Xk_S_L            : constant X_Key_Sym := 16#004C#; -- XK_L  
    Xk_S_M            : constant X_Key_Sym := 16#004D#; -- XK_M  
    Xk_S_N            : constant X_Key_Sym := 16#004E#; -- XK_N  
    Xk_S_O            : constant X_Key_Sym := 16#004F#; -- XK_O  
    Xk_S_P            : constant X_Key_Sym := 16#0050#; -- XK_P  
    Xk_S_Q            : constant X_Key_Sym := 16#0051#; -- XK_Q  
    Xk_S_R            : constant X_Key_Sym := 16#0052#; -- XK_R  
    Xk_S_S            : constant X_Key_Sym := 16#0053#; -- XK_S  
    Xk_S_T            : constant X_Key_Sym := 16#0054#; -- XK_T  
    Xk_S_U            : constant X_Key_Sym := 16#0055#; -- XK_U  
    Xk_S_V            : constant X_Key_Sym := 16#0056#; -- XK_V  
    Xk_S_W            : constant X_Key_Sym := 16#0057#; -- XK_W  
    Xk_S_X            : constant X_Key_Sym := 16#0058#; -- XK_X  
    Xk_S_Y            : constant X_Key_Sym := 16#0059#; -- XK_Y  
    Xk_S_Z            : constant X_Key_Sym := 16#005A#; -- XK_Z  
    Xk_Bracketleft    : constant X_Key_Sym := 16#005B#;  
    Xk_Backslash      : constant X_Key_Sym := 16#005C#;  
    Xk_Bracketright   : constant X_Key_Sym := 16#005D#;  
    Xk_Asciicircum    : constant X_Key_Sym := 16#005E#;  
    Xk_Underscore     : constant X_Key_Sym := 16#005F#;  
    Xk_Grave          : constant X_Key_Sym := 16#0060#;  
    Xk_A              : constant X_Key_Sym := 16#0061#; -- XK_a  
    Xk_B              : constant X_Key_Sym := 16#0062#; -- XK_b  
    Xk_C              : constant X_Key_Sym := 16#0063#; -- XK_c  
    Xk_D              : constant X_Key_Sym := 16#0064#; -- XK_d  
    Xk_E              : constant X_Key_Sym := 16#0065#; -- XK_e  
    Xk_F              : constant X_Key_Sym := 16#0066#; -- XK_f  
    Xk_G              : constant X_Key_Sym := 16#0067#; -- XK_g  
    Xk_H              : constant X_Key_Sym := 16#0068#; -- XK_h  
    Xk_I              : constant X_Key_Sym := 16#0069#; -- XK_i  
    Xk_J              : constant X_Key_Sym := 16#006A#; -- XK_j  
    Xk_K              : constant X_Key_Sym := 16#006B#; -- XK_k  
    Xk_L              : constant X_Key_Sym := 16#006C#; -- XK_l  
    Xk_M              : constant X_Key_Sym := 16#006D#; -- XK_m  
    Xk_N              : constant X_Key_Sym := 16#006E#; -- XK_n  
    Xk_O              : constant X_Key_Sym := 16#006F#; -- XK_o  
    Xk_P              : constant X_Key_Sym := 16#0070#; -- XK_p  
    Xk_Q              : constant X_Key_Sym := 16#0071#; -- XK_q  
    Xk_R              : constant X_Key_Sym := 16#0072#; -- XK_r  
    Xk_S              : constant X_Key_Sym := 16#0073#; -- XK_s  
    Xk_T              : constant X_Key_Sym := 16#0074#; -- XK_t  
    Xk_U              : constant X_Key_Sym := 16#0075#; -- XK_u  
    Xk_V              : constant X_Key_Sym := 16#0076#; -- XK_v  
    Xk_W              : constant X_Key_Sym := 16#0077#; -- XK_w  
    Xk_X              : constant X_Key_Sym := 16#0078#; -- XK_x  
    Xk_Y              : constant X_Key_Sym := 16#0079#; -- XK_y  
    Xk_Z              : constant X_Key_Sym := 16#007A#; -- XK_z  
    Xk_Braceleft      : constant X_Key_Sym := 16#007B#;  
    Xk_Bar            : constant X_Key_Sym := 16#007C#;  
    Xk_Braceright     : constant X_Key_Sym := 16#007D#;  
    Xk_Asciitilde     : constant X_Key_Sym := 16#007E#;  
    Xk_Nobreakspace   : constant X_Key_Sym := 16#00A0#;  
    Xk_Exclamdown     : constant X_Key_Sym := 16#00A1#;  
    Xk_Cent           : constant X_Key_Sym := 16#00A2#;  
    Xk_Sterling       : constant X_Key_Sym := 16#00A3#;  
    Xk_Currency       : constant X_Key_Sym := 16#00A4#;  
    Xk_Yen            : constant X_Key_Sym := 16#00A5#;  
    Xk_Brokenbar      : constant X_Key_Sym := 16#00A6#;  
    Xk_Section        : constant X_Key_Sym := 16#00A7#;  
    Xk_Diaeresis      : constant X_Key_Sym := 16#00A8#;  
    Xk_Copyright      : constant X_Key_Sym := 16#00A9#;  
    Xk_Ordfeminine    : constant X_Key_Sym := 16#00AA#;  
    Xk_Guillemotleft  : constant X_Key_Sym := 16#00AB#;--left angle quotemark  
    Xk_Notsign        : constant X_Key_Sym := 16#00AC#;  
    Xk_Hyphen         : constant X_Key_Sym := 16#00AD#;  
    Xk_Registered     : constant X_Key_Sym := 16#00AE#;  
    Xk_Macron         : constant X_Key_Sym := 16#00AF#;  
    Xk_Degree         : constant X_Key_Sym := 16#00B0#;  
    Xk_Plusminus      : constant X_Key_Sym := 16#00B1#;  
    Xk_Twosuperior    : constant X_Key_Sym := 16#00B2#;  
    Xk_Threesuperior  : constant X_Key_Sym := 16#00B3#;  
    Xk_Acute          : constant X_Key_Sym := 16#00B4#;  
    Xk_Mu             : constant X_Key_Sym := 16#00B5#;  
    Xk_Paragraph      : constant X_Key_Sym := 16#00B6#;  
    Xk_Periodcentered : constant X_Key_Sym := 16#00B7#;  
    Xk_Cedilla        : constant X_Key_Sym := 16#00B8#;  
    Xk_Onesuperior    : constant X_Key_Sym := 16#00B9#;  
    Xk_Masculine      : constant X_Key_Sym := 16#00BA#;  
    Xk_Guillemotright : constant X_Key_Sym :=  
       16#00BB#; -- right angle quot. mark  
    Xk_Onequarter     : constant X_Key_Sym := 16#00BC#;  
    Xk_Onehalf        : constant X_Key_Sym := 16#00BD#;  
    Xk_Threequarters  : constant X_Key_Sym := 16#00BE#;  
    Xk_Questiondown   : constant X_Key_Sym := 16#00BF#;  
    Xk_S_Agrave       : constant X_Key_Sym := 16#00C0#; -- XK_Agrave  
    Xk_S_Aacute       : constant X_Key_Sym := 16#00C1#; -- XK_Aacute  
    Xk_S_Acircumflex  : constant X_Key_Sym := 16#00C2#; -- XK_Acircumflex  
    Xk_S_Atilde       : constant X_Key_Sym := 16#00C3#; -- XK_Atilde  
    Xk_S_Adiaeresis   : constant X_Key_Sym := 16#00C4#; -- XK_Adiaeresis  
    Xk_S_Aring        : constant X_Key_Sym := 16#00C5#; -- XK_Aring  
    Xk_S_Ae           : constant X_Key_Sym := 16#00C6#; -- XK_AE  
    Xk_S_Ccedilla     : constant X_Key_Sym := 16#00C7#; -- XK_Ccedilla  
    Xk_S_Egrave       : constant X_Key_Sym := 16#00C8#; -- XK_Egrave  
    Xk_S_Eacute       : constant X_Key_Sym := 16#00C9#; -- XK_Eacute  
    Xk_S_Ecircumflex  : constant X_Key_Sym := 16#00CA#; -- XK_Ecircumflex  
    Xk_S_Ediaeresis   : constant X_Key_Sym := 16#00CB#; -- XK_Ediaeresis  
    Xk_S_Igrave       : constant X_Key_Sym := 16#00CC#; -- XK_Igrave  
    Xk_S_Iacute       : constant X_Key_Sym := 16#00CD#; -- XK_Iacute  
    Xk_S_Icircumflex  : constant X_Key_Sym := 16#00CE#; -- XK_Icircumflex  
    Xk_S_Idiaeresis   : constant X_Key_Sym := 16#00CF#; -- XK_Idiaeresis  
    Xk_S_Eth          : constant X_Key_Sym := 16#00D0#; -- XK_Eth  
    Xk_S_Ntilde       : constant X_Key_Sym := 16#00D1#; -- XK_Ntilde  
    Xk_S_Ograve       : constant X_Key_Sym := 16#00D2#; -- XK_Ograve  
    Xk_S_Oacute       : constant X_Key_Sym := 16#00D3#; -- XK_Oacute  
    Xk_S_Ocircumflex  : constant X_Key_Sym := 16#00D4#; -- XK_Ocircumflex  
    Xk_S_Otilde       : constant X_Key_Sym := 16#00D5#; -- XK_Otilde  
    Xk_S_Odiaeresis   : constant X_Key_Sym := 16#00D6#; -- XK_Odiaeresis  
    Xk_Multiply       : constant X_Key_Sym := 16#00D7#; -- XK_multiply  
    Xk_Ooblique       : constant X_Key_Sym := 16#00D8#; -- XK_Ooblique  
    Xk_S_Ugrave       : constant X_Key_Sym := 16#00D9#; -- XK_Ugrave  
    Xk_S_Uacute       : constant X_Key_Sym := 16#00DA#; -- XK_Uacute  
    Xk_S_Ucircumflex  : constant X_Key_Sym := 16#00DB#; -- XK_Ucircumflex  
    Xk_S_Udiaeresis   : constant X_Key_Sym := 16#00DC#; -- XK_Udiaeresis  
    Xk_S_Yacute       : constant X_Key_Sym := 16#00DD#; -- XK_Yacute  
    Xk_S_Thorn        : constant X_Key_Sym := 16#00DE#; -- XK_Thorn  
    Xk_Ssharp         : constant X_Key_Sym := 16#00DF#; -- XK_ssharp  
    Xk_Agrave         : constant X_Key_Sym := 16#00E0#; -- XK_agrave  
    Xk_Aacute         : constant X_Key_Sym := 16#00E1#; -- XK_aacute  
    Xk_Acircumflex    : constant X_Key_Sym := 16#00E2#; -- XK_acircumflex  
    Xk_Atilde         : constant X_Key_Sym := 16#00E3#; -- XK_atilde  
    Xk_Adiaeresis     : constant X_Key_Sym := 16#00E4#; -- XK_adiaeresis  
    Xk_Aring          : constant X_Key_Sym := 16#00E5#; -- XK_aring  
    Xk_Ae             : constant X_Key_Sym := 16#00E6#; -- XK_ae  
    Xk_Ccedilla       : constant X_Key_Sym := 16#00E7#; -- XK_ccedilla  
    Xk_Egrave         : constant X_Key_Sym := 16#00E8#; -- XK_egrave  
    Xk_Eacute         : constant X_Key_Sym := 16#00E9#; -- XK_eacute  
    Xk_Ecircumflex    : constant X_Key_Sym := 16#00EA#; -- XK_ecircumflex  
    Xk_Ediaeresis     : constant X_Key_Sym := 16#00EB#; -- XK_ediaeresis  
    Xk_Igrave         : constant X_Key_Sym := 16#00EC#; -- XK_igrave  
    Xk_Iacute         : constant X_Key_Sym := 16#00ED#; -- XK_iacute  
    Xk_Icircumflex    : constant X_Key_Sym := 16#00EE#; -- XK_icircumflex  
    Xk_Idiaeresis     : constant X_Key_Sym := 16#00EF#; -- XK_idiaeresis  
    Xk_Eth            : constant X_Key_Sym := 16#00F0#; -- XK_eth  
    Xk_Ntilde         : constant X_Key_Sym := 16#00F1#; -- XK_ntilde  
    Xk_Ograve         : constant X_Key_Sym := 16#00F2#; -- XK_ograve  
    Xk_Oacute         : constant X_Key_Sym := 16#00F3#; -- XK_oacute  
    Xk_Ocircumflex    : constant X_Key_Sym := 16#00F4#; -- XK_ocircumflex  
    Xk_Otilde         : constant X_Key_Sym := 16#00F5#; -- XK_otilde  
    Xk_Odiaeresis     : constant X_Key_Sym := 16#00F6#; -- XK_odiaeresis  
    Xk_Division       : constant X_Key_Sym := 16#00F7#; -- XK_division  
    Xk_Oslash         : constant X_Key_Sym := 16#00F8#; -- XK_oslash  
    Xk_Ugrave         : constant X_Key_Sym := 16#00F9#; -- XK_ugrave  
    Xk_Uacute         : constant X_Key_Sym := 16#00FA#; -- XK_uacute  
    Xk_Ucircumflex    : constant X_Key_Sym := 16#00FB#; -- XK_ucircumflex  
    Xk_Udiaeresis     : constant X_Key_Sym := 16#00FC#; -- XK_udiaeresis  
    Xk_Yacute         : constant X_Key_Sym := 16#00FD#; -- XK_yacute  
    Xk_Thorn          : constant X_Key_Sym := 16#00FE#; -- XK_thorn  
    Xk_Ydiaeresis     : constant X_Key_Sym := 16#00FF#; -- XK_ydiaeresis  

end Xlbt_Key_Defs_Latin1;  

