with Xlbt_Key;  
use Xlbt_Key;  

package Xlbt_Key_Defs_Technical is  
------------------------------------------------------------------------------  
-- X Library Key Symbol Definitions - Technical  
--  
-- Xlbt_Key_Defs_Technical - Definitions of the various pre-defined X Key Symbols  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
------------------------------------------------------------------------------  
-- Technical  
-- Byte 3 = 8  
------------------------------------------------------------------------------  

    Xk_Leftradical               : constant X_Key_Sym := 16#08A1#;  
    Xk_Topleftradical            : constant X_Key_Sym := 16#08A2#;  
    Xk_Horizconnector            : constant X_Key_Sym := 16#08A3#;  
    Xk_Topintegral               : constant X_Key_Sym := 16#08A4#;  
    Xk_Botintegral               : constant X_Key_Sym := 16#08A5#;  
    Xk_Vertconnector             : constant X_Key_Sym := 16#08A6#;  
    Xk_Topleftsqbracket          : constant X_Key_Sym := 16#08A7#;  
    Xk_Botleftsqbracket          : constant X_Key_Sym := 16#08A8#;  
    Xk_Toprightsqbracket         : constant X_Key_Sym := 16#08A9#;  
    Xk_Botrightsqbracket         : constant X_Key_Sym := 16#08AA#;  
    Xk_Topleftparens             : constant X_Key_Sym := 16#08AB#;  
    Xk_Botleftparens             : constant X_Key_Sym := 16#08AC#;  
    Xk_Toprightparens            : constant X_Key_Sym := 16#08AD#;  
    Xk_Botrightparens            : constant X_Key_Sym := 16#08AE#;  
    Xk_Leftmiddlecurlybrace      : constant X_Key_Sym := 16#08AF#;  
    Xk_Rightmiddlecurlybrace     : constant X_Key_Sym := 16#08B0#;  
    Xk_Topleftsummation          : constant X_Key_Sym := 16#08B1#;  
    Xk_Botleftsummation          : constant X_Key_Sym := 16#08B2#;  
    Xk_Topvertsummationconnector : constant X_Key_Sym := 16#08B3#;  
    Xk_Botvertsummationconnector : constant X_Key_Sym := 16#08B4#;  
    Xk_Toprightsummation         : constant X_Key_Sym := 16#08B5#;  
    Xk_Botrightsummation         : constant X_Key_Sym := 16#08B6#;  
    Xk_Rightmiddlesummation      : constant X_Key_Sym := 16#08B7#;  
    Xk_Lessthanequal             : constant X_Key_Sym := 16#08BC#;  
    Xk_Notequal                  : constant X_Key_Sym := 16#08BD#;  
    Xk_Greaterthanequal          : constant X_Key_Sym := 16#08BE#;  
    Xk_Integral                  : constant X_Key_Sym := 16#08BF#;  
    Xk_Therefore                 : constant X_Key_Sym := 16#08C0#;  
    Xk_Variation                 : constant X_Key_Sym := 16#08C1#;  
    Xk_Infinity                  : constant X_Key_Sym := 16#08C2#;  
    Xk_Nabla                     : constant X_Key_Sym := 16#08C5#;  
    Xk_Approximate               : constant X_Key_Sym := 16#08C8#;  
    Xk_Similarequal              : constant X_Key_Sym := 16#08C9#;  
    Xk_Ifonlyif                  : constant X_Key_Sym := 16#08CD#;  
    Xk_Implies                   : constant X_Key_Sym := 16#08CE#;  
    Xk_Identical                 : constant X_Key_Sym := 16#08CF#;  
    Xk_Radical                   : constant X_Key_Sym := 16#08D6#;  
    Xk_Includedin                : constant X_Key_Sym := 16#08DA#;  
    Xk_Includes                  : constant X_Key_Sym := 16#08DB#;  
    Xk_Intersection              : constant X_Key_Sym := 16#08DC#;  
    Xk_Union                     : constant X_Key_Sym := 16#08DD#;  
    Xk_Logicaland                : constant X_Key_Sym := 16#08DE#;  
    Xk_Logicalor                 : constant X_Key_Sym := 16#08DF#;  
    Xk_Partialderivative         : constant X_Key_Sym := 16#08EF#;  
    Xk_Function                  : constant X_Key_Sym := 16#08F6#;  
    Xk_Leftarrow                 : constant X_Key_Sym := 16#08FB#;  
    Xk_Uparrow                   : constant X_Key_Sym := 16#08FC#;  
    Xk_Rightarrow                : constant X_Key_Sym := 16#08FD#;  
    Xk_Downarrow                 : constant X_Key_Sym := 16#08FE#;  

end Xlbt_Key_Defs_Technical;  

