with Xlbt_Keyboard3;  

package Xlbt_Keyboard is  
------------------------------------------------------------------------------  
-- X Library Keyboard Structures  
--  
-- Xlbt_Keyboard - Structures dealing with the keyboard as a unit  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
    package K3 renames Xlbt_Keyboard3;  

------------------------------------------------------------------------------  
-- X_Auto_Repeat_Mode  
--  
--      Auto_Repeat_Mode_Off  
--      Auto_Repeat_Mode_On  
--      Auto_Repeat_Mode_Default  
------------------------------------------------------------------------------  

    subtype X_Auto_Repeat_Mode is K3.X_Auto_Repeat_Mode;  

    Auto_Repeat_Mode_Off     : constant X_Auto_Repeat_Mode  
        := K3.Auto_Repeat_Mode_Off;  
    Auto_Repeat_Mode_On      : constant X_Auto_Repeat_Mode  
        := K3.Auto_Repeat_Mode_On;  
    Auto_Repeat_Mode_Default : constant X_Auto_Repeat_Mode  
        := K3.Auto_Repeat_Mode_Default;  

    None_X_Auto_Repeat_Mode : X_Auto_Repeat_Mode  
        renames K3.None_X_Auto_Repeat_Mode;  

    function "=" (A, B : X_Auto_Repeat_Mode) return Boolean renames K3."=";  

------------------------------------------------------------------------------  
-- X_Keyboard_As_Bits - key presence indicated by a 1 bit  
------------------------------------------------------------------------------  

    subtype X_Keyboard_As_Bits is K3.X_Keyboard_As_Bits;  

    subtype X_Keyboard_As_Bits_Short is K3.X_Keyboard_As_Bits_Short;  


    None_X_Keyboard_As_Bits : X_Keyboard_As_Bits  
        renames K3.None_X_Keyboard_As_Bits;  

------------------------------------------------------------------------------  
-- X_Keyboard_Control_Flags  
--  
--      Kb_Auto_Repeat_Mode  
--      Kb_Key  
--      Kb_Led_Mode  
--      Kb_Led  
--      Kb_Bell_Duration  
--      Kb_Bell_Pitch  
--      Kb_Bell_Percent  
--      Kb_Key_Click_Percent  
------------------------------------------------------------------------------  

    subtype X_Keyboard_Control_Flags_Index is K3.X_Keyboard_Control_Flags_Index;  
    subtype X_Keyboard_Control_Flags       is K3.X_Keyboard_Control_Flags;  

    subtype Xkcfi is K3.X_Keyboard_Control_Flags_Index;  

    Kb_Auto_Repeat_Mode  : constant Xkcfi := K3.Kb_Auto_Repeat_Mode;  
    Kb_Key               : constant Xkcfi := K3.Kb_Key;  
    Kb_Led_Mode          : constant Xkcfi := K3.Kb_Led_Mode;  
    Kb_Led               : constant Xkcfi := K3.Kb_Led;  
    Kb_Bell_Duration     : constant Xkcfi := K3.Kb_Bell_Duration;  
    Kb_Bell_Pitch        : constant Xkcfi := K3.Kb_Bell_Pitch;  
    Kb_Bell_Percent      : constant Xkcfi := K3.Kb_Bell_Percent;  
    Kb_Key_Click_Percent : constant Xkcfi := K3.Kb_Key_Click_Percent;  

    None_X_Keyboard_Control_Flags : X_Keyboard_Control_Flags renames  
       K3.None_X_Keyboard_Control_Flags;  

    function "=" (A, B : X_Keyboard_Control_Flags_Index) return Boolean  
        renames K3."=";  
    function "=" (A, B : X_Keyboard_Control_Flags)       return Boolean  
        renames K3."=";  

------------------------------------------------------------------------------  
-- X_Keyboard_Control  
------------------------------------------------------------------------------  

    subtype X_Keyboard_Control is K3.X_Keyboard_Control;  

------------------------------------------------------------------------------  
-- X_Keyboard_State  
------------------------------------------------------------------------------  

    subtype X_Keyboard_State is K3.X_Keyboard_State;  
    None_X_Keyboard_State : X_Keyboard_State renames K3.None_X_Keyboard_State;  

------------------------------------------------------------------------------  
-- X_Led_Bits - One bit for each possible keyboard led.  
------------------------------------------------------------------------------  

    subtype X_Led_Bits_Index is K3.X_Led_Bits_Index;  
    subtype X_Led_Bits       is K3.X_Led_Bits;  

    Led31 : constant X_Led_Bits_Index := K3.Led31;  
    Led30 : constant X_Led_Bits_Index := K3.Led30;  
    Led29 : constant X_Led_Bits_Index := K3.Led29;  
    Led28 : constant X_Led_Bits_Index := K3.Led28;  
    Led27 : constant X_Led_Bits_Index := K3.Led27;  
    Led26 : constant X_Led_Bits_Index := K3.Led26;  
    Led25 : constant X_Led_Bits_Index := K3.Led25;  
    Led24 : constant X_Led_Bits_Index := K3.Led24;  
    Led23 : constant X_Led_Bits_Index := K3.Led23;  
    Led22 : constant X_Led_Bits_Index := K3.Led22;  
    Led21 : constant X_Led_Bits_Index := K3.Led21;  
    Led20 : constant X_Led_Bits_Index := K3.Led20;  
    Led19 : constant X_Led_Bits_Index := K3.Led19;  
    Led18 : constant X_Led_Bits_Index := K3.Led18;  
    Led17 : constant X_Led_Bits_Index := K3.Led17;  
    Led16 : constant X_Led_Bits_Index := K3.Led16;  
    Led15 : constant X_Led_Bits_Index := K3.Led15;  
    Led14 : constant X_Led_Bits_Index := K3.Led14;  
    Led13 : constant X_Led_Bits_Index := K3.Led13;  
    Led12 : constant X_Led_Bits_Index := K3.Led12;  
    Led11 : constant X_Led_Bits_Index := K3.Led11;  
    Led10 : constant X_Led_Bits_Index := K3.Led10;  
    Led09 : constant X_Led_Bits_Index := K3.Led09;  
    Led08 : constant X_Led_Bits_Index := K3.Led08;  
    Led07 : constant X_Led_Bits_Index := K3.Led07;  
    Led06 : constant X_Led_Bits_Index := K3.Led06;  
    Led05 : constant X_Led_Bits_Index := K3.Led05;  
    Led04 : constant X_Led_Bits_Index := K3.Led04;  
    Led03 : constant X_Led_Bits_Index := K3.Led03;  
    Led02 : constant X_Led_Bits_Index := K3.Led02;  
    Led01 : constant X_Led_Bits_Index := K3.Led01;  
    Led00 : constant X_Led_Bits_Index := K3.Led00;  

    None_X_Led_Bits : X_Led_Bits renames K3.None_X_Led_Bits;  

    function "=" (A, B : X_Led_Bits_Index) return Boolean renames K3."=";  
    function "=" (A, B : X_Led_Bits)       return Boolean renames K3."=";  

------------------------------------------------------------------------------  
-- LED's On/Off  
------------------------------------------------------------------------------  

    subtype X_Led_Mode is K3.X_Led_Mode;  

    Led_Mode_Off : constant X_Led_Mode := K3.Led_Mode_Off;  
    Led_Mode_On  : constant X_Led_Mode := K3.Led_Mode_On;  

    None_X_Led_Mode : X_Led_Mode renames K3.None_X_Led_Mode;  

    function "=" (A, B : X_Led_Mode) return Boolean renames K3."=";  

------------------------------------------------------------------------------  
-- X_Mapping_Status  
------------------------------------------------------------------------------  

    subtype X_Mapping_Status is K3.X_Mapping_Status;  

    Mapping_Success : constant X_Mapping_Status := K3.Mapping_Success;  
    Mapping_Busy    : constant X_Mapping_Status := K3.Mapping_Busy;  
    Mapping_Failed  : constant X_Mapping_Status := K3.Mapping_Failed;  

    function "=" (A, B : X_Mapping_Status) return Boolean renames K3."=";  

------------------------------------------------------------------------------  
-- Percentages  
------------------------------------------------------------------------------  

    subtype S_Percent is K3.S_Percent;  -- -100..+100  

end Xlbt_Keyboard;  

