with Unchecked_Deallocation;  

with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  
with Xlbt_Basic3;  
use Xlbt_Basic3;  

--/ if Record_Rep_Clauses then  
with Xlbmt_Parameters;  
use Xlbmt_Parameters;  
--/ end if;  

package Xlbt_Pointer is  
------------------------------------------------------------------------------  
-- X Library Pointer/Mouse Structures  
--  
-- Xlbt_Pointer - Structures dealing with the pointer or mouse  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
------------------------------------------------------------------------------  
-- X_Button_Name.  Used as arguments to Grab_Button and as detail in  
-- Button_Press and Button_Release events.  Not to be confused with button  
-- masks.  Note that the 0'th is already defined in the masks as "Any_Button".  
------------------------------------------------------------------------------  

    type X_Button_Name is  
       (Any_Button, -- special Button Code, passed to Grab_Button  
        Button_1,  
        Button_2,  
        Button_3,  
        Button_4,  
        Button_5);  

--/ if Length_Clauses then  
    for X_Button_Name'Size use 8;  
--/ end if;  

    None_X_Button_Name : constant X_Button_Name := X_Button_Name'Val (0);  

------------------------------------------------------------------------------  
-- X_Time_Coord - Data structure for X_Get_Motion_Events.  
------------------------------------------------------------------------------  

    type X_Time_Coord is  
        record  
            Time : X_Time;  
            X    : U_Short;  
            Y    : U_Short;  
        end record;  

--/ if Length_Clauses then  
    for X_Time_Coord'Size use 2 * 32;  
--/ end if;  

--/ if Record_Rep_Clauses then  
 
    for X_Time_Coord use  
        record  
            Time at 0 * X_Word range X_Word0a .. X_Word0b;  
            X    at 1 * X_Word range X_Half0a .. X_Half0b;  
            Y    at 1 * X_Word range X_Half1a .. X_Half1b;  
        end record;  
 
--/ end if;  

    type X_Time_Coord_Array is array (S_Natural range <>) of X_Time_Coord;  
    type X_Time_Coord_List  is access X_Time_Coord_Array;  

    None_X_Time_Coord      : constant X_Time_Coord      := (0, 0, 0);  
    None_X_Time_Coord_List : constant X_Time_Coord_List := null;  

    procedure Free_X_Time_Coord_List is  
       new Unchecked_Deallocation (X_Time_Coord_Array,  
                                   X_Time_Coord_List);  

--/ if Enable_Deallocation then  
    pragma Enable_Deallocation (X_Time_Coord_List);  
--/ end if;  

end Xlbt_Pointer;  

