with Unchecked_Deallocation;  

with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  

package body Xlbt_Region3 is  
------------------------------------------------------------------------------  
-- X Library Regions  
--  
-- Xlbt_Region2 - Structures for working with regions of images/screens/windows  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1987 - 1989 by Digital Equipment Corporation, Maynard, Mass.  
-- Copyright 1987 - 1989 by Massachusetts Institute of Technology,  
--                          Cambridge, Massachusetts.  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of Digital, MIT, or Rational  
-- not be used in advertising or publicity pertaining to distribution of  
-- the software without specific, written prior permission.  
--  
-- Digital, MIT, and Rational disclaim all warranties with regard to this  
-- software, including all implied warranties of merchantability and fitness,  
-- in no event shall Digital, MIT, or Rational be liable for any special,  
-- indirect or consequential damages or any damages whatsoever resulting from  
-- loss of use, data or profits, whether in an action of contract, negligence  
-- or other tortious action, arising out of or in connection with the use or  
-- performance of this software.  
------------------------------------------------------------------------------  

--
    procedure Heap_Free_X_Region is new Unchecked_Deallocation (X_Region_Rec,  
                                                                X_Region);  

--
    procedure Free_X_Region (Region : in out X_Region) is  
    begin  

        if Region = None_X_Region then  
            return;  
        end if;  
        Free_X_Box_List (Region.Rects);  
        Heap_Free_X_Region (Region);  

    end Free_X_Region;  

--
end Xlbt_Region3;  

