with Xlbt_Reply3;  

package Xlbt_Reply is  
------------------------------------------------------------------------------  
-- X Library Protocol Reply Packets - Normal User Interface  
--  
-- Xlbt_Reply - Record definitions of the protocol reply packets  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
    package R3 renames Xlbt_Reply3;  

------------------------------------------------------------------------------  
-- X_Reply_Contents - Can hold any reply record type  
------------------------------------------------------------------------------  

    subtype X_Reply_Contents is R3.X_Reply_Contents;  

------------------------------------------------------------------------------  
-- Reply Record Structures  
------------------------------------------------------------------------------  

    subtype X_Alloc_Color_Reply              is R3.X_Alloc_Color_Reply;  
    subtype X_Alloc_Color_Cells_Reply        is R3.X_Alloc_Color_Cells_Reply;  
    subtype X_Alloc_Color_Planes_Reply       is R3.X_Alloc_Color_Planes_Reply;  
    subtype X_Alloc_Named_Color_Reply        is R3.X_Alloc_Named_Color_Reply;  
    subtype X_Get_Atom_Name_Reply            is R3.X_Get_Atom_Name_Reply;  
    subtype X_Get_Font_Path_Reply            is R3.X_Get_Font_Path_Reply;  
    subtype X_Get_Geometry_Reply             is R3.X_Get_Geometry_Reply;  
    subtype X_Get_Image_Reply                is R3.X_Get_Image_Reply;  
    subtype X_Get_Input_Focus_Reply          is R3.X_Get_Input_Focus_Reply;  
    subtype X_Get_Keyboard_Control_Reply     is R3.X_Get_Keyboard_Control_Reply;  
    subtype X_Get_Keyboard_Mapping_Reply     is R3.X_Get_Keyboard_Mapping_Reply;  
    subtype X_Get_Modifier_Mapping_Reply     is R3.X_Get_Modifier_Mapping_Reply;  
    subtype X_Get_Motion_Events_Reply        is R3.X_Get_Motion_Events_Reply;  
    subtype X_Get_Pointer_Control_Reply      is R3.X_Get_Pointer_Control_Reply;  
    subtype X_Get_Pointer_Mapping_Reply      is R3.X_Get_Pointer_Mapping_Reply;  
    subtype X_Get_Property_Reply             is R3.X_Get_Property_Reply;  
    subtype X_Get_Screen_Saver_Reply         is R3.X_Get_Screen_Saver_Reply;  
    subtype X_Get_Selection_Owner_Reply      is R3.X_Get_Selection_Owner_Reply;  
    subtype X_Get_Window_Attributes_Reply    is  
       R3.X_Get_Window_Attributes_Reply;  
    subtype X_Grab_Keyboard_Reply            is R3.X_Grab_Keyboard_Reply;  
    subtype X_Grab_Pointer_Reply             is R3.X_Grab_Pointer_Reply;  
    subtype X_Intern_Atom_Reply              is R3.X_Intern_Atom_Reply;  
    subtype X_List_Extensions_Reply          is R3.X_List_Extensions_Reply;  
    subtype X_List_Fonts_Reply               is R3.X_List_Fonts_Reply;  
    subtype X_List_Fonts_With_Info_Reply     is  
       R3.X_List_Fonts_With_Info_Reply;  
    subtype X_List_Hosts_Reply               is R3.X_List_Hosts_Reply;  
    subtype X_Wire_Host_Reply                is R3.X_Wire_Host_Reply;  
    subtype X_List_Installed_Colormaps_Reply is  
       R3.X_List_Installed_Colormaps_Reply;  
    subtype X_List_Properties_Reply          is R3.X_List_Properties_Reply;  
    subtype X_Lookup_Color_Reply             is R3.X_Lookup_Color_Reply;  
    subtype X_Query_Best_Size_Reply          is R3.X_Query_Best_Size_Reply;  
    subtype X_Query_Colors_Reply             is R3.X_Query_Colors_Reply;  

    subtype X_Rgb       is R3.X_Rgb;  
    subtype X_Rgb_Array is R3.X_Rgb_Array;  
    subtype X_Rgb_List  is R3.X_Rgb_List;  

    subtype X_Query_Extension_Reply      is R3.X_Query_Extension_Reply;  
    subtype X_Query_Font_Reply           is R3.X_Query_Font_Reply;  
    subtype X_Query_Keymap_Reply         is R3.X_Query_Keymap_Reply;  
    subtype X_Query_Pointer_Reply        is R3.X_Query_Pointer_Reply;  
    subtype X_Query_Text_Extents_Reply   is R3.X_Query_Text_Extents_Reply;  
    subtype X_Query_Tree_Reply           is R3.X_Query_Tree_Reply;  
    subtype X_Set_Modifier_Mapping_Reply is R3.X_Set_Modifier_Mapping_Reply;  
    subtype X_Set_Pointer_Mapping_Reply  is R3.X_Set_Pointer_Mapping_Reply;  
    subtype X_Translate_Coords_Reply     is R3.X_Translate_Coords_Reply;  

    procedure Free_X_Rgb_List (List : in out X_Rgb_List)  
        renames R3.Free_X_Rgb_List;  

end Xlbt_Reply;  

