with Unchecked_Deallocation;  

with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  
with Xlbt_Basic3;  
use Xlbt_Basic3;  
with Xlbt_Color;  
use Xlbt_Color;  
with Xlbt_Error3;  
use Xlbt_Error3;  
with Xlbt_Event3;  
use Xlbt_Event3;  
with Xlbt_Font3;  
use Xlbt_Font3;  
with Xlbt_Grab;  
use Xlbt_Grab;  
with Xlbt_Host;  
use Xlbt_Host;  
with Xlbt_Input_Focus;  
use Xlbt_Input_Focus;  
with Xlbt_Key3;  
use Xlbt_Key3;  
with Xlbt_Keyboard3;  
use Xlbt_Keyboard3;  
with Xlbt_Misc;  
use Xlbt_Misc;  
with Xlbt_Request3;  
use Xlbt_Request3;  
with Xlbt_Screen_Saver;  
use Xlbt_Screen_Saver;  
with Xlbt_Window4;  
use Xlbt_Window4;  

with Xlbit_Unused;  
use Xlbit_Unused;  

--/ if Record_Rep_Clauses then  
with Xlbmt_Parameters;  
use Xlbmt_Parameters;  
--/ end if;  
with Xlbmt_Network_Types;  
use Xlbmt_Network_Types;  

package Xlbt_Reply3 is  
------------------------------------------------------------------------------  
-- X Library Protocol Reply Packets - Full Interface  
--  
-- Xlbt_Reply3 - Record definitions of the protocol reply packets  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
------------------------------------------------------------------------------  
-- X_Alloc_Color_Reply  
------------------------------------------------------------------------------  

    type X_Alloc_Color_Reply is  
        record  
            Kind            : X_Event_Code_8;    -- X_Reply  
            Pad1            : U_Char;  
            Sequence_Number : U_Short;  
            Length          : S_Long;            -- 0  
            Red             : U_Short;  
            Green           : U_Short;  
            Blue            : U_Short;  
            Pad2            : U_Short;  
            Pixel           : X_Pixel;  
            Pad3            : X_Unused_4;  
            Pad4            : X_Unused_4;  
            Pad5            : X_Unused_4;  
        end record;  

--/ if Length_Clauses then  
    for X_Alloc_Color_Reply'Size use 8 * 32;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_Alloc_Color_Cells_Reply  
------------------------------------------------------------------------------  

    type X_Alloc_Color_Cells_Reply is  
        record  
            Kind            : X_Event_Code_8;  -- X_Reply  
            Pad1            : U_Char;  
            Sequence_Number : U_Short;  
            Length          : S_Long;  
            N_Pixels        : U_Short;  
            N_Masks         : U_Short;  
            Pad3            : X_Unused_4;  
            Pad4            : X_Unused_4;  
            Pad5            : X_Unused_4;  
            Pad6            : X_Unused_4;  
            Pad7            : X_Unused_4;  
        end record;  

--/ if Length_Clauses then  
    for X_Alloc_Color_Cells_Reply'Size use 8 * 32;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_Alloc_Color_Planes_Reply  
------------------------------------------------------------------------------  

    type X_Alloc_Color_Planes_Reply is  
        record  
            Kind            : X_Event_Code_8; -- X_Reply  
            Pad1            : U_Char;  
            Sequence_Number : U_Short;  
            Length          : S_Long;  
            N_Pixels        : U_Short;  
            Pad2            : U_Short;  
            Red_Mask        : X_Red_Color_Mask;  
            Green_Mask      : X_Green_Color_Mask;  
            Blue_Mask       : X_Blue_Color_Mask;  
            Pad3            : X_Unused_4;  
            Pad4            : X_Unused_4;  
        end record;  

--/ if Length_Clauses then  
    for X_Alloc_Color_Planes_Reply'Size use 8 * 32;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_Alloc_Named_Color_Reply  
------------------------------------------------------------------------------  

    type X_Alloc_Named_Color_Reply is  
        record  
            Kind            : X_Event_Code_8;    -- X_Reply  
            Pad1            : U_Char;  
            Sequence_Number : U_Short;  
            Length          : S_Long;            -- 0  
            Pixel           : X_Pixel;  
            Exact_Red       : U_Short;  
            Exact_Green     : U_Short;  
            Exact_Blue      : U_Short;  
            Screen_Red      : U_Short;  
            Screen_Green    : U_Short;  
            Screen_Blue     : U_Short;  
            Pad2            : X_Unused_4;  
            Pad3            : X_Unused_4;  
        end record;  

--/ if Length_Clauses then  
    for X_Alloc_Named_Color_Reply'Size use 8 * 32;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_Get_Atom_Name_Reply  
------------------------------------------------------------------------------  

    type X_Get_Atom_Name_Reply is  
        record  
            Kind            : X_Event_Code_8;       -- X_Reply  
            Pad1            : U_Char;  
            Sequence_Number : U_Short;  
            Length          : S_Long;               -- of additional bytes  
            Name_Length     : U_Short;              -- # of characters in name  
            Pad2            : U_Short;  
            Pad3            : X_Unused_4;  
            Pad4            : X_Unused_4;  
            Pad5            : X_Unused_4;  
            Pad6            : X_Unused_4;  
            Pad7            : X_Unused_4;  
        end record;  

--/ if Length_Clauses then  
    for X_Get_Atom_Name_Reply'Size use 8 * 32;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_Get_Font_Path_Reply  
------------------------------------------------------------------------------  

    type X_Get_Font_Path_Reply is  
        record  
            Kind            : X_Event_Code_8;       -- X_Reply  
            Pad1            : U_Char;  
            Sequence_Number : U_Short;  
            Length          : S_Long;  
            N_Paths         : U_Short;  
            Pad2            : U_Short;  
            Pad3            : X_Unused_4;  
            Pad4            : X_Unused_4;  
            Pad5            : X_Unused_4;  
            Pad6            : X_Unused_4;  
            Pad7            : X_Unused_4;  
        end record;  

--/ if Length_Clauses then  
    for X_Get_Font_Path_Reply'Size use 8 * 32;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_Get_Geometry_Reply  
------------------------------------------------------------------------------  

    type X_Get_Geometry_Reply is  
        record  
            Kind            : X_Event_Code_8;       -- X_Reply  
            Depth           : U_Char;  
            Sequence_Number : U_Short;  
            Length          : S_Long;               -- 0  
            Root            : X_Window;  
            X               : S_Short;  
            Y               : S_Short;  
            Width           : U_Short;  
            Height          : U_Short;  
            Border_Width    : U_Short;  
            Pad1            : U_Short;  
            Pad2            : X_Unused_4;  
            Pad3            : X_Unused_4;  
        end record;  

--/ if Length_Clauses then  
    for X_Get_Geometry_Reply'Size use 8 * 32;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_Get_Image_Reply  
------------------------------------------------------------------------------  

    type X_Get_Image_Reply is  
        record  
            Kind            : X_Event_Code_8;       -- X_Reply  
            Depth           : U_Char;  
            Sequence_Number : U_Short;  
            Length          : S_Long;  
            Visual          : X_Visual_Id;  
            Pad3            : X_Unused_4;  
            Pad4            : X_Unused_4;  
            Pad5            : X_Unused_4;  
            Pad6            : X_Unused_4;  
            Pad7            : X_Unused_4;  
        end record;  

--/ if Length_Clauses then  
    for X_Get_Image_Reply'Size use 8 * 32;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_Get_Input_Focus_Reply  
------------------------------------------------------------------------------  

    type X_Get_Input_Focus_Reply is  
        record  
            Kind            : X_Event_Code_8;           -- X_Reply  
            Revert_To       : X_Revert_Focus_Mode;  
            Sequence_Number : U_Short;  
            Length          : S_Long;                   -- 0  
            Focus           : X_Window;  
            Pad1            : X_Unused_4;  
            Pad2            : X_Unused_4;  
            Pad3            : X_Unused_4;  
            Pad4            : X_Unused_4;  
            Pad5            : X_Unused_4;  
        end record;  

--/ if Length_Clauses then  
    for X_Get_Input_Focus_Reply'Size use 8 * 32;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_Get_Keyboard_Control_Reply  
------------------------------------------------------------------------------  

    type X_Get_Keyboard_Control_Reply is  
        record  
            Kind               : X_Event_Code_8;        -- X_Reply  
            Global_Auto_Repeat : X_Boolean_Char;  
            Sequence_Number    : U_Short;  
            Length             : S_Long;                -- 5  
            Led_Mask           : X_Led_Bits;  
            Key_Click_Percent  : S_Char;                -- -100..100  
            Bell_Percent       : S_Char;                -- -100..100  
            Bell_Pitch         : U_Short;  
            Bell_Duration      : U_Short;  
            Pad                : U_Short;  
            Map                : X_Keyboard_As_Bits;    -- bit masks start here  
        end record;  

--/ if not R1000_Size_Bug and then Length_Clauses then  
    for X_Get_Keyboard_Control_Reply'Size use 8 * 52;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_Get_Keyboard_Mapping_Reply  
------------------------------------------------------------------------------  

    type X_Get_Keyboard_Mapping_Reply is  
        record  
            Kind                  : X_Event_Code_8;  
            Key_Syms_Per_Key_Code : U_Char;  
            Sequence_Number       : U_Short;  
            Length                : S_Long;  
            Pad2                  : X_Unused_4;  
            Pad3                  : X_Unused_4;  
            Pad4                  : X_Unused_4;  
            Pad5                  : X_Unused_4;  
            Pad6                  : X_Unused_4;  
            Pad7                  : X_Unused_4;  
        end record;  

--/ if Length_Clauses then  
    for X_Get_Keyboard_Mapping_Reply'Size use 8 * 32;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_Get_Modifier_Mapping_Reply  
------------------------------------------------------------------------------  

    type X_Get_Modifier_Mapping_Reply is  
        record  
            Kind                 : X_Event_Code_8;  
            Num_Key_Per_Modifier : U_Char;  
            Sequence_Number      : U_Short;  
            Length               : S_Long;  
            Pad1                 : X_Unused_4;  
            Pad2                 : X_Unused_4;  
            Pad3                 : X_Unused_4;  
            Pad4                 : X_Unused_4;  
            Pad5                 : X_Unused_4;  
            Pad6                 : X_Unused_4;  
        end record;  

--/ if Length_Clauses then  
    for X_Get_Modifier_Mapping_Reply'Size use 8 * 32;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_Get_Motion_Events_Reply  
------------------------------------------------------------------------------  

    type X_Get_Motion_Events_Reply is  
        record  
            Kind            : X_Event_Code_8;           -- X_Reply  
            Pad1            : U_Char;  
            Sequence_Number : U_Short;  
            Length          : S_Long;  
            N_Events        : S_Long;  
            Pad2            : X_Unused_4;  
            Pad3            : X_Unused_4;  
            Pad4            : X_Unused_4;  
            Pad5            : X_Unused_4;  
            Pad6            : X_Unused_4;  
        end record;  

--/ if Length_Clauses then  
    for X_Get_Motion_Events_Reply'Size use 8 * 32;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_Get_Pointer_Control_Reply  
------------------------------------------------------------------------------  

    type X_Get_Pointer_Control_Reply is  
        record  
            Kind              : X_Event_Code_8;         -- X_Reply  
            Pad1              : U_Char;  
            Sequence_Number   : U_Short;  
            Length            : S_Long;                 -- 0  
            Accel_Numerator   : U_Short;  
            Accel_Denominator : U_Short;  
            Threshold         : U_Short;  
            Pad2              : U_Short;  
            Pad3              : X_Unused_4;  
            Pad4              : X_Unused_4;  
            Pad5              : X_Unused_4;  
            Pad6              : X_Unused_4;  
        end record;  

--/ if Length_Clauses then  
    for X_Get_Pointer_Control_Reply'Size use 8 * 32;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_Get_Pointer_Mapping_Reply  
------------------------------------------------------------------------------  

    type X_Get_Pointer_Mapping_Reply is  
        record  
            Kind            : X_Event_Code_8;           -- X_Reply  
            N_Elts          : U_Char;                   -- how many elements  
                                                        --  does the map have  
            Sequence_Number : U_Short;  
            Length          : S_Long;  
            Pad2            : X_Unused_4;  
            Pad3            : X_Unused_4;  
            Pad4            : X_Unused_4;  
            Pad5            : X_Unused_4;  
            Pad6            : X_Unused_4;  
            Pad7            : X_Unused_4;  
        end record;  

--/ if Length_Clauses then  
    for X_Get_Pointer_Mapping_Reply'Size use 8 * 32;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_Get_Property_Reply  
------------------------------------------------------------------------------  

    type X_Get_Property_Reply is  
        record  
            Kind            : X_Event_Code_8;           -- X_Reply  
            Format          : U_Char;  
            Sequence_Number : U_Short;  
            Length          : S_Long;                   -- of additional bytes  
            Property_Type   : X_Atom;  
            Bytes_After     : S_Long;  
            N_Items         : S_Long;       -- # of 8/16/32-bit items in reply  
            Pad1            : X_Unused_4;  
            Pad2            : X_Unused_4;  
            Pad3            : X_Unused_4;  
        end record;  

--/ if Length_Clauses then  
    for X_Get_Property_Reply'Size use 8 * 32;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_Get_Screen_Saver_Reply  
------------------------------------------------------------------------------  

    type X_Get_Screen_Saver_Reply is  
        record  
            Kind            : X_Event_Code_8;         -- X_Reply  
            Pad1            : U_Char;  
            Sequence_Number : U_Short;  
            Length          : S_Long;                 -- 0  
            Timeout         : U_Short;  
            Interval        : U_Short;  
            Prefer_Blanking : X_Screen_Saver_Blanking;  
            Allow_Exposures : X_Screen_Saver_Exposures;  
            Pad2            : U_Short;  
            Pad3            : X_Unused_4;  
            Pad4            : X_Unused_4;  
            Pad5            : X_Unused_4;  
            Pad6            : X_Unused_4;  
        end record;  

--/ if Length_Clauses then  
    for X_Get_Screen_Saver_Reply'Size use 8 * 32;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_Get_Selection_Owner_Reply  
------------------------------------------------------------------------------  

    type X_Get_Selection_Owner_Reply is  
        record  
            Kind            : X_Event_Code_8;       -- X_Reply  
            Pad1            : U_Char;  
            Sequence_Number : U_Short;  
            Length          : S_Long;               -- 0  
            Owner           : X_Window;  
            Pad2            : X_Unused_4;  
            Pad3            : X_Unused_4;  
            Pad4            : X_Unused_4;  
            Pad5            : X_Unused_4;  
            Pad6            : X_Unused_4;  
        end record;  

--/ if Length_Clauses then  
    for X_Get_Selection_Owner_Reply'Size use 8 * 32;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_Get_Window_Attributes_Reply  
------------------------------------------------------------------------------  

    type X_Get_Window_Attributes_Reply is  
        record  
            Kind                  : X_Event_Code_8;     -- X_Reply  
            Backing_Store         : X_Backing_Store_Hint;  
            Sequence_Number       : U_Short;  
            Length                : S_Long;             -- NOT 0; this is an  
                                                        --  extra-large reply  
            Visual_Id             : X_Visual_Id;  
            Class                 : X_Window_Class;  
            Bit_Gravity           : X_Bit_Gravity;  
            Win_Gravity           : X_Window_Gravity;  
            Backing_Bit_Planes    : X_Plane_Mask;  
            Backing_Pixel         : X_Pixel;  
            Save_Under            : X_Boolean_Char;  
            Map_Installed         : X_Boolean_Char;  
            Map_State             : X_Map_State;  
            Override              : X_Boolean_Char;  
            Colormap              : X_Colormap;  
            All_Event_Masks       : X_Event_Mask;  
            Your_Event_Mask       : X_Event_Mask;  
            Do_Not_Propagate_Mask : X_Event_Mask_Short;  
            Pad                   : U_Short;  
        end record;  

--/ if not R1000_Size_Bug and then Length_Clauses then  
    for X_Get_Window_Attributes_Reply'Size use 8 * 44;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_Grab_Keyboard_Reply  
------------------------------------------------------------------------------  

    type X_Grab_Keyboard_Reply is  
        record  
            Kind            : X_Event_Code_8;           -- X_Reply  
            Success         : X_Grab_Status;  
            Sequence_Number : U_Short;  
            Length          : S_Long;                   -- 0  
            Pad1            : X_Unused_4;  
            Pad2            : X_Unused_4;  
            Pad3            : X_Unused_4;  
            Pad4            : X_Unused_4;  
            Pad5            : X_Unused_4;  
            Pad6            : X_Unused_4;  
        end record;  

--/ if Length_Clauses then  
    for X_Grab_Keyboard_Reply'Size use 8 * 32;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_Grab_Pointer_Reply  
------------------------------------------------------------------------------  

    type X_Grab_Pointer_Reply is  
        record  
            Kind            : X_Event_Code_8;           -- X_Reply  
            Success         : X_Grab_Status;  
            Sequence_Number : U_Short;  
            Length          : S_Long;                   -- 0  
            Pad1            : X_Unused_4;  
            Pad2            : X_Unused_4;  
            Pad3            : X_Unused_4;  
            Pad4            : X_Unused_4;  
            Pad5            : X_Unused_4;  
            Pad6            : X_Unused_4;  
        end record;  

--/ if Length_Clauses then  
    for X_Grab_Pointer_Reply'Size use 8 * 32;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_Intern_Atom_Reply  
------------------------------------------------------------------------------  

    type X_Intern_Atom_Reply is  
        record  
            Kind            : X_Event_Code_8;           -- X_Reply  
            Pad1            : U_Char;  
            Sequence_Number : U_Short;  
            Length          : S_Long;                   -- 0  
            Atom            : X_Atom;  
            Pad2            : X_Unused_4;  
            Pad3            : X_Unused_4;  
            Pad4            : X_Unused_4;  
            Pad5            : X_Unused_4;  
            Pad6            : X_Unused_4;  
        end record;  

--/ if Length_Clauses then  
    for X_Intern_Atom_Reply'Size use 8 * 32;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_List_Extensions_Reply  
------------------------------------------------------------------------------  

    type X_List_Extensions_Reply is  
        record  
            Kind            : X_Event_Code_8;           -- X_Reply  
            N_Extensions    : U_Char;  
            Sequence_Number : U_Short;  
            Length          : S_Long;  
            Pad2            : X_Unused_4;  
            Pad3            : X_Unused_4;  
            Pad4            : X_Unused_4;  
            Pad5            : X_Unused_4;  
            Pad6            : X_Unused_4;  
            Pad7            : X_Unused_4;  
        end record;  

--/ if Length_Clauses then  
    for X_List_Extensions_Reply'Size use 8 * 32;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_List_Fonts_Reply  
------------------------------------------------------------------------------  

    type X_List_Fonts_Reply is  
        record  
            Kind            : X_Event_Code_8;           -- X_Reply  
            Pad1            : U_Char;  
            Sequence_Number : U_Short;  
            Length          : S_Long;  
            N_Fonts         : U_Short;  
            Pad2            : U_Short;  
            Pad3            : X_Unused_4;  
            Pad4            : X_Unused_4;  
            Pad5            : X_Unused_4;  
            Pad6            : X_Unused_4;  
            Pad7            : X_Unused_4;  
        end record;  

--/ if Length_Clauses then  
    for X_List_Fonts_Reply'Size use 8 * 32;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_List_Fonts_With_Info_Reply  
------------------------------------------------------------------------------  

    type X_List_Fonts_With_Info_Reply is  
        record  
            Kind              : X_Event_Code_8; -- X_Reply  
            Name_Length       : U_Char;         -- 0 indicates end-of-reply-  
                                                --  sequence  
            Sequence_Number   : U_Short;  
            Length            : S_Long;         -- definitely > 0, even if  
                                                --  "Name_Length" is 0  
            Min_Bounds        : X_Char_Struct;  
            Walign1           : S_Long;         -- Just alignment, no data  
            Max_Bounds        : X_Char_Struct;  
            Walign2           : S_Long;         -- Just alignment, no data  
            Min_Char_Or_Byte2 : U_Short;  
            Max_Char_Or_Byte2 : U_Short;  
            Default_Char      : U_Short;        -- Note: *not* X_Character16!  
            N_Font_Props      : U_Short;        -- followed by this many  
                                                --  X_Font_Prop structures  
            Draw_Direction    : X_Font_Direction;  
            Min_Byte1         : U_Char;  
            Max_Byte1         : U_Char;  
            All_Chars_Exist   : X_Boolean_Char;  
            Font_Ascent       : S_Short;  
            Font_Descent      : S_Short;  
            N_Replies         : S_Long;         -- hint as to how many more  
                                                --  replies might be coming  
        end record;  

--/ if Length_Clauses then  
    for X_List_Fonts_With_Info_Reply'Size use 8 * 60;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_List_Hosts_Reply  
------------------------------------------------------------------------------  

    type X_List_Hosts_Reply is  
        record  
            Kind            : X_Event_Code_8;           -- X_Reply  
            Enabled         : X_Boolean_Char;  
            Sequence_Number : U_Short;  
            Length          : S_Long;  
            N_Hosts         : U_Short;  
            Pad1            : U_Short;  
            Pad3            : X_Unused_4;  
            Pad4            : X_Unused_4;  
            Pad5            : X_Unused_4;  
            Pad6            : X_Unused_4;  
            Pad7            : X_Unused_4;  
        end record;  

--/ if Length_Clauses then  
    for X_List_Hosts_Reply'Size use 8 * 32;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_Wire_Host_Format  
------------------------------------------------------------------------------  

    type X_Wire_Host_Reply is  
        record  
            Family      : X_Host_Protocol_Family;  
            Pad         : U_Char;  
            Name_Length : U_Short;  
        end record;  

--/ if Length_Clauses then  
    for X_Wire_Host_Reply'Size use 8 * 4 * 1;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_List_Installed_Colormaps_Reply  
------------------------------------------------------------------------------  

    type X_List_Installed_Colormaps_Reply is  
        record  
            Kind            : X_Event_Code_8;           -- X_Reply  
            Pad1            : U_Char;  
            Sequence_Number : U_Short;  
            Length          : S_Long;  
            N_Colormaps     : U_Short;  
            Pad2            : U_Short;  
            Pad3            : X_Unused_4;  
            Pad4            : X_Unused_4;  
            Pad5            : X_Unused_4;  
            Pad6            : X_Unused_4;  
            Pad7            : X_Unused_4;  
        end record;  

--/ if Length_Clauses then  
    for X_List_Installed_Colormaps_Reply'Size use 8 * 32;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_List_Properties_Reply  
------------------------------------------------------------------------------  

    type X_List_Properties_Reply is  
        record  
            Kind            : X_Event_Code_8;           -- X_Reply  
            Pad1            : U_Char;  
            Sequence_Number : U_Short;  
            Length          : S_Long;  
            N_Properties    : U_Short;  
            Pad2            : U_Short;  
            Pad3            : X_Unused_4;  
            Pad4            : X_Unused_4;  
            Pad5            : X_Unused_4;  
            Pad6            : X_Unused_4;  
            Pad7            : X_Unused_4;  
        end record;  

--/ if Length_Clauses then  
    for X_List_Properties_Reply'Size use 8 * 32;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_Lookup_Color_Reply  
------------------------------------------------------------------------------  

    type X_Lookup_Color_Reply is  
        record  
            Kind            : X_Event_Code_8;           -- X_Reply  
            Pad1            : U_Char;  
            Sequence_Number : U_Short;  
            Length          : S_Long;                   -- 0  
            Exact_Red       : U_Short;  
            Exact_Green     : U_Short;  
            Exact_Blue      : U_Short;  
            Screen_Red      : U_Short;  
            Screen_Green    : U_Short;  
            Screen_Blue     : U_Short;  
            Pad3            : X_Unused_4;  
            Pad4            : X_Unused_4;  
            Pad5            : X_Unused_4;  
        end record;  

--/ if Length_Clauses then  
    for X_Lookup_Color_Reply'Size use 8 * 32;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_Query_Best_Size_Reply  
------------------------------------------------------------------------------  

    type X_Query_Best_Size_Reply is  
        record  
            Kind            : X_Event_Code_8;           -- X_Reply  
            Pad1            : U_Char;  
            Sequence_Number : U_Short;  
            Length          : S_Long;                   -- 0  
            Width           : U_Short;  
            Height          : U_Short;  
            Pad3            : X_Unused_4;  
            Pad4            : X_Unused_4;  
            Pad5            : X_Unused_4;  
            Pad6            : X_Unused_4;  
            Pad7            : X_Unused_4;  
        end record;  

--/ if Length_Clauses then  
    for X_Query_Best_Size_Reply'Size use 8 * 32;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_Query_Colors_Reply  
------------------------------------------------------------------------------  

    type X_Query_Colors_Reply is  
        record  
            Kind            : X_Event_Code_8;           -- X_Reply  
            Pad1            : U_Char;  
            Sequence_Number : U_Short;  
            Length          : S_Long;  
            N_Colors        : U_Short;  
            Pad2            : U_Short;  
            Pad3            : X_Unused_4;  
            Pad4            : X_Unused_4;  
            Pad5            : X_Unused_4;  
            Pad6            : X_Unused_4;  
            Pad7            : X_Unused_4;  
        end record;  

--/ if Length_Clauses then  
    for X_Query_Colors_Reply'Size use 8 * 32;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_Rgb - Part of an X_Query_Colors_Reply  
------------------------------------------------------------------------------  

    type X_Rgb is  
        record  
            Red   : U_Short;  
            Green : U_Short;  
            Blue  : U_Short;  
            Pad   : U_Short;  
        end record;  

--/ if Length_Clauses then  
    for X_Rgb'Size use 16 * 4;  
--/ end if;  

    type X_Rgb_Array is array (S_Natural range <>) of X_Rgb;  
    type X_Rgb_List  is access X_Rgb_Array;  

--/ if Pack and not TeleGen2_Pack_Bug then  
    pragma Pack (X_Rgb_Array);  
--/ end if;  
--/ if Enable_Deallocation then  
    pragma Enable_Deallocation (X_Rgb_List);  
--/ end if;  

    procedure Free_X_Rgb_List is  
       new Unchecked_Deallocation (X_Rgb_Array,  
                                   X_Rgb_List);  

------------------------------------------------------------------------------  
-- X_Query_Extension_Reply  
------------------------------------------------------------------------------  

    type X_Query_Extension_Reply is  
        record  
            Kind            : X_Event_Code_8;           -- X_Reply  
            Pad1            : U_Char;  
            Sequence_Number : U_Short;  
            Length          : S_Long;                   -- 0  
            Present         : X_Boolean_Char;  
            Major_Opcode    : X_Request_Code;  
            First_Event     : X_Event_Code_8;  
            First_Error     : X_Error_Code;  
            Pad3            : X_Unused_4;  
            Pad4            : X_Unused_4;  
            Pad5            : X_Unused_4;  
            Pad6            : X_Unused_4;  
            Pad7            : X_Unused_4;  
        end record;  

--/ if Length_Clauses then  
    for X_Query_Extension_Reply'Size use 8 * 32;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_Query_Font_Reply  
------------------------------------------------------------------------------  

    type X_Query_Font_Reply is  
        record  
            Kind              : X_Event_Code_8;  -- X_Reply  
            Pad1              : U_Char;  
            Sequence_Number   : U_Short;  
            Length            : S_Long;         -- definitely > 0, even if  
                                                --  "N_Char_Infos" is 0  
            Min_Bounds        : X_Char_Struct;  
            Walign1           : S_Long;         -- Just alignment, no data.  
            Max_Bounds        : X_Char_Struct;  
            Walign2           : S_Long;         -- Just alignment, no data.  
            Min_Char_Or_Byte2 : U_Short;  
            Max_Char_Or_Byte2 : U_Short;  
            Default_Char      : U_Short;        -- Note: *not* X_Character16!  
            N_Font_Props      : U_Short;        -- followed by this many  
                                                --  x_Font_Prop structures  
            Draw_Direction    : X_Font_Direction;  
            Min_Byte1         : U_Char;  
            Max_Byte1         : U_Char;  
            All_Chars_Exist   : X_Boolean_Char;  
            Font_Ascent       : S_Short;  
            Font_Descent      : S_Short;  
            N_Char_Infos      : S_Long;         -- followed by this many  
                                                --  X_Char_Info structures  
        end record;  

--/ if Length_Clauses then  
    for X_Query_Font_Reply'Size use 8 * 60;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_Query_Keymap_Reply  
------------------------------------------------------------------------------  

    type X_Query_Keymap_Reply is  
        record  
            Kind            : X_Event_Code_8;           -- X_Reply  
            Pad1            : U_Char;  
            Sequence_Number : U_Short;  
            Length          : S_Long;                   -- 2, NOT 0; this is an  
                                                        --  extra-large reply  
            Map             : X_Keyboard_As_Bits;  
        end record;  

--/ if not R1000_Size_Bug and then Length_Clauses then  
    for X_Query_Keymap_Reply'Size use 8 * 32 + 8 * 4 * 2;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_Query_Pointer_Reply  
------------------------------------------------------------------------------  

    type X_Query_Pointer_Reply is  
        record  
            Kind            : X_Event_Code_8;           -- X_Reply  
            Same_Screen     : X_Boolean_Char;  
            Sequence_Number : U_Short;  
            Length          : S_Long;                   -- 0  
            Root            : X_Window;  
            Child           : X_Window;  
            Root_X          : U_Short;  
            Root_Y          : U_Short;  
            Win_X           : S_Short;  
            Win_Y           : S_Short;  
            Mask            : X_Key_Button_Mask;  
            Pad1            : U_Short;  
            Pad             : X_Unused_4;  
        end record;  

--/ if not R1000_Size_Bug and then Length_Clauses then  
    for X_Query_Pointer_Reply'Size use 8 * 32;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_Query_Text_Extents_Reply  
------------------------------------------------------------------------------  

    type X_Query_Text_Extents_Reply is  
        record  
            Kind            : X_Event_Code_8;           -- X_Reply  
            Draw_Direction  : X_Font_Direction;  
            Sequence_Number : U_Short;  
            Length          : S_Long;                   -- 0  
            Font_Ascent     : S_Short;  
            Font_Descent    : S_Short;  
            Overall_Ascent  : S_Short;  
            Overall_Descent : S_Short;  
            Overall_Width   : S_Long;  
            Overall_Left    : S_Long;  
            Overall_Right   : S_Long;  
            Pad             : X_Unused_4;  
        end record;  

--/ if Length_Clauses then  
    for X_Query_Text_Extents_Reply'Size use 8 * 32;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_Query_Tree_Reply  
------------------------------------------------------------------------------  

    type X_Query_Tree_Reply is  
        record  
            Kind            : X_Event_Code_8;           -- X_Reply  
            Pad1            : U_Char;  
            Sequence_Number : U_Short;  
            Length          : S_Long;  
            Root            : X_Window;  
            Parent          : X_Window;  
            N_Children      : U_Short;  
            Pad2            : U_Short;  
            Pad3            : X_Unused_4;  
            Pad4            : X_Unused_4;  
            Pad5            : X_Unused_4;  
        end record;  

--/ if Length_Clauses then  
    for X_Query_Tree_Reply'Size use 8 * 32;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_Set_Modifier_Mapping_Reply  
------------------------------------------------------------------------------  

    type X_Set_Modifier_Mapping_Reply is  
        record  
            Kind            : X_Event_Code_8;           -- X_Reply  
            Success         : X_Mapping_Status;  
            Sequence_Number : U_Short;  
            Length          : S_Long;  
            Pad2            : X_Unused_4;  
            Pad3            : X_Unused_4;  
            Pad4            : X_Unused_4;  
            Pad5            : X_Unused_4;  
            Pad6            : X_Unused_4;  
            Pad7            : X_Unused_4;  
        end record;  

--/ if Length_Clauses then  
    for X_Set_Modifier_Mapping_Reply'Size use 8 * 32;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_Set_Pointer_Mapping_Reply  
------------------------------------------------------------------------------  

    type X_Set_Pointer_Mapping_Reply is  
        record  
            Kind            : X_Event_Code_8;           -- X_Reply  
            Success         : X_Mapping_Status;  
            Sequence_Number : U_Short;  
            Length          : S_Long;  
            Pad2            : X_Unused_4;  
            Pad3            : X_Unused_4;  
            Pad4            : X_Unused_4;  
            Pad5            : X_Unused_4;  
            Pad6            : X_Unused_4;  
            Pad7            : X_Unused_4;  
        end record;  

--/ if Length_Clauses then  
    for X_Set_Pointer_Mapping_Reply'Size use 8 * 32;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_Translate_Coords_Reply  
------------------------------------------------------------------------------  

    type X_Translate_Coords_Reply is  
        record  
            Kind            : X_Event_Code_8;           -- X_Reply  
            Same_Screen     : X_Boolean_Char;  
            Sequence_Number : U_Short;  
            Length          : S_Long;                   -- 0  
            Child           : X_Window;  
            Dst_X           : S_Short;  
            Dst_Y           : S_Short;  
            Pad2            : X_Unused_4;  
            Pad3            : X_Unused_4;  
            Pad4            : X_Unused_4;  
            Pad5            : X_Unused_4;  
        end record;  

--/ if Length_Clauses then  
    for X_Translate_Coords_Reply'Size use 8 * 32;  
--/ end if;  

--
------------------------------------------------------------------------------  
-- X_Reply - All reply headers are 32 bytes in length.  They may have extra  
-- data following the initial 32 bytes.  
------------------------------------------------------------------------------  

    type X_Reply_Contents (Kind : X_Request_Code := Invalid_Request) is  
        record  
            Send_Event : Boolean := False; -- True if sent by Client not Server  
            case Kind is  
                when Alloc_Color =>  
                    Alloc_Color : X_Alloc_Color_Reply;  
                when Alloc_Color_Cells =>  
                    Alloc_Color_Cells : X_Alloc_Color_Cells_Reply;  
                when Alloc_Color_Planes =>  
                    Alloc_Color_Planes : X_Alloc_Color_Planes_Reply;  
                when Alloc_Named_Color =>  
                    Alloc_Named_Color : X_Alloc_Named_Color_Reply;  
                when Get_Atom_Name =>  
                    Get_Atom_Name : X_Get_Atom_Name_Reply;  
                when Get_Font_Path =>  
                    Get_Font_Path : X_Get_Font_Path_Reply;  
                when Get_Geometry =>  
                    Get_Geometry : X_Get_Geometry_Reply;  
                when Get_Image =>  
                    Get_Image : X_Get_Image_Reply;  
                when Get_Input_Focus =>  
                    Get_Input_Focus : X_Get_Input_Focus_Reply;  
                when Get_Keyboard_Control =>  
                    Get_Keyboard_Control : X_Get_Keyboard_Control_Reply;  
                when Get_Keyboard_Mapping =>  
                    Get_Keyboard_Mapping : X_Get_Keyboard_Mapping_Reply;  
                when Get_Modifier_Mapping =>  
                    Get_Modifier_Mapping : X_Get_Modifier_Mapping_Reply;  
                when Get_Motion_Events =>  
                    Get_Motion_Events : X_Get_Motion_Events_Reply;  
                when Get_Pointer_Control =>  
                    Get_Pointer_Control : X_Get_Pointer_Control_Reply;  
                when Get_Pointer_Mapping =>  
                    Get_Pointer_Mapping : X_Get_Pointer_Mapping_Reply;  
                when Get_Property =>  
                    Get_Property : X_Get_Property_Reply;  
                when Get_Screen_Saver =>  
                    Get_Screen_Saver : X_Get_Screen_Saver_Reply;  
                when Get_Selection_Owner =>  
                    Get_Selection_Owner : X_Get_Selection_Owner_Reply;  
                when Get_Window_Attributes =>  
                    Get_Window_Attributes : X_Get_Window_Attributes_Reply;  
                when Grab_Keyboard =>  
                    Grab_Keyboard : X_Grab_Keyboard_Reply;  
                when Grab_Pointer =>  
                    Grab_Pointer : X_Grab_Pointer_Reply;  
                when Intern_Atom =>  
                    Intern_Atom : X_Intern_Atom_Reply;  
                when List_Extensions =>  
                    List_Extensions : X_List_Extensions_Reply;  
                when List_Fonts =>  
                    List_Fonts : X_List_Fonts_Reply;  
                when List_Fonts_With_Info =>  
                    List_Fonts_With_Info : X_List_Fonts_With_Info_Reply;  
                when List_Hosts =>  
                    List_Hosts : X_List_Hosts_Reply;  
                when List_Installed_Colormaps =>  
                    List_Installed_Colormaps : X_List_Installed_Colormaps_Reply;  
                when List_Properties =>  
                    List_Properties : X_List_Properties_Reply;  
                when Lookup_Color =>  
                    Lookup_Color : X_Lookup_Color_Reply;  
                when Query_Best_Size =>  
                    Query_Best_Size : X_Query_Best_Size_Reply;  
                when Query_Colors =>  
                    Query_Colors : X_Query_Colors_Reply;  
                when Query_Extension =>  
                    Query_Extension : X_Query_Extension_Reply;  
                when Query_Font =>  
                    Query_Font : X_Query_Font_Reply;  
                when Query_Keymap =>  
                    Query_Keymap : X_Query_Keymap_Reply;  
                when Query_Pointer =>  
                    Query_Pointer : X_Query_Pointer_Reply;  
                when Query_Text_Extents =>  
                    Query_Text_Extents : X_Query_Text_Extents_Reply;  
                when Query_Tree =>  
                    Query_Tree : X_Query_Tree_Reply;  
                when Set_Modifier_Mapping =>  
                    Set_Modifier_Mapping : X_Set_Modifier_Mapping_Reply;  
                when Set_Pointer_Mapping =>  
                    Set_Pointer_Mapping : X_Set_Pointer_Mapping_Reply;  
                when Translate_Coords =>  
                    Translate_Coords : X_Translate_Coords_Reply;  

                when others =>  
                    null;  
            end case;  
        end record;  

--
--/ if Record_Rep_Clauses then  
 
    for X_Alloc_Color_Reply use  
        record  
            Kind            at 0 * X_Word range X_Byte0a .. X_Byte0b;  
            Pad1            at 0 * X_Word range X_Byte1a .. X_Byte1b;  
            Sequence_Number at 0 * X_Word range X_Half1a .. X_Half1b;  
            Length          at 1 * X_Word range X_Word0a .. X_Word0b;  
            Red             at 2 * X_Word range X_Half0a .. X_Half0b;  
            Green           at 2 * X_Word range X_Half1a .. X_Half1b;  
            Blue            at 3 * X_Word range X_Half0a .. X_Half0b;  
            Pad2            at 3 * X_Word range X_Half1a .. X_Half1b;  
            Pixel           at 4 * X_Word range X_Word0a .. X_Word0b;  
            Pad3            at 5 * X_Word range X_Word0a .. X_Word0b;  
            Pad4            at 6 * X_Word range X_Word0a .. X_Word0b;  
            Pad5            at 7 * X_Word range X_Word0a .. X_Word0b;  
        end record;  
 
    for X_Alloc_Color_Cells_Reply use  
        record  
            Kind            at 0 * X_Word range X_Byte0a .. X_Byte0b;  
            Pad1            at 0 * X_Word range X_Byte1a .. X_Byte1b;  
            Sequence_Number at 0 * X_Word range X_Half1a .. X_Half1b;  
            Length          at 1 * X_Word range X_Word0a .. X_Word0b;  
            N_Pixels        at 2 * X_Word range X_Half0a .. X_Half0b;  
            N_Masks         at 2 * X_Word range X_Half1a .. X_Half1b;  
            Pad3            at 3 * X_Word range X_Word0a .. X_Word0b;  
            Pad4            at 4 * X_Word range X_Word0a .. X_Word0b;  
            Pad5            at 5 * X_Word range X_Word0a .. X_Word0b;  
            Pad6            at 6 * X_Word range X_Word0a .. X_Word0b;  
            Pad7            at 7 * X_Word range X_Word0a .. X_Word0b;  
        end record;  
 
    for X_Alloc_Color_Planes_Reply use  
        record  
            Kind            at 0 * X_Word range X_Byte0a .. X_Byte0b;  
            Pad1            at 0 * X_Word range X_Byte1a .. X_Byte1b;  
            Sequence_Number at 0 * X_Word range X_Half1a .. X_Half1b;  
            Length          at 1 * X_Word range X_Word0a .. X_Word0b;  
            N_Pixels        at 2 * X_Word range X_Half0a .. X_Half0b;  
            Pad2            at 2 * X_Word range X_Half1a .. X_Half1b;  
            Red_Mask        at 3 * X_Word range X_Word0a .. X_Word0b;  
            Green_Mask      at 4 * X_Word range X_Word0a .. X_Word0b;  
            Blue_Mask       at 5 * X_Word range X_Word0a .. X_Word0b;  
            Pad3            at 6 * X_Word range X_Word0a .. X_Word0b;  
            Pad4            at 7 * X_Word range X_Word0a .. X_Word0b;  
        end record;  
 
    for X_Alloc_Named_Color_Reply use  
        record  
            Kind            at 0 * X_Word range X_Byte0a .. X_Byte0b;  
            Pad1            at 0 * X_Word range X_Byte1a .. X_Byte1b;  
            Sequence_Number at 0 * X_Word range X_Half1a .. X_Half1b;  
            Length          at 1 * X_Word range X_Word0a .. X_Word0b;  
            Pixel           at 2 * X_Word range X_Word0a .. X_Word0b;  
            Exact_Red       at 3 * X_Word range X_Half0a .. X_Half0b;  
            Exact_Green     at 3 * X_Word range X_Half1a .. X_Half1b;  
            Exact_Blue      at 4 * X_Word range X_Half0a .. X_Half0b;  
            Screen_Red      at 4 * X_Word range X_Half1a .. X_Half1b;  
            Screen_Green    at 5 * X_Word range X_Half0a .. X_Half0b;  
            Screen_Blue     at 5 * X_Word range X_Half1a .. X_Half1b;  
            Pad2            at 6 * X_Word range X_Word0a .. X_Word0b;  
            Pad3            at 7 * X_Word range X_Word0a .. X_Word0b;  
        end record;  
 
    for X_Get_Atom_Name_Reply use  
        record  
            Kind            at 0 * X_Word range X_Byte0a .. X_Byte0b;  
            Pad1            at 0 * X_Word range X_Byte1a .. X_Byte1b;  
            Sequence_Number at 0 * X_Word range X_Half1a .. X_Half1b;  
            Length          at 1 * X_Word range X_Word0a .. X_Word0b;  
            Name_Length     at 2 * X_Word range X_Half0a .. X_Half0b;  
            Pad2            at 2 * X_Word range X_Half1a .. X_Half1b;  
            Pad3            at 3 * X_Word range X_Word0a .. X_Word0b;  
            Pad4            at 4 * X_Word range X_Word0a .. X_Word0b;  
            Pad5            at 5 * X_Word range X_Word0a .. X_Word0b;  
            Pad6            at 6 * X_Word range X_Word0a .. X_Word0b;  
            Pad7            at 7 * X_Word range X_Word0a .. X_Word0b;  
        end record;  
 
    for X_Get_Font_Path_Reply use  
        record  
            Kind            at 0 * X_Word range X_Byte0a .. X_Byte0b;  
            Pad1            at 0 * X_Word range X_Byte1a .. X_Byte1b;  
            Sequence_Number at 0 * X_Word range X_Half1a .. X_Half1b;  
            Length          at 1 * X_Word range X_Word0a .. X_Word0b;  
            N_Paths         at 2 * X_Word range X_Half0a .. X_Half0b;  
            Pad2            at 2 * X_Word range X_Half1a .. X_Half1b;  
            Pad3            at 3 * X_Word range X_Word0a .. X_Word0b;  
            Pad4            at 4 * X_Word range X_Word0a .. X_Word0b;  
            Pad5            at 5 * X_Word range X_Word0a .. X_Word0b;  
            Pad6            at 6 * X_Word range X_Word0a .. X_Word0b;  
            Pad7            at 7 * X_Word range X_Word0a .. X_Word0b;  
        end record;  
 
    for X_Get_Geometry_Reply use  
        record  
            Kind            at 0 * X_Word range X_Byte0a .. X_Byte0b;  
            Depth           at 0 * X_Word range X_Byte1a .. X_Byte1b;  
            Sequence_Number at 0 * X_Word range X_Half1a .. X_Half1b;  
            Length          at 1 * X_Word range X_Word0a .. X_Word0b;  
            Root            at 2 * X_Word range X_Word0a .. X_Word0b;  
            X               at 3 * X_Word range X_Half0a .. X_Half0b;  
            Y               at 3 * X_Word range X_Half1a .. X_Half1b;  
            Width           at 4 * X_Word range X_Half0a .. X_Half0b;  
            Height          at 4 * X_Word range X_Half1a .. X_Half1b;  
            Border_Width    at 5 * X_Word range X_Half0a .. X_Half0b;  
            Pad1            at 5 * X_Word range X_Half1a .. X_Half1b;  
            Pad2            at 6 * X_Word range X_Word0a .. X_Word0b;  
            Pad3            at 7 * X_Word range X_Word0a .. X_Word0b;  
        end record;  
 
    for X_Get_Image_Reply use  
        record  
            Kind            at 0 * X_Word range X_Byte0a .. X_Byte0b;  
            Depth           at 0 * X_Word range X_Byte1a .. X_Byte1b;  
            Sequence_Number at 0 * X_Word range X_Half1a .. X_Half1b;  
            Length          at 1 * X_Word range X_Word0a .. X_Word0b;  
            Visual          at 2 * X_Word range X_Word0a .. X_Word0b;  
            Pad3            at 3 * X_Word range X_Word0a .. X_Word0b;  
            Pad4            at 4 * X_Word range X_Word0a .. X_Word0b;  
            Pad5            at 5 * X_Word range X_Word0a .. X_Word0b;  
            Pad6            at 6 * X_Word range X_Word0a .. X_Word0b;  
            Pad7            at 7 * X_Word range X_Word0a .. X_Word0b;  
        end record;  
 
    for X_Get_Input_Focus_Reply use  
        record  
            Kind            at 0 * X_Word range X_Byte0a .. X_Byte0b;  
            Revert_To       at 0 * X_Word range X_Byte1a .. X_Byte1b;  
            Sequence_Number at 0 * X_Word range X_Half1a .. X_Half1b;  
            Length          at 1 * X_Word range X_Word0a .. X_Word0b;  
            Focus           at 2 * X_Word range X_Word0a .. X_Word0b;  
            Pad1            at 3 * X_Word range X_Word0a .. X_Word0b;  
            Pad2            at 4 * X_Word range X_Word0a .. X_Word0b;  
            Pad3            at 5 * X_Word range X_Word0a .. X_Word0b;  
            Pad4            at 6 * X_Word range X_Word0a .. X_Word0b;  
            Pad5            at 7 * X_Word range X_Word0a .. X_Word0b;  
        end record;  
 
    for X_Get_Keyboard_Control_Reply use  
        record  
            Kind               at 0 * X_Word range X_Byte0a .. X_Byte0b;  
            Global_Auto_Repeat at 0 * X_Word range X_Byte1a .. X_Byte1b;  
            Sequence_Number    at 0 * X_Word range X_Half1a .. X_Half1b;  
            Length             at 1 * X_Word range X_Word0a .. X_Word0b;  
            Led_Mask           at 2 * X_Word range X_Word0a .. X_Word0b;  
            Key_Click_Percent  at 3 * X_Word range X_Byte0a .. X_Byte0b;  
            Bell_Percent       at 3 * X_Word range X_Byte1a .. X_Byte1b;  
            Bell_Pitch         at 3 * X_Word range X_Half1a .. X_Half1b;  
            Bell_Duration      at 4 * X_Word range X_Half0a .. X_Half0b;  
            Pad                at 4 * X_Word range X_Half1a .. X_Half1b;  
            Map                at 5 * X_Word range 0 .. 8 * 32 - 1;  
        end record;  
 
    for X_Get_Keyboard_Mapping_Reply use  
        record  
            Kind                  at 0 * X_Word range X_Byte0a .. X_Byte0b;  
            Key_Syms_Per_Key_Code at 0 * X_Word range X_Byte1a .. X_Byte1b;  
            Sequence_Number       at 0 * X_Word range X_Half1a .. X_Half1b;  
            Length                at 1 * X_Word range X_Word0a .. X_Word0b;  
            Pad2                  at 2 * X_Word range X_Word0a .. X_Word0b;  
            Pad3                  at 3 * X_Word range X_Word0a .. X_Word0b;  
            Pad4                  at 4 * X_Word range X_Word0a .. X_Word0b;  
            Pad5                  at 5 * X_Word range X_Word0a .. X_Word0b;  
            Pad6                  at 6 * X_Word range X_Word0a .. X_Word0b;  
            Pad7                  at 7 * X_Word range X_Word0a .. X_Word0b;  
        end record;  
 
    for X_Get_Modifier_Mapping_Reply use  
        record  
            Kind                 at 0 * X_Word range X_Byte0a .. X_Byte0b;  
            Num_Key_Per_Modifier at 0 * X_Word range X_Byte1a .. X_Byte1b;  
            Sequence_Number      at 0 * X_Word range X_Half1a .. X_Half1b;  
            Length               at 1 * X_Word range X_Word0a .. X_Word0b;  
            Pad1                 at 2 * X_Word range X_Word0a .. X_Word0b;  
            Pad2                 at 3 * X_Word range X_Word0a .. X_Word0b;  
            Pad3                 at 4 * X_Word range X_Word0a .. X_Word0b;  
            Pad4                 at 5 * X_Word range X_Word0a .. X_Word0b;  
            Pad5                 at 6 * X_Word range X_Word0a .. X_Word0b;  
            Pad6                 at 7 * X_Word range X_Word0a .. X_Word0b;  
        end record;  
 
    for X_Get_Motion_Events_Reply use  
        record  
            Kind            at 0 * X_Word range X_Byte0a .. X_Byte0b;  
            Pad1            at 0 * X_Word range X_Byte1a .. X_Byte1b;  
            Sequence_Number at 0 * X_Word range X_Half1a .. X_Half1b;  
            Length          at 1 * X_Word range X_Word0a .. X_Word0b;  
            N_Events        at 2 * X_Word range X_Word0a .. X_Word0b;  
            Pad2            at 3 * X_Word range X_Word0a .. X_Word0b;  
            Pad3            at 4 * X_Word range X_Word0a .. X_Word0b;  
            Pad4            at 5 * X_Word range X_Word0a .. X_Word0b;  
            Pad5            at 6 * X_Word range X_Word0a .. X_Word0b;  
            Pad6            at 7 * X_Word range X_Word0a .. X_Word0b;  
        end record;  
 
    for X_Get_Pointer_Control_Reply use  
        record  
            Kind              at 0 * X_Word range X_Byte0a .. X_Byte0b;  
            Pad1              at 0 * X_Word range X_Byte1a .. X_Byte1b;  
            Sequence_Number   at 0 * X_Word range X_Half1a .. X_Half1b;  
            Length            at 1 * X_Word range X_Word0a .. X_Word0b;  
            Accel_Numerator   at 2 * X_Word range X_Half0a .. X_Half0b;  
            Accel_Denominator at 2 * X_Word range X_Half1a .. X_Half1b;  
            Threshold         at 3 * X_Word range X_Half0a .. X_Half0b;  
            Pad2              at 3 * X_Word range X_Half1a .. X_Half1b;  
            Pad3              at 4 * X_Word range X_Word0a .. X_Word0b;  
            Pad4              at 5 * X_Word range X_Word0a .. X_Word0b;  
            Pad5              at 6 * X_Word range X_Word0a .. X_Word0b;  
            Pad6              at 7 * X_Word range X_Word0a .. X_Word0b;  
        end record;  
 
    for X_Get_Pointer_Mapping_Reply use  
        record  
            Kind            at 0 * X_Word range X_Byte0a .. X_Byte0b;  
            N_Elts          at 0 * X_Word range X_Byte1a .. X_Byte1b;  
            Sequence_Number at 0 * X_Word range X_Half1a .. X_Half1b;  
            Length          at 1 * X_Word range X_Word0a .. X_Word0b;  
            Pad2            at 2 * X_Word range X_Word0a .. X_Word0b;  
            Pad3            at 3 * X_Word range X_Word0a .. X_Word0b;  
            Pad4            at 4 * X_Word range X_Word0a .. X_Word0b;  
            Pad5            at 5 * X_Word range X_Word0a .. X_Word0b;  
            Pad6            at 6 * X_Word range X_Word0a .. X_Word0b;  
            Pad7            at 7 * X_Word range X_Word0a .. X_Word0b;  
        end record;  
 
    for X_Get_Property_Reply use  
        record  
            Kind            at 0 * X_Word range X_Byte0a .. X_Byte0b;  
            Format          at 0 * X_Word range X_Byte1a .. X_Byte1b;  
            Sequence_Number at 0 * X_Word range X_Half1a .. X_Half1b;  
            Length          at 1 * X_Word range X_Word0a .. X_Word0b;  
            Property_Type   at 2 * X_Word range X_Word0a .. X_Word0b;  
            Bytes_After     at 3 * X_Word range X_Word0a .. X_Word0b;  
            N_Items         at 4 * X_Word range X_Word0a .. X_Word0b;  
            Pad1            at 5 * X_Word range X_Word0a .. X_Word0b;  
            Pad2            at 6 * X_Word range X_Word0a .. X_Word0b;  
            Pad3            at 7 * X_Word range X_Word0a .. X_Word0b;  
        end record;  
 
    for X_Get_Screen_Saver_Reply use  
        record  
            Kind            at 0 * X_Word range X_Byte0a .. X_Byte0b;  
            Pad1            at 0 * X_Word range X_Byte1a .. X_Byte1b;  
            Sequence_Number at 0 * X_Word range X_Half1a .. X_Half1b;  
            Length          at 1 * X_Word range X_Word0a .. X_Word0b;  
            Timeout         at 2 * X_Word range X_Half0a .. X_Half0b;  
            Interval        at 2 * X_Word range X_Half1a .. X_Half1b;  
            Prefer_Blanking at 3 * X_Word range X_Byte0a .. X_Byte0b;  
            Allow_Exposures at 3 * X_Word range X_Byte1a .. X_Byte1b;  
            Pad2            at 3 * X_Word range X_Half1a .. X_Half1b;  
            Pad3            at 4 * X_Word range X_Word0a .. X_Word0b;  
            Pad4            at 5 * X_Word range X_Word0a .. X_Word0b;  
            Pad5            at 6 * X_Word range X_Word0a .. X_Word0b;  
            Pad6            at 7 * X_Word range X_Word0a .. X_Word0b;  
        end record;  
 
    for X_Get_Selection_Owner_Reply use  
        record  
            Kind            at 0 * X_Word range X_Byte0a .. X_Byte0b;  
            Pad1            at 0 * X_Word range X_Byte1a .. X_Byte1b;  
            Sequence_Number at 0 * X_Word range X_Half1a .. X_Half1b;  
            Length          at 1 * X_Word range X_Word0a .. X_Word0b;  
            Owner           at 2 * X_Word range X_Word0a .. X_Word0b;  
            Pad2            at 3 * X_Word range X_Word0a .. X_Word0b;  
            Pad3            at 4 * X_Word range X_Word0a .. X_Word0b;  
            Pad4            at 5 * X_Word range X_Word0a .. X_Word0b;  
            Pad5            at 6 * X_Word range X_Word0a .. X_Word0b;  
            Pad6            at 7 * X_Word range X_Word0a .. X_Word0b;  
        end record;  
 
    for X_Get_Window_Attributes_Reply use  
        record  
            Kind                  at 0 * X_Word  range X_Byte0a .. X_Byte0b;  
            Backing_Store         at 0 * X_Word  range X_Byte1a .. X_Byte1b;  
            Sequence_Number       at 0 * X_Word  range X_Half1a .. X_Half1b;  
            Length                at 1 * X_Word  range X_Word0a .. X_Word0b;  
            Visual_Id             at 2 * X_Word  range X_Word0a .. X_Word0b;  
            Class                 at 3 * X_Word  range X_Half0a .. X_Half0b;  
            Bit_Gravity           at 3 * X_Word  range X_Byte2a .. X_Byte2b;  
            Win_Gravity           at 3 * X_Word  range X_Byte3a .. X_Byte3b;  
            Backing_Bit_Planes    at 4 * X_Word  range X_Word0a .. X_Word0b;  
            Backing_Pixel         at 5 * X_Word  range X_Word0a .. X_Word0b;  
            Save_Under            at 6 * X_Word  range X_Byte0a .. X_Byte0b;  
            Map_Installed         at 6 * X_Word  range X_Byte1a .. X_Byte1b;  
            Map_State             at 6 * X_Word  range X_Byte2a .. X_Byte2b;  
            Override              at 6 * X_Word  range X_Byte3a .. X_Byte3b;  
            Colormap              at 7 * X_Word  range X_Word0a .. X_Word0b;  
            All_Event_Masks       at 8 * X_Word  range X_Word0a .. X_Word0b;  
            Your_Event_Mask       at 9 * X_Word  range X_Word0a .. X_Word0b;  
            Do_Not_Propagate_Mask at 10 * X_Word range X_Half0a .. X_Half0b;  
            Pad                   at 10 * X_Word range X_Half1a .. X_Half1b;  
        end record;  
 
    for X_Grab_Keyboard_Reply use  
        record  
            Kind            at 0 * X_Word range X_Byte0a .. X_Byte0b;  
            Success         at 0 * X_Word range X_Byte1a .. X_Byte1b;  
            Sequence_Number at 0 * X_Word range X_Half1a .. X_Half1b;  
            Length          at 1 * X_Word range X_Word0a .. X_Word0b;  
            Pad1            at 2 * X_Word range X_Word0a .. X_Word0b;  
            Pad2            at 3 * X_Word range X_Word0a .. X_Word0b;  
            Pad3            at 4 * X_Word range X_Word0a .. X_Word0b;  
            Pad4            at 5 * X_Word range X_Word0a .. X_Word0b;  
            Pad5            at 6 * X_Word range X_Word0a .. X_Word0b;  
            Pad6            at 7 * X_Word range X_Word0a .. X_Word0b;  
        end record;  
 
    for X_Grab_Pointer_Reply use  
        record  
            Kind            at 0 * X_Word range X_Byte0a .. X_Byte0b;  
            Success         at 0 * X_Word range X_Byte1a .. X_Byte1b;  
            Sequence_Number at 0 * X_Word range X_Half1a .. X_Half1b;  
            Length          at 1 * X_Word range X_Word0a .. X_Word0b;  
            Pad1            at 2 * X_Word range X_Word0a .. X_Word0b;  
            Pad2            at 3 * X_Word range X_Word0a .. X_Word0b;  
            Pad3            at 4 * X_Word range X_Word0a .. X_Word0b;  
            Pad4            at 5 * X_Word range X_Word0a .. X_Word0b;  
            Pad5            at 6 * X_Word range X_Word0a .. X_Word0b;  
            Pad6            at 7 * X_Word range X_Word0a .. X_Word0b;  
        end record;  
 
    for X_Intern_Atom_Reply use  
        record  
            Kind            at 0 * X_Word range X_Byte0a .. X_Byte0b;  
            Pad1            at 0 * X_Word range X_Byte1a .. X_Byte1b;  
            Sequence_Number at 0 * X_Word range X_Half1a .. X_Half1b;  
            Length          at 1 * X_Word range X_Word0a .. X_Word0b;  
            Atom            at 2 * X_Word range X_Word0a .. X_Word0b;  
            Pad2            at 3 * X_Word range X_Word0a .. X_Word0b;  
            Pad3            at 4 * X_Word range X_Word0a .. X_Word0b;  
            Pad4            at 5 * X_Word range X_Word0a .. X_Word0b;  
            Pad5            at 6 * X_Word range X_Word0a .. X_Word0b;  
            Pad6            at 7 * X_Word range X_Word0a .. X_Word0b;  
        end record;  
 
    for X_List_Extensions_Reply use  
        record  
            Kind            at 0 * X_Word range X_Byte0a .. X_Byte0b;  
            N_Extensions    at 0 * X_Word range X_Byte1a .. X_Byte1b;  
            Sequence_Number at 0 * X_Word range X_Half1a .. X_Half1b;  
            Length          at 1 * X_Word range X_Word0a .. X_Word0b;  
            Pad2            at 2 * X_Word range X_Word0a .. X_Word0b;  
            Pad3            at 3 * X_Word range X_Word0a .. X_Word0b;  
            Pad4            at 4 * X_Word range X_Word0a .. X_Word0b;  
            Pad5            at 5 * X_Word range X_Word0a .. X_Word0b;  
            Pad6            at 6 * X_Word range X_Word0a .. X_Word0b;  
            Pad7            at 7 * X_Word range X_Word0a .. X_Word0b;  
        end record;  
 
    for X_List_Fonts_Reply use  
        record  
            Kind            at 0 * X_Word range X_Byte0a .. X_Byte0b;  
            Pad1            at 0 * X_Word range X_Byte1a .. X_Byte1b;  
            Sequence_Number at 0 * X_Word range X_Half1a .. X_Half1b;  
            Length          at 1 * X_Word range X_Word0a .. X_Word0b;  
            N_Fonts         at 2 * X_Word range X_Half0a .. X_Half0b;  
            Pad2            at 2 * X_Word range X_Half1a .. X_Half1b;  
            Pad3            at 3 * X_Word range X_Word0a .. X_Word0b;  
            Pad4            at 4 * X_Word range X_Word0a .. X_Word0b;  
            Pad5            at 5 * X_Word range X_Word0a .. X_Word0b;  
            Pad6            at 6 * X_Word range X_Word0a .. X_Word0b;  
            Pad7            at 7 * X_Word range X_Word0a .. X_Word0b;  
        end record;  
 
    for X_List_Fonts_With_Info_Reply use  
        record  
            Kind              at 0 * X_Word  range X_Byte0a .. X_Byte0b;  
            Name_Length       at 0 * X_Word  range X_Byte1a .. X_Byte1b;  
            Sequence_Number   at 0 * X_Word  range X_Half1a .. X_Half1b;  
            Length            at 1 * X_Word  range X_Word0a .. X_Word0b;  
            Min_Bounds        at 2 * X_Word  range 0 .. 3 * 32 - 1;  
            Walign1           at 5 * X_Word  range X_Word0a .. X_Word0b;  
            Max_Bounds        at 6 * X_Word  range 0 .. 3 * 32 - 1;  
            Walign2           at 9 * X_Word  range X_Word0a .. X_Word0b;  
            Min_Char_Or_Byte2 at 10 * X_Word range X_Half0a .. X_Half0b;  
            Max_Char_Or_Byte2 at 10 * X_Word range X_Half1a .. X_Half1b;  
            Default_Char      at 11 * X_Word range X_Half0a .. X_Half0b;  
            N_Font_Props      at 11 * X_Word range X_Half1a .. X_Half1b;  
            Draw_Direction    at 12 * X_Word range X_Byte0a .. X_Byte0b;  
            Min_Byte1         at 12 * X_Word range X_Byte1a .. X_Byte1b;  
            Max_Byte1         at 12 * X_Word range X_Byte2a .. X_Byte2b;  
            All_Chars_Exist   at 12 * X_Word range X_Byte3a .. X_Byte3b;  
            Font_Ascent       at 13 * X_Word range X_Half0a .. X_Half0b;  
            Font_Descent      at 13 * X_Word range X_Half1a .. X_Half1b;  
            N_Replies         at 14 * X_Word range X_Word0a .. X_Word0b;  
 
        end record;  
 
    for X_List_Hosts_Reply use  
        record  
            Kind            at 0 * X_Word range X_Byte0a .. X_Byte0b;  
            Enabled         at 0 * X_Word range X_Byte1a .. X_Byte1b;  
            Sequence_Number at 0 * X_Word range X_Half1a .. X_Half1b;  
            Length          at 1 * X_Word range X_Word0a .. X_Word0b;  
            N_Hosts         at 2 * X_Word range X_Half0a .. X_Half0b;  
            Pad1            at 2 * X_Word range X_Half1a .. X_Half1b;  
            Pad3            at 3 * X_Word range X_Word0a .. X_Word0b;  
            Pad4            at 4 * X_Word range X_Word0a .. X_Word0b;  
            Pad5            at 5 * X_Word range X_Word0a .. X_Word0b;  
            Pad6            at 6 * X_Word range X_Word0a .. X_Word0b;  
            Pad7            at 7 * X_Word range X_Word0a .. X_Word0b;  
        end record;  
 
    for X_Wire_Host_Reply use  
        record  
            Family      at 0 * X_Word range X_Byte0a .. X_Byte0b;  
            Pad         at 0 * X_Word range X_Byte1a .. X_Byte1b;  
            Name_Length at 0 * X_Word range X_Half1a .. X_Half1b;  
        end record;  
 
    for X_List_Installed_Colormaps_Reply use  
        record  
            Kind            at 0 * X_Word range X_Byte0a .. X_Byte0b;  
            Pad1            at 0 * X_Word range X_Byte1a .. X_Byte1b;  
            Sequence_Number at 0 * X_Word range X_Half1a .. X_Half1b;  
            Length          at 1 * X_Word range X_Word0a .. X_Word0b;  
            N_Colormaps     at 2 * X_Word range X_Half0a .. X_Half0b;  
            Pad2            at 2 * X_Word range X_Half1a .. X_Half1b;  
            Pad3            at 3 * X_Word range X_Word0a .. X_Word0b;  
            Pad4            at 4 * X_Word range X_Word0a .. X_Word0b;  
            Pad5            at 5 * X_Word range X_Word0a .. X_Word0b;  
            Pad6            at 6 * X_Word range X_Word0a .. X_Word0b;  
            Pad7            at 7 * X_Word range X_Word0a .. X_Word0b;  
        end record;  
 
    for X_List_Properties_Reply use  
        record  
            Kind            at 0 * X_Word range X_Byte0a .. X_Byte0b;  
            Pad1            at 0 * X_Word range X_Byte1a .. X_Byte1b;  
            Sequence_Number at 0 * X_Word range X_Half1a .. X_Half1b;  
            Length          at 1 * X_Word range X_Word0a .. X_Word0b;  
            N_Properties    at 2 * X_Word range X_Half0a .. X_Half0b;  
            Pad2            at 2 * X_Word range X_Half1a .. X_Half1b;  
            Pad3            at 3 * X_Word range X_Word0a .. X_Word0b;  
            Pad4            at 4 * X_Word range X_Word0a .. X_Word0b;  
            Pad5            at 5 * X_Word range X_Word0a .. X_Word0b;  
            Pad6            at 6 * X_Word range X_Word0a .. X_Word0b;  
            Pad7            at 7 * X_Word range X_Word0a .. X_Word0b;  
        end record;  
 
    for X_Lookup_Color_Reply use  
        record  
            Kind            at 0 * X_Word range X_Byte0a .. X_Byte0b;  
            Pad1            at 0 * X_Word range X_Byte1a .. X_Byte1b;  
            Sequence_Number at 0 * X_Word range X_Half1a .. X_Half1b;  
            Length          at 1 * X_Word range X_Word0a .. X_Word0b;  
            Exact_Red       at 2 * X_Word range X_Half0a .. X_Half0b;  
            Exact_Green     at 2 * X_Word range X_Half1a .. X_Half1b;  
            Exact_Blue      at 3 * X_Word range X_Half0a .. X_Half0b;  
            Screen_Red      at 3 * X_Word range X_Half1a .. X_Half1b;  
            Screen_Green    at 4 * X_Word range X_Half0a .. X_Half0b;  
            Screen_Blue     at 4 * X_Word range X_Half1a .. X_Half1b;  
            Pad3            at 5 * X_Word range X_Word0a .. X_Word0b;  
            Pad4            at 6 * X_Word range X_Word0a .. X_Word0b;  
            Pad5            at 7 * X_Word range X_Word0a .. X_Word0b;  
        end record;  
 
    for X_Query_Best_Size_Reply use  
        record  
            Kind            at 0 * X_Word range X_Byte0a .. X_Byte0b;  
            Pad1            at 0 * X_Word range X_Byte1a .. X_Byte1b;  
            Sequence_Number at 0 * X_Word range X_Half1a .. X_Half1b;  
            Length          at 1 * X_Word range X_Word0a .. X_Word0b;  
            Width           at 2 * X_Word range X_Half0a .. X_Half0b;  
            Height          at 2 * X_Word range X_Half1a .. X_Half1b;  
            Pad3            at 3 * X_Word range X_Word0a .. X_Word0b;  
            Pad4            at 4 * X_Word range X_Word0a .. X_Word0b;  
            Pad5            at 5 * X_Word range X_Word0a .. X_Word0b;  
            Pad6            at 6 * X_Word range X_Word0a .. X_Word0b;  
            Pad7            at 7 * X_Word range X_Word0a .. X_Word0b;  
        end record;  
 
    for X_Query_Colors_Reply use  
        record  
            Kind            at 0 * X_Word range X_Byte0a .. X_Byte0b;  
            Pad1            at 0 * X_Word range X_Byte1a .. X_Byte1b;  
            Sequence_Number at 0 * X_Word range X_Half1a .. X_Half1b;  
            Length          at 1 * X_Word range X_Word0a .. X_Word0b;  
            N_Colors        at 2 * X_Word range X_Half0a .. X_Half0b;  
            Pad2            at 2 * X_Word range X_Half1a .. X_Half1b;  
            Pad3            at 3 * X_Word range X_Word0a .. X_Word0b;  
            Pad4            at 4 * X_Word range X_Word0a .. X_Word0b;  
            Pad5            at 5 * X_Word range X_Word0a .. X_Word0b;  
            Pad6            at 6 * X_Word range X_Word0a .. X_Word0b;  
            Pad7            at 7 * X_Word range X_Word0a .. X_Word0b;  
        end record;  
 
    for X_Rgb use  
        record  
            Red   at 0 * X_Word range X_Half0a .. X_Half0b;  
            Green at 0 * X_Word range X_Half1a .. X_Half1b;  
            Blue  at 1 * X_Word range X_Half0a .. X_Half0b;  
            Pad   at 1 * X_Word range X_Half1a .. X_Half1b;  
        end record;  
 
    for X_Query_Extension_Reply use  
        record  
            Kind            at 0 * X_Word range X_Byte0a .. X_Byte0b;  
            Pad1            at 0 * X_Word range X_Byte1a .. X_Byte1b;  
            Sequence_Number at 0 * X_Word range X_Half1a .. X_Half1b;  
            Length          at 1 * X_Word range X_Word0a .. X_Word0b;  
            Present         at 2 * X_Word range X_Byte0a .. X_Byte0b;  
            Major_Opcode    at 2 * X_Word range X_Byte1a .. X_Byte1b;  
            First_Event     at 2 * X_Word range X_Byte2a .. X_Byte2b;  
            First_Error     at 2 * X_Word range X_Byte3a .. X_Byte3b;  
            Pad3            at 3 * X_Word range X_Word0a .. X_Word0b;  
            Pad4            at 4 * X_Word range X_Word0a .. X_Word0b;  
            Pad5            at 5 * X_Word range X_Word0a .. X_Word0b;  
            Pad6            at 6 * X_Word range X_Word0a .. X_Word0b;  
            Pad7            at 7 * X_Word range X_Word0a .. X_Word0b;  
        end record;  
 
    for X_Query_Font_Reply use  
        record  
            Kind              at 0 * X_Word  range X_Byte0a .. X_Byte0b;  
            Pad1              at 0 * X_Word  range X_Byte1a .. X_Byte1b;  
            Sequence_Number   at 0 * X_Word  range X_Half1a .. X_Half1b;  
            Length            at 1 * X_Word  range X_Word0a .. X_Word0b;  
            Min_Bounds        at 2 * X_Word  range 0 .. 3 * 32 - 1;  
            Walign1           at 5 * X_Word  range X_Word0a .. X_Word0b;  
            Max_Bounds        at 6 * X_Word  range 0 .. 3 * 32 - 1;  
            Walign2           at 9 * X_Word  range X_Word0a .. X_Word0b;  
            Min_Char_Or_Byte2 at 10 * X_Word range X_Half0a .. X_Half0b;  
            Max_Char_Or_Byte2 at 10 * X_Word range X_Half1a .. X_Half1b;  
            Default_Char      at 11 * X_Word range X_Half0a .. X_Half0b;  
            N_Font_Props      at 11 * X_Word range X_Half1a .. X_Half1b;  
            Draw_Direction    at 12 * X_Word range X_Byte0a .. X_Byte0b;  
            Min_Byte1         at 12 * X_Word range X_Byte1a .. X_Byte1b;  
            Max_Byte1         at 12 * X_Word range X_Byte2a .. X_Byte2b;  
            All_Chars_Exist   at 12 * X_Word range X_Byte3a .. X_Byte3b;  
            Font_Ascent       at 13 * X_Word range X_Half0a .. X_Half0b;  
            Font_Descent      at 13 * X_Word range X_Half1a .. X_Half1b;  
            N_Char_Infos      at 14 * X_Word range X_Word0a .. X_Word0b;  
 
        end record;  
 
    for X_Query_Keymap_Reply use  
        record  
            Kind            at 0 * X_Word range X_Byte0a .. X_Byte0b;  
            Pad1            at 0 * X_Word range X_Byte1a .. X_Byte1b;  
            Sequence_Number at 0 * X_Word range X_Half1a .. X_Half1b;  
            Length          at 1 * X_Word range X_Word0a .. X_Word0b;  
            Map             at 2 * X_Word range 0 .. 8 * 32 - 1;  
        end record;  
 
    for X_Query_Pointer_Reply use  
        record  
            Kind            at 0 * X_Word range X_Byte0a .. X_Byte0b;  
            Same_Screen     at 0 * X_Word range X_Byte1a .. X_Byte1b;  
            Sequence_Number at 0 * X_Word range X_Half1a .. X_Half1b;  
            Length          at 1 * X_Word range X_Word0a .. X_Word0b;  
            Root            at 2 * X_Word range X_Word0a .. X_Word0b;  
            Child           at 3 * X_Word range X_Word0a .. X_Word0b;  
            Root_X          at 4 * X_Word range X_Half0a .. X_Half0b;  
            Root_Y          at 4 * X_Word range X_Half1a .. X_Half1b;  
            Win_X           at 5 * X_Word range X_Half0a .. X_Half0b;  
            Win_Y           at 5 * X_Word range X_Half1a .. X_Half1b;  
            Mask            at 6 * X_Word range X_Half0a .. X_Half0b;  
            Pad1            at 6 * X_Word range X_Half1a .. X_Half1b;  
            Pad             at 7 * X_Word range X_Word0a .. X_Word0b;  
        end record;  
 
    for X_Query_Text_Extents_Reply use  
        record  
            Kind            at 0 * X_Word range X_Byte0a .. X_Byte0b;  
            Draw_Direction  at 0 * X_Word range X_Byte1a .. X_Byte1b;  
            Sequence_Number at 0 * X_Word range X_Half1a .. X_Half1b;  
            Length          at 1 * X_Word range X_Word0a .. X_Word0b;  
            Font_Ascent     at 2 * X_Word range X_Half0a .. X_Half0b;  
            Font_Descent    at 2 * X_Word range X_Half1a .. X_Half1b;  
            Overall_Ascent  at 3 * X_Word range X_Half0a .. X_Half0b;  
            Overall_Descent at 3 * X_Word range X_Half1a .. X_Half1b;  
            Overall_Width   at 4 * X_Word range X_Word0a .. X_Word0b;  
            Overall_Left    at 5 * X_Word range X_Word0a .. X_Word0b;  
            Overall_Right   at 6 * X_Word range X_Word0a .. X_Word0b;  
            Pad             at 7 * X_Word range X_Word0a .. X_Word0b;  
        end record;  
 
    for X_Query_Tree_Reply use  
        record  
            Kind            at 0 * X_Word range X_Byte0a .. X_Byte0b;  
            Pad1            at 0 * X_Word range X_Byte1a .. X_Byte1b;  
            Sequence_Number at 0 * X_Word range X_Half1a .. X_Half1b;  
            Length          at 1 * X_Word range X_Word0a .. X_Word0b;  
            Root            at 2 * X_Word range X_Word0a .. X_Word0b;  
            Parent          at 3 * X_Word range X_Word0a .. X_Word0b;  
            N_Children      at 4 * X_Word range X_Half0a .. X_Half0b;  
            Pad2            at 4 * X_Word range X_Half1a .. X_Half1b;  
            Pad3            at 5 * X_Word range X_Word0a .. X_Word0b;  
            Pad4            at 6 * X_Word range X_Word0a .. X_Word0b;  
            Pad5            at 7 * X_Word range X_Word0a .. X_Word0b;  
        end record;  
 
    for X_Set_Modifier_Mapping_Reply use  
        record  
            Kind            at 0 * X_Word range X_Byte0a .. X_Byte0b;  
            Success         at 0 * X_Word range X_Byte1a .. X_Byte1b;  
            Sequence_Number at 0 * X_Word range X_Half1a .. X_Half1b;  
            Length          at 1 * X_Word range X_Word0a .. X_Word0b;  
            Pad2            at 2 * X_Word range X_Word0a .. X_Word0b;  
            Pad3            at 3 * X_Word range X_Word0a .. X_Word0b;  
            Pad4            at 4 * X_Word range X_Word0a .. X_Word0b;  
            Pad5            at 5 * X_Word range X_Word0a .. X_Word0b;  
            Pad6            at 6 * X_Word range X_Word0a .. X_Word0b;  
            Pad7            at 7 * X_Word range X_Word0a .. X_Word0b;  
        end record;  
 
    for X_Set_Pointer_Mapping_Reply use  
        record  
            Kind            at 0 * X_Word range X_Byte0a .. X_Byte0b;  
            Success         at 0 * X_Word range X_Byte1a .. X_Byte1b;  
            Sequence_Number at 0 * X_Word range X_Half1a .. X_Half1b;  
            Length          at 1 * X_Word range X_Word0a .. X_Word0b;  
            Pad2            at 2 * X_Word range X_Word0a .. X_Word0b;  
            Pad3            at 3 * X_Word range X_Word0a .. X_Word0b;  
            Pad4            at 4 * X_Word range X_Word0a .. X_Word0b;  
            Pad5            at 5 * X_Word range X_Word0a .. X_Word0b;  
            Pad6            at 6 * X_Word range X_Word0a .. X_Word0b;  
            Pad7            at 7 * X_Word range X_Word0a .. X_Word0b;  
        end record;  
 
    for X_Translate_Coords_Reply use  
        record  
            Kind            at 0 * X_Word range X_Byte0a .. X_Byte0b;  
            Same_Screen     at 0 * X_Word range X_Byte1a .. X_Byte1b;  
            Sequence_Number at 0 * X_Word range X_Half1a .. X_Half1b;  
            Length          at 1 * X_Word range X_Word0a .. X_Word0b;  
            Child           at 2 * X_Word range X_Word0a .. X_Word0b;  
            Dst_X           at 3 * X_Word range X_Half0a .. X_Half0b;  
            Dst_Y           at 3 * X_Word range X_Half1a .. X_Half1b;  
            Pad2            at 4 * X_Word range X_Word0a .. X_Word0b;  
            Pad3            at 5 * X_Word range X_Word0a .. X_Word0b;  
            Pad4            at 6 * X_Word range X_Word0a .. X_Word0b;  
            Pad5            at 7 * X_Word range X_Word0a .. X_Word0b;  
        end record;  
 
--/ end if;  

--
end Xlbt_Reply3;  

