with Xlbt_Basic3;  
use Xlbt_Basic3;  
with Xlbt_Rm3;  

package Xlbt_Rm is  
------------------------------------------------------------------------------  
-- X Library Resource Manager - Normal User Interface  
--  
-- Xlbt_Rm - Resource Manager Data Types  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1987 - 1988 by Digital Equipment Corporation, Maynard, Mass.  
-- Copyright 1987 - 1989 by Massachusetts Institute of Technology,  
--                          Cambridge, Massachusetts.  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of Digital, MIT, or Rational  
-- not be used in advertising or publicity pertaining to distribution of  
-- the software without specific, written prior permission.  
--  
-- Digital, MIT, and Rational disclaim all warranties with regard to this  
-- software, including all implied warranties of merchantability and fitness,  
-- in no event shall Digital, MIT, or Rational be liable for any special,  
-- indirect or consequential damages or any damages whatsoever resulting from  
-- loss of use, data or profits, whether in an action of contract, negligence  
-- or other tortious action, arising out of or in connection with the use or  
-- performance of this software.  
------------------------------------------------------------------------------  

    package R3 renames Xlbt_Rm3;  

--
------------------------------------------------------------------------------  
-- Misc. X Resource Manager Types  
------------------------------------------------------------------------------  

------------------------------------------------------------------------------  
-- X_Rm_Dims  
------------------------------------------------------------------------------  

    subtype X_Rm_Dims is R3.X_Rm_Dims;  

    function "=" (A, B : X_Rm_Dims) return Boolean renames R3."=";  

------------------------------------------------------------------------------  
-- X_Rm_Pos  
------------------------------------------------------------------------------  

    subtype X_Rm_Pos is R3.X_Rm_Pos;  

    function "=" (A, B : X_Rm_Pos) return Boolean renames R3."=";  

------------------------------------------------------------------------------  
-- X_Rm_Geometry  
------------------------------------------------------------------------------  

    subtype X_Rm_Geometry is R3.X_Rm_Geometry;  

    function "=" (A, B : X_Rm_Geometry) return Boolean renames R3."=";  

------------------------------------------------------------------------------  
-- X_Rm_Option_Kind  
--  
--      X_Rm_Option_No_Arg      - Value is specified in Option_Desc.value  
--      X_Rm_Option_Is_Arg      - Value is the option string itself  
--      X_Rm_Option_Sticky_Arg  - Value is text immediately following option  
--      X_Rm_Option_Sep_Arg     - Value is next argument in Arg_V  
--      X_Rm_Option_Res_Arg     - Resource and value in next arg in Arg_V  
--      X_Rm_Option_Skip_Arg    - Ignore option and next argument in Arg_V  
--      X_Rm_Option_Skip_Line   - Ignore option and the rest of Arg_V  
------------------------------------------------------------------------------  

    subtype X_Rm_Option_Kind is R3.X_Rm_Option_Kind;  

    subtype Xrom is X_Rm_Option_Kind;  

    X_Rm_Option_No_Arg      : constant Xrom := R3.X_Rm_Option_No_Arg;  
    X_Rm_Option_Is_Arg      : constant Xrom := R3.X_Rm_Option_Is_Arg;  
    X_Rm_Option_Sticky_Arg  : constant Xrom := R3.X_Rm_Option_Sticky_Arg;  
    X_Rm_Option_Sep_Arg     : constant Xrom := R3.X_Rm_Option_Sep_Arg;  
    X_Rm_Option_Res_Arg     : constant Xrom := R3.X_Rm_Option_Res_Arg;  
    X_Rm_Option_Skip_Arg    : constant Xrom := R3.X_Rm_Option_Skip_Arg;  
    X_Rm_Option_Skip_Line   : constant Xrom := R3.X_Rm_Option_Skip_Line;  
    X_Rm_Option_Skip_N_Args : constant Xrom := R3.X_Rm_Option_Skip_N_Args;  

    None_X_Rm_Option_Kind : X_Rm_Option_Kind renames R3.None_X_Rm_Option_Kind;  

    function "=" (A, B : X_Rm_Option_Kind) return Boolean renames R3."=";  

------------------------------------------------------------------------------  
-- X_Rm_Option_Desc - Command line option mapping to resource entries  
------------------------------------------------------------------------------  

    subtype X_Rm_Option_Desc       is R3.X_Rm_Option_Desc;  
    subtype X_Rm_Option_Desc_Array is R3.X_Rm_Option_Desc_Array;  

------------------------------------------------------------------------------  
-- X_Rm_Status - Status of various RM operations; used when X_Status is not  
--               sufficient.  
--  
--    Rm_Successful    -- Fully successful.  
--    Rm_Had_Errors    -- Had errors, recovery has been attempted.  
--    Rm_Failed        -- Had errors, no further recovery was possible.  
------------------------------------------------------------------------------  

    subtype X_Rm_Status is R3.X_Rm_Status;  

    Rm_Successful : constant X_Rm_Status := R3.Rm_Successful;  
    Rm_Had_Errors : constant X_Rm_Status := R3.Rm_Had_Errors;  
    Rm_Failed     : constant X_Rm_Status := R3.Rm_Failed;  
--  
    function "=" (A, B : X_Rm_Status) return Boolean renames R3."=";  
    function ">" (A, B : X_Rm_Status) return Boolean renames R3.">";  
    function "<" (A, B : X_Rm_Status) return Boolean renames R3."<";  

--
------------------------------------------------------------------------------  
-- X Resource Manager Quark/String Types  
------------------------------------------------------------------------------  

------------------------------------------------------------------------------  
-- X_Rm_Class  
------------------------------------------------------------------------------  

    subtype X_Rm_Class       is R3.X_Rm_Class;  
    subtype X_Rm_Class_Array is R3.X_Rm_Class_Array;  
    subtype X_Rm_Class_List  is R3.X_Rm_Class_List;  

    None_X_Rm_Class      : X_Rm_Class      renames R3.None_X_Rm_Class;  
    None_X_Rm_Class_List : X_Rm_Class_List renames R3.None_X_Rm_Class_List;  

    function "=" (A, B : X_Rm_Class)       return Boolean renames R3."=";  
    function "=" (A, B : X_Rm_Class_Array) return Boolean renames R3."=";  

    procedure Free_X_Rm_Class_List (List : in out X_Rm_Class_List)  
        renames R3.Free_X_Rm_Class_List;  

------------------------------------------------------------------------------  
-- X_Rm_Quark  
------------------------------------------------------------------------------  

    subtype X_Rm_Quark      is R3.X_Rm_Quark;  
    subtype X_Rm_Quark_List is R3.X_Rm_Quark_List;  

    None_X_Rm_Quark      : X_Rm_Quark      renames R3.None_X_Rm_Quark;  
    None_X_Rm_Quark_List : X_Rm_Quark_List renames R3.None_X_Rm_Quark_List;  

    function  "=" (A, B : X_Rm_Quark) return Boolean renames R3."=";  
    function  "=" (A, B : X_Rm_Quark_List) return Boolean renames R3."=";  
    procedure Free_X_Rm_Quark_List (List : in out X_Rm_Quark_List)  
        renames R3.Free_X_Rm_Quark_List;  

------------------------------------------------------------------------------  
-- X_Rm_Name  
------------------------------------------------------------------------------  

    subtype X_Rm_Name       is R3.X_Rm_Name;  
    subtype X_Rm_Name_Array is R3.X_Rm_Name_Array;  
    subtype X_Rm_Name_List  is R3.X_Rm_Name_List;  

    None_X_Rm_Name      : X_Rm_Name      renames R3.None_X_Rm_Name;  
    None_X_Rm_Name_List : X_Rm_Name_List renames R3.None_X_Rm_Name_List;  

    function "=" (A, B : X_Rm_Name)       return Boolean renames R3."=";  
    function "=" (A, B : X_Rm_Name_Array) return Boolean renames R3."=";  

    procedure Free_X_Rm_Name_List (List : in out X_Rm_Name_List)  
        renames R3.Free_X_Rm_Name_List;  

------------------------------------------------------------------------------  
-- X_Rm_Representation  
------------------------------------------------------------------------------  

    subtype X_Rm_Representation       is R3.X_Rm_Representation;  
    subtype X_Rm_Representation_Array is R3.X_Rm_Representation_Array;  
    subtype X_Rm_Representation_List  is R3.X_Rm_Representation_List;  

    None_X_Rm_Representation      : X_Rm_Representation  
        renames R3.None_X_Rm_Representation;  
    None_X_Rm_Representation_List : X_Rm_Representation_List  
        renames R3.None_X_Rm_Representation_List;  

    function "=" (A, B : X_Rm_Representation) return Boolean renames R3."=";  
    function "=" (A, B : X_Rm_Representation_Array) return Boolean  
        renames R3."=";  

    procedure Free_X_Rm_Representation_List  
                 (List : in out X_Rm_Representation_List)  
        renames R3.Free_X_Rm_Representation_List;  

--
------------------------------------------------------------------------------  
-- X Resource Manager Databases and Database Support Types  
------------------------------------------------------------------------------  

------------------------------------------------------------------------------  
-- X_Rm_Database - A record (possibly) containing a Hash Bucket pointer.  
------------------------------------------------------------------------------  

    subtype X_Rm_Database is R3.X_Rm_Database;  

    None_X_Rm_Database : X_Rm_Database renames R3.None_X_Rm_Database;  

    function "=" (A, B : X_Rm_Database) return Boolean renames R3."=";  

------------------------------------------------------------------------------  
-- X_Rm_Entry - Resource Database Entry  
------------------------------------------------------------------------------  

    subtype X_Rm_Entry_Rec is R3.X_Rm_Entry_Rec;  
    subtype X_Rm_Entry     is R3.X_Rm_Entry;  

    function "=" (A, B : X_Rm_Entry) return Boolean renames R3."=";  

    None_X_Rm_Entry : X_Rm_Entry renames R3.None_X_Rm_Entry;  

------------------------------------------------------------------------------  
-- X_Rm_Value  
------------------------------------------------------------------------------  

    subtype X_Rm_Value             is R3.X_Rm_Value;  
    subtype X_Rm_Universal_Pointer is R3.X_Rm_Universal_Pointer;  

    None_X_Rm_Value             : X_Rm_Value             := R3.None_X_Rm_Value;  
    None_X_Rm_Universal_Pointer : X_Rm_Universal_Pointer :=  
       R3.None_X_Rm_Universal_Pointer;  

    function "=" (A, B : X_Rm_Value)             return Boolean renames R3."=";  
    function "=" (A, B : X_Rm_Universal_Pointer) return Boolean renames R3."=";  

------------------------------------------------------------------------------  
-- X_Rm_Value_Kind - Explicit types of X_Rm_Value  
------------------------------------------------------------------------------  

    subtype X_Rm_Value_Kind is R3.X_Rm_Value_Kind;  

    subtype Xrvk is X_Rm_Value_Kind;  

    Is_None                   : constant Xrvk := R3.Is_None;  
    Is_X_Rm_File_Type         : constant Xrvk := R3.Is_X_Rm_File_Type;  
    Is_Boolean                : constant Xrvk := R3.Is_Boolean;  
    Is_Float                  : constant Xrvk := R3.Is_Float;  
    Is_U_Char_List            : constant Xrvk := R3.Is_U_Char_List;  
    Is_U_Char                 : constant Xrvk := R3.Is_U_Char;  
    Is_U_Short                : constant Xrvk := R3.Is_U_Short;  
    Is_S_Char                 : constant Xrvk := R3.Is_S_Char;  
    Is_S_Short                : constant Xrvk := R3.Is_S_Short;  
    Is_S_Long                 : constant Xrvk := R3.Is_S_Long;  
    Is_X_String7_Pointer      : constant Xrvk := R3.Is_X_String7_Pointer;  
    Is_X_String_Pointer       : constant Xrvk := R3.Is_X_String_Pointer;  
    Is_X_String16_Pointer     : constant Xrvk := R3.Is_X_String16_Pointer;  
    Is_X_Universal_Pointer    : constant Xrvk := R3.Is_X_Universal_Pointer;  
    Is_X_Atom                 : constant Xrvk := R3.Is_X_Atom;  
    Is_X_Color                : constant Xrvk := R3.Is_X_Color;  
    Is_X_Colormap             : constant Xrvk := R3.Is_X_Colormap;  
    Is_X_Cursor               : constant Xrvk := R3.Is_X_Cursor;  
    Is_X_Display              : constant Xrvk := R3.Is_X_Display;  
    Is_X_Font                 : constant Xrvk := R3.Is_X_Font;  
    Is_X_Font_Struct          : constant Xrvk := R3.Is_X_Font_Struct;  
    Is_X_Initial_Window_State : constant Xrvk := R3.Is_X_Initial_Window_State;  
    Is_X_Pixel                : constant Xrvk := R3.Is_X_Pixel;  
    Is_X_Pixmap               : constant Xrvk := R3.Is_X_Pixmap;  
    Is_X_Screen               : constant Xrvk := R3.Is_X_Screen;  
    Is_X_Time                 : constant Xrvk := R3.Is_X_Time;  
    Is_X_Visual               : constant Xrvk := R3.Is_X_Visual;  
    Is_X_Window               : constant Xrvk := R3.Is_X_Window;  

    function "=" (A, B : X_Rm_Value_Kind) return Boolean renames R3."=";  

--
------------------------------------------------------------------------------  
-- X Resource Manager Search Lists  
------------------------------------------------------------------------------  

------------------------------------------------------------------------------  
-- X_Rm_Binding  
--  
--      X_Rm_Bind_Tightly  
--      X_Rm_Bind_Loosely  
------------------------------------------------------------------------------  

    subtype X_Rm_Binding is R3.X_Rm_Binding;  

    X_Rm_Bind_Tightly : constant X_Rm_Binding := R3.X_Rm_Bind_Tightly;  
    X_Rm_Bind_Loosely : constant X_Rm_Binding := R3.X_Rm_Bind_Loosely;  

    subtype X_Rm_Binding_Array is R3.X_Rm_Binding_Array;  

    function "=" (A, B : X_Rm_Binding) return Boolean renames R3."=";  

------------------------------------------------------------------------------  
-- X_Rm_Search_List - a series of related Hash Tables  
------------------------------------------------------------------------------  

    subtype X_Rm_Search_List is R3.X_Rm_Search_List;  

    function "=" (A, B : X_Rm_Search_List) return Boolean renames R3."=";  

end Xlbt_Rm;  

