with Xlbt_Basic3;  
use Xlbt_Basic3;  
with Xlbt_Rm3;  

package Xlbt_Rm2 is  
------------------------------------------------------------------------------  
-- X Library Resource Manager - Extended User Interface  
--  
-- Xlbt_Rm2 - Resource Manager Data Types  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1987 - 1989 by Digital Equipment Corporation, Maynard, Mass.  
-- Copyright 1987 - 1989 by Massachusetts Institute of Technology,  
--                          Cambridge, Massachusetts.  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of Digital, MIT, or Rational  
-- not be used in advertising or publicity pertaining to distribution of  
-- the software without specific, written prior permission.  
--  
-- Digital, MIT, and Rational disclaim all warranties with regard to this  
-- software, including all implied warranties of merchantability and fitness,  
-- in no event shall Digital, MIT, or Rational be liable for any special,  
-- indirect or consequential damages or any damages whatsoever resulting from  
-- loss of use, data or profits, whether in an action of contract, negligence  
-- or other tortious action, arising out of or in connection with the use or  
-- performance of this software.  
------------------------------------------------------------------------------  

--
    package R3 renames Xlbt_Rm3;  

------------------------------------------------------------------------------  
-- X_Rm_Option_Desc  
------------------------------------------------------------------------------  

    subtype X_Rm_Option_Desc is R3.X_Rm_Option_Desc;  


------------------------------------------------------------------------------  
-- X_Rm_Quark  
------------------------------------------------------------------------------  

    subtype X_Rm_Quark_Array is R3.X_Rm_Quark_Array;  


    function "=" (A, B : X_Rm_Quark_Array) return Boolean renames R3."=";  


------------------------------------------------------------------------------  
-- X_Rm_Database - A record (possibly) containing a Hash Bucket pointer.  
------------------------------------------------------------------------------  

    subtype X_Rm_Database_Rec is R3.X_Rm_Database_Rec;  

------------------------------------------------------------------------------  
-- X_Rm_Search_List  
------------------------------------------------------------------------------  

    subtype X_Rm_Search_List_Entry is R3.X_Rm_Search_List_Entry;  

    function "&" (A : R3.X_Rm_Search_List;  
                  B : R3.X_Rm_Search_List_Entry) return R3.X_Rm_Search_List  
        renames R3."&";  
    function "&" (A, B : R3.X_Rm_Search_List)    return R3.X_Rm_Search_List  
        renames R3."&";  
    function "=" (A, B : X_Rm_Search_List_Entry) return Boolean renames R3."=";  

------------------------------------------------------------------------------  
-- X_Rm_Hash_Bucket - records a value and possibly dependent/refined values.  
------------------------------------------------------------------------------  

    subtype X_Rm_Hash_Bucket_Rec   is R3.X_Rm_Hash_Bucket_Rec;  
    subtype X_Rm_Hash_Bucket       is R3.X_Rm_Hash_Bucket;  
    subtype X_Rm_Hash_Bucket_Array is R3.X_Rm_Hash_Bucket_Array;  
    subtype X_Rm_Hash_Table        is R3.X_Rm_Hash_Table;  

    function "=" (A, B : X_Rm_Hash_Bucket) return Boolean renames R3."=";  
    function "=" (A, B : X_Rm_Hash_Table)  return Boolean renames R3."=";  

    None_X_Rm_Hash_Bucket : X_Rm_Hash_Bucket renames R3.None_X_Rm_Hash_Bucket;  
    None_X_Rm_Hash_Table : X_Rm_Hash_Table renames R3.None_X_Rm_Hash_Table;  
    None_X_Rm_Hash_Bucket_Rec : X_Rm_Hash_Bucket_Rec  
        renames R3.None_X_Rm_Hash_Bucket_Rec;  

    procedure Free_X_Rm_Hash_Bucket (Bucket : in out X_Rm_Hash_Bucket)  
        renames R3.Free_X_Rm_Hash_Bucket;  

    procedure Free_X_Rm_Hash_Table (Table : in out X_Rm_Hash_Table)  
        renames R3.Free_X_Rm_Hash_Table;  

------------------------------------------------------------------------------  
-- X_Rm_File_Type - Text_Io.File_Type is limited private; ths is not.  
------------------------------------------------------------------------------  

    subtype X_Rm_File_Type is R3.X_Rm_File_Type;  

    function "=" (A, B : X_Rm_File_Type) return Boolean renames R3."=";  

    None_X_Rm_File_Type : X_Rm_File_Type renames R3.None_X_Rm_File_Type;  

    procedure Free_X_Rm_File_Type (File : in out X_Rm_File_Type)  
        renames R3.Free_X_Rm_File_Type;  

------------------------------------------------------------------------------  
-- X_Rm_Quark_Bit_List - array of bits used to speed RM processing  
------------------------------------------------------------------------------  

    subtype X_Rm_Quark_Bit_Array is R3.X_Rm_Quark_Bit_Array;  
    subtype X_Rm_Quark_Bit_List  is R3.X_Rm_Quark_Bit_List;  

    function "=" (A, B : X_Rm_Quark_Bit_List) return Boolean renames R3."=";  

    None_X_Rm_Quark_Bit_List : X_Rm_Quark_Bit_List  
        renames R3.None_X_Rm_Quark_Bit_List;  

    procedure Free_X_Rm_Quark_Bit_List (List : in out X_Rm_Quark_Bit_List)  
        renames R3.Free_X_Rm_Quark_Bit_List;  

end Xlbt_Rm2;  

