with Unchecked_Deallocation;  

with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  

with Xlbmt_Parameters;  
use Xlbmt_Parameters;  

package Xlbt_String16 is  
------------------------------------------------------------------------------  
-- X Library 16-bit character types  
--  
-- Xlbt_String16 - Extended 16-bit character types  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
------------------------------------------------------------------------------  
-- X_Character16  
------------------------------------------------------------------------------  

    type X_Character16 is  
        record        -- normal 16 bit characters are two bytes  
            Char1 : U_Char;  
            Char2 : U_Char;  
        end record;  

--/ if Length_Clauses then  
    for X_Character16'Size use 16;  
--/ end if;  

--/ if Record_Rep_Clauses then  
 
    for X_Character16 use  
        record  
            Char1 at 0 * X_Word range X_Byte0a .. X_Byte0b;  
            Char2 at 0 * X_Word range X_Byte1a .. X_Byte1b;  
        end record;  
 
--/ end if;  

------------------------------------------------------------------------------  
-- X_String16  
-- 16-bit character string types  
------------------------------------------------------------------------------  

    type X_String16 is array (S_Natural range <>) of X_Character16;  

    type X_String16_Pointer is access X_String16;  

--/ if Pack then  
    pragma Pack (X_String16);  
--/ end if;  
--/ if Enable_Deallocation then  
    pragma Enable_Deallocation (X_String16_Pointer);  
--/ end if;  

    procedure Free_X_String16_Pointer is  
       new Unchecked_Deallocation (X_String16,  
                                   X_String16_Pointer);  

end Xlbt_String16;  

