with Unchecked_Deallocation;  

with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  

package Xlbt_String7 is  
------------------------------------------------------------------------------  
-- X Library 7-bit character types (Ada Strings)  
--  
-- Xlbt_String7 - Normal Ada 7-bit character Strings  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
------------------------------------------------------------------------------  
-- X_String7_Pointer  
------------------------------------------------------------------------------  

    type X_String7_Pointer is access String;  

--/ if Enable_Deallocation then  
    pragma Enable_Deallocation (X_String7_Pointer);  
--/ end if;  

    procedure Free_X_String7_Pointer is  
       new Unchecked_Deallocation (String,  
                                   X_String7_Pointer);  

    None_X_String7_Pointer : constant X_String7_Pointer := null;  

end Xlbt_String7;  

