with Unchecked_Deallocation;  

with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  
with Xlbt_Basic3;  
use Xlbt_Basic3;  
with Xlbt_String;  
use Xlbt_String;  
with Xlbt_String16;  
use Xlbt_String16;  

package Xlbt_Text3 is  
------------------------------------------------------------------------------  
-- X Library Text Drawing - Full Interface  
--  
-- Xlbt_Text3 - Types dealing with drawn text  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

------------------------------------------------------------------------------  
-- X_Text_Item  
------------------------------------------------------------------------------  

    type X_Text_Item is  
        record  
            Chars  :                -- pointer to str  
               X_String_Pointer;  
            Deltaa : S_Short := 0;  -- delta between strings  
            Font   : X_Font  :=     -- font to print it in, None_X_Font means  
               None_X_Font;         --  don't change  
        end record;  

    type X_Text_Item_Array is array (S_Natural range <>) of X_Text_Item;  
    type X_Text_Item_List  is access X_Text_Item_Array;  

--/ if Pack then  
    pragma Pack (X_Text_Item_Array);  
--/ end if;  
--/ if Enable_Deallocation then  
    pragma Enable_Deallocation (X_Text_Item_List);  
--/ end if;  

    None_X_Text_Item_List : constant X_Text_Item_List := null;  

    procedure Free_X_Text_Item_List (List : in out X_Text_Item_List);  

------------------------------------------------------------------------------  
-- X_Text_Item16  
------------------------------------------------------------------------------  

    type X_Text_Item16 is  
        record  
            Chars  :                -- two byte characters  
               X_String16_Pointer;  
            Deltaa : S_Short := 0;  -- delta between strings  
            Font   : X_Font  :=     -- font to print it in, None_X_Font means  
               None_X_Font;         --  don't change  
        end record;  

    type X_Text_Item16_Array is array (S_Natural range <>) of X_Text_Item16;  
    type X_Text_Item16_List  is access X_Text_Item16_Array;  

--/ if Pack then  
    pragma Pack (X_Text_Item16_Array);  
--/ end if;  
--/ if Enable_Deallocation then  
    pragma Enable_Deallocation (X_Text_Item16_List);  
--/ end if;  

    None_X_Text_Item16_List : constant X_Text_Item16_List := null;  

    procedure Free_X_Text_Item16_List (List : in out X_Text_Item16_List);  

end Xlbt_Text3;  

