with Xlbt_Window3;  
with Xlbt_Window4;  

package Xlbt_Window is  
------------------------------------------------------------------------------  
-- X Library Windows  
--  
-- Xlbt_Window - Types dealing with windows and window state  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
    package W3 renames Xlbt_Window3;  
    package W4 renames Xlbt_Window4;  

------------------------------------------------------------------------------  
-- X_Backing_Store_Hint  
--  
--      Not_Useful  
--      When_Mapped  
--      Always  
------------------------------------------------------------------------------  

    subtype X_Backing_Store_Hint is W4.X_Backing_Store_Hint;  

    Not_Useful  : constant X_Backing_Store_Hint := W4.Not_Useful;  
    When_Mapped : constant X_Backing_Store_Hint := W4.When_Mapped;  
    Always      : constant X_Backing_Store_Hint := W4.Always;  

    None_X_Backing_Store_Hint : X_Backing_Store_Hint  
        renames W4.None_X_Backing_Store_Hint;  

    function "=" (A, B : X_Backing_Store_Hint) return Boolean renames W4."=";  

------------------------------------------------------------------------------  
-- X_Bit_Gravity  
--  
--      Forget_Bit_Gravity  
--      North_West_Bit_Gravity  
--      North_Bit_Gravity  
--      North_East_Bit_Gravity  
--      West_Bit_Gravity  
--      Center_Bit_Gravity  
--      East_Bit_Gravity  
--      South_West_Bit_Gravity  
--      South_Bit_Gravity  
--      South_East_Bit_Gravity  
--      Static_Bit_Gravity  
------------------------------------------------------------------------------  

    subtype X_Bit_Gravity is W4.X_Bit_Gravity;  

    subtype Xbg is X_Bit_Gravity;  

    Forget_Bit_Gravity     : constant Xbg := W4.Forget_Bit_Gravity;  
    North_West_Bit_Gravity : constant Xbg := W4.North_West_Bit_Gravity;  
    North_Bit_Gravity      : constant Xbg := W4.North_Bit_Gravity;  
    North_East_Bit_Gravity : constant Xbg := W4.North_East_Bit_Gravity;  
    West_Bit_Gravity       : constant Xbg := W4.West_Bit_Gravity;  
    Center_Bit_Gravity     : constant Xbg := W4.Center_Bit_Gravity;  
    East_Bit_Gravity       : constant Xbg := W4.East_Bit_Gravity;  
    South_West_Bit_Gravity : constant Xbg := W4.South_West_Bit_Gravity;  
    South_Bit_Gravity      : constant Xbg := W4.South_Bit_Gravity;  
    South_East_Bit_Gravity : constant Xbg := W4.South_East_Bit_Gravity;  
    Static_Bit_Gravity     : constant Xbg := W4.Static_Bit_Gravity;  

    None_X_Bit_Gravity : X_Bit_Gravity renames W4.None_X_Bit_Gravity;  

    function "=" (A, B : X_Bit_Gravity) return Boolean renames W4."=";  

------------------------------------------------------------------------------  
-- X_Circulate_Place  
--  
--      Place_On_Top  
--      Place_On_Bottom  
--      Raise_Lowest  
--      Lower_Highest  
------------------------------------------------------------------------------  

    subtype X_Circulate_Place is W4.X_Circulate_Place;  

    Place_On_Top    : constant X_Circulate_Place := W4.Place_On_Top;  
    Place_On_Bottom : constant X_Circulate_Place := W4.Place_On_Bottom;  

----Circulation direction  

    Raise_Lowest  : X_Circulate_Place renames W4.Raise_Lowest;  
    Lower_Highest : X_Circulate_Place renames W4.Lower_Highest;  

    function "=" (A, B : X_Circulate_Place) return Boolean renames W4."=";  

------------------------------------------------------------------------------  
-- X_Map_State  
--  
--      Is_Unmapped  
--      Is_Unviewable  
--      Is_Viewable  
------------------------------------------------------------------------------  

    subtype X_Map_State is W4.X_Map_State;  

    Is_Unmapped   : constant X_Map_State := W4.Is_Unmapped;  
    Is_Unviewable : constant X_Map_State := W4.Is_Unviewable;  
    Is_Viewable   : constant X_Map_State := W4.Is_Viewable;  

    None_X_Map_State : X_Map_State renames W4.None_X_Map_State;  

    function "=" (A, B : X_Map_State) return Boolean renames W4."=";  

------------------------------------------------------------------------------  
-- X_New_Window_Attributes  
--  
--        Cw_Cursor  
--        Cw_Colormap  
--        Cw_Dont_Propagate  
--        Cw_Event_Mask  
--        Cw_Save_Under  
--        Cw_Override_Redirect  
--        Cw_Backing_Pixel  
--        Cw_Backing_Planes  
--        Cw_Backing_Store  
--        Cw_Win_Gravity  
--        Cw_Bit_Gravity  
--        Cw_Border_Pixel  
--        Cw_Border_Pixmap  
--        Cw_Back_Pixel  
--        Cw_Back_Pixmap  
------------------------------------------------------------------------------  

    subtype X_New_Window_Attributes_Index is W4.X_New_Window_Attributes_Index;  
    subtype X_New_Window_Attributes       is W4.X_New_Window_Attributes;  

    subtype Xnwai is X_New_Window_Attributes_Index;  
    subtype Xnwa  is X_New_Window_Attributes;  

    Cw_Cursor            : constant Xnwai := W4.Cw_Cursor;  
    Cw_Colormap          : constant Xnwai := W4.Cw_Colormap;  
    Cw_Dont_Propagate    : constant Xnwai := W4.Cw_Dont_Propagate;  
    Cw_Event_Mask        : constant Xnwai := W4.Cw_Event_Mask;  
    Cw_Save_Under        : constant Xnwai := W4.Cw_Save_Under;  
    Cw_Override_Redirect : constant Xnwai := W4.Cw_Override_Redirect;  
    Cw_Backing_Pixel     : constant Xnwai := W4.Cw_Backing_Pixel;  
    Cw_Backing_Planes    : constant Xnwai := W4.Cw_Backing_Planes;  
    Cw_Backing_Store     : constant Xnwai := W4.Cw_Backing_Store;  
    Cw_Win_Gravity       : constant Xnwai := W4.Cw_Win_Gravity;  
    Cw_Bit_Gravity       : constant Xnwai := W4.Cw_Bit_Gravity;  
    Cw_Border_Pixel      : constant Xnwai := W4.Cw_Border_Pixel;  
    Cw_Border_Pixmap     : constant Xnwai := W4.Cw_Border_Pixmap;  
    Cw_Background_Pixel  : constant Xnwai := W4.Cw_Background_Pixel;  
    Cw_Background_Pixmap : constant Xnwai := W4.Cw_Background_Pixmap;  

----These names are kept for backwards compatibility only.  Use the longer  
--  names given above.  

    Cw_Back_Pixel  : constant Xnwai := W4.Cw_Background_Pixel;  
    Cw_Back_Pixmap : constant Xnwai := W4.Cw_Background_Pixmap;  

----These flags are unused by X Library  

    Xnwai31 : constant Xnwai := W4.Xnwai31;  
    Xnwai30 : constant Xnwai := W4.Xnwai30;  
    Xnwai29 : constant Xnwai := W4.Xnwai29;  
    Xnwai28 : constant Xnwai := W4.Xnwai28;  
    Xnwai27 : constant Xnwai := W4.Xnwai27;  
    Xnwai26 : constant Xnwai := W4.Xnwai26;  
    Xnwai25 : constant Xnwai := W4.Xnwai25;  
    Xnwai24 : constant Xnwai := W4.Xnwai24;  
    Xnwai23 : constant Xnwai := W4.Xnwai23;  
    Xnwai22 : constant Xnwai := W4.Xnwai22;  
    Xnwai21 : constant Xnwai := W4.Xnwai21;  
    Xnwai20 : constant Xnwai := W4.Xnwai20;  
    Xnwai19 : constant Xnwai := W4.Xnwai19;  
    Xnwai18 : constant Xnwai := W4.Xnwai18;  
    Xnwai17 : constant Xnwai := W4.Xnwai17;  
    Xnwai16 : constant Xnwai := W4.Xnwai16;  
    Xnwai15 : constant Xnwai := W4.Xnwai15;  

    None_X_New_Window_Attributes : X_New_Window_Attributes renames  
       W4.None_X_New_Window_Attributes;  

    All_X_New_Window_Attributes : X_New_Window_Attributes  
        renames W4.All_X_New_Window_Attributes;  

    function "="   (A, B : Xnwai) return Boolean renames W4."=";  
    function "="   (A, B : Xnwa)  return Boolean renames W4."=";  
    function "and" (A, B : Xnwa)  return Xnwa    renames W4."and";  
    function "or"  (A, B : Xnwa)  return Xnwa    renames W4."or";  
    function "xor" (A, B : Xnwa)  return Xnwa    renames W4."xor";  
    function "not" (A : Xnwa)     return Xnwa    renames W4."not";  

------------------------------------------------------------------------------  
-- X_Property_Mode  
------------------------------------------------------------------------------  

    subtype X_Property_Mode is W4.X_Property_Mode;  

    Prop_Mode_Replace : constant X_Property_Mode := W4.Prop_Mode_Replace;  
    Prop_Mode_Prepend : constant X_Property_Mode := W4.Prop_Mode_Prepend;  
    Prop_Mode_Append  : constant X_Property_Mode := W4.Prop_Mode_Append;  

    function "=" (A, B : X_Property_Mode) return Boolean renames W4."=";  

------------------------------------------------------------------------------  
-- Property notification  
------------------------------------------------------------------------------  

    subtype X_Property_State is W4.X_Property_State;  

    Property_New_Value : constant X_Property_State := W4.Property_New_Value;  
    Property_Delete    : constant X_Property_State := W4.Property_Delete;  

    function "=" (A, B : X_Property_State) return Boolean renames W4."=";  

------------------------------------------------------------------------------  
-- X_Set_Window_Attributes - used with X_New_Window_Attributes to set/change  
-- a window's attributes.  
------------------------------------------------------------------------------  

    subtype X_Set_Window_Attributes is W3.X_Set_Window_Attributes;  

------------------------------------------------------------------------------  
-- X_Window_Attributes - returned in response to a query about window attributes  
------------------------------------------------------------------------------  

    subtype X_Window_Attributes is W3.X_Window_Attributes;  

------------------------------------------------------------------------------  
-- X_Window_Changes - used to make several changes at once  
------------------------------------------------------------------------------  

    subtype X_Window_Changes is W3.X_Window_Changes;  

------------------------------------------------------------------------------  
-- X_Window_Changes_Mask  
--  
--      Cw_Stack_Mode  
--      Cw_Sibling  
--      Cw_Border_Width  
--      Cw_Height  
--      Cw_Width  
--      Cw_Y  
--      Cw_X  
------------------------------------------------------------------------------  

    subtype X_Window_Changes_Mask_Index is W4.X_Window_Changes_Mask_Index;  
    subtype X_Window_Changes_Mask       is W4.X_Window_Changes_Mask;  

    subtype Xwcmi is X_Window_Changes_Mask_Index;  
    subtype Xwcm  is X_Window_Changes_Mask;  

    Cw_Stack_Mode   : constant Xwcmi := W4.Cw_Stack_Mode;  
    Cw_Sibling      : constant Xwcmi := W4.Cw_Sibling;  
    Cw_Border_Width : constant Xwcmi := W4.Cw_Border_Width;  
    Cw_Height       : constant Xwcmi := W4.Cw_Height;  
    Cw_Width        : constant Xwcmi := W4.Cw_Width;  
    Cw_Y            : constant Xwcmi := W4.Cw_Y;  
    Cw_X            : constant Xwcmi := W4.Cw_X;  

----These are not currently used by the X Library.  

    Xwcmi15 : constant Xwcmi := W4.Xwcmi15;  
    Xwcmi14 : constant Xwcmi := W4.Xwcmi14;  
    Xwcmi13 : constant Xwcmi := W4.Xwcmi13;  
    Xwcmi12 : constant Xwcmi := W4.Xwcmi12;  
    Xwcmi11 : constant Xwcmi := W4.Xwcmi11;  
    Xwcmi10 : constant Xwcmi := W4.Xwcmi10;  
    Xwcmi09 : constant Xwcmi := W4.Xwcmi09;  
    Xwcmi08 : constant Xwcmi := W4.Xwcmi08;  
    Xwcmi07 : constant Xwcmi := W4.Xwcmi07;  

    None_X_Window_Changes_Mask : X_Window_Changes_Mask renames  
       W4.None_X_Window_Changes_Mask;  

    All_X_Window_Changes_Mask : X_Window_Changes_Mask  
        renames W4.All_X_Window_Changes_Mask;  

    function "="   (A, B : Xwcmi) return Boolean renames W4."=";  
    function "="   (A, B : Xwcm)  return Boolean renames W4."=";  
    function "and" (A, B : Xwcm)  return Xwcm    renames W4."and";  
    function "or"  (A, B : Xwcm)  return Xwcm    renames W4."or";  
    function "xor" (A, B : Xwcm)  return Xwcm    renames W4."xor";  
    function "not" (A : Xwcm)     return Xwcm    renames W4."not";  

------------------------------------------------------------------------------  
-- X_Window_Class  
--  
--      Copy_From_Parent -- make the same as the parent window  
--      Input_Output     -- perform both input and output  
--      Input_Only       -- will only be for input  
------------------------------------------------------------------------------  

    subtype X_Window_Class is W4.X_Window_Class;  

    Copy_From_Parent : constant X_Window_Class := W4.Copy_From_Parent;  
    Input_Output     : constant X_Window_Class := W4.Input_Output;  
    Input_Only       : constant X_Window_Class := W4.Input_Only;  

    None_X_Window_Class : X_Window_Class renames W4.None_X_Window_Class;  

    function "=" (A, B : X_Window_Class) return Boolean renames W4."=";  

------------------------------------------------------------------------------  
-- X_Window_Gravity  
--  
--      Unmap_Gravity  
--      North_West_Gravity  
--      North_Gravity  
--      North_East_Gravity  
--      West_Gravity  
--      Center_Gravity  
--      East_Gravity  
--      South_West_Gravity  
--      South_Gravity  
--      South_East_Gravity  
--      Static_Gravity  
------------------------------------------------------------------------------  

    subtype X_Window_Gravity is W4.X_Window_Gravity;  

    subtype Xwg is X_Window_Gravity;  

    Unmap_Gravity      : constant Xwg := W4.Unmap_Gravity;  
    North_West_Gravity : constant Xwg := W4.North_West_Gravity;  
    North_Gravity      : constant Xwg := W4.North_Gravity;  
    North_East_Gravity : constant Xwg := W4.North_East_Gravity;  
    West_Gravity       : constant Xwg := W4.West_Gravity;  
    Center_Gravity     : constant Xwg := W4.Center_Gravity;  
    East_Gravity       : constant Xwg := W4.East_Gravity;  
    South_West_Gravity : constant Xwg := W4.South_West_Gravity;  
    South_Gravity      : constant Xwg := W4.South_Gravity;  
    South_East_Gravity : constant Xwg := W4.South_East_Gravity;  
    Static_Gravity     : constant Xwg := W4.Static_Gravity;  

    None_X_Window_Gravity : X_Window_Gravity renames W4.None_X_Window_Gravity;  

    function "=" (A, B : X_Window_Gravity) return Boolean renames W4."=";  

------------------------------------------------------------------------------  
-- X_Window_Stacking  
--  
--      Above  
--      Below  
--      Top_If  
--      Bottom_If  
--      Opposite  
------------------------------------------------------------------------------  

    subtype X_Window_Stacking is W4.X_Window_Stacking;  

    Above     : constant X_Window_Stacking := W4.Above;  
    Below     : constant X_Window_Stacking := W4.Below;  
    Top_If    : constant X_Window_Stacking := W4.Top_If;  
    Bottom_If : constant X_Window_Stacking := W4.Bottom_If;  
    Opposite  : constant X_Window_Stacking := W4.Opposite;  

    None_X_Window_Stacking : X_Window_Stacking  
        renames W4.None_X_Window_Stacking;  

    function "=" (A, B : X_Window_Stacking) return Boolean renames W4."=";  

end Xlbt_Window;  

