package Xlbt_Window4 is  
------------------------------------------------------------------------------  
-- X Library Windows - Full Interface - Enumerations and Discretes  
--  
-- Xlbt_Window4 - Types dealing with windows and window state  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
------------------------------------------------------------------------------  
-- X_Backing_Store_Hint  
------------------------------------------------------------------------------  

    type X_Backing_Store_Hint is (Not_Useful,  
                                  When_Mapped,  
                                  Always);  

--/ if Length_Clauses then  
    for X_Backing_Store_Hint'Size use 8;  
--/ end if;  

    None_X_Backing_Store_Hint : constant X_Backing_Store_Hint :=  
       X_Backing_Store_Hint'Val (0);  

------------------------------------------------------------------------------  
-- X_Bit_Gravity  
------------------------------------------------------------------------------  

    type X_Bit_Gravity is (Forget_Bit_Gravity,  
                           North_West_Bit_Gravity,  
                           North_Bit_Gravity,  
                           North_East_Bit_Gravity,  
                           West_Bit_Gravity,  
                           Center_Bit_Gravity,  
                           East_Bit_Gravity,  
                           South_West_Bit_Gravity,  
                           South_Bit_Gravity,  
                           South_East_Bit_Gravity,  
                           Static_Bit_Gravity);  

--/ if Length_Clauses then  
    for X_Bit_Gravity'Size use 8;  
--/ end if;  

    None_X_Bit_Gravity : constant X_Bit_Gravity := X_Bit_Gravity'Val (0);  

------------------------------------------------------------------------------  
-- X_Circulate_Place  
------------------------------------------------------------------------------  

    type X_Circulate_Place is  
       (Place_On_Top,  
        Place_On_Bottom);  

--/ if Length_Clauses then  
    for X_Circulate_Place'Size use 8;  
--/ end if;  

----Circulation direction  

    Raise_Lowest  : constant X_Circulate_Place := Place_On_Top;  
    Lower_Highest : constant X_Circulate_Place := Place_On_Bottom;  

------------------------------------------------------------------------------  
-- X_Map_State  
------------------------------------------------------------------------------  

    type X_Map_State is (Is_Unmapped,  
                         Is_Unviewable,  
                         Is_Viewable);  

--/ if Length_Clauses then  
    for X_Map_State'Size use 8;  
--/ end if;  

    None_X_Map_State : constant X_Map_State := X_Map_State'Val (0);  

------------------------------------------------------------------------------  
-- X_New_Window_Attributes  
------------------------------------------------------------------------------  

--/ if Bit0_Sign_Bit then  

    type X_New_Window_Attributes_Index is  
       (Xnwai31, Xnwai30, Xnwai29, Xnwai28, Xnwai27, Xnwai26,  
        Xnwai25, Xnwai24, Xnwai23, Xnwai22, Xnwai21, Xnwai20,  
        Xnwai19, Xnwai18, Xnwai17, Xnwai16, Xnwai15, -- Unused  
        Cw_Cursor,  
        Cw_Colormap,  
        Cw_Dont_Propagate,  
        Cw_Event_Mask,  
        Cw_Save_Under,  
        Cw_Override_Redirect,  
        Cw_Backing_Pixel,  
        Cw_Backing_Planes,  
        Cw_Backing_Store,  
        Cw_Win_Gravity,  
        Cw_Bit_Gravity,  
        Cw_Border_Pixel,  
        Cw_Border_Pixmap,  
        Cw_Background_Pixel,  
        Cw_Background_Pixmap);  

--/ else -- not Bit0_Sign_Bit then  
 
    type X_New_Window_Attributes_Index is  
       (Cw_Background_Pixmap,  
        Cw_Background_Pixel,  
        Cw_Border_Pixmap,  
        Cw_Border_Pixel,  
        Cw_Bit_Gravity,  
        Cw_Win_Gravity,  
        Cw_Backing_Store,  
        Cw_Backing_Planes,  
        Cw_Backing_Pixel,  
        Cw_Override_Redirect,  
        Cw_Save_Under,  
        Cw_Event_Mask,  
        Cw_Dont_Propagate,  
        Cw_Colormap,  
        Cw_Cursor,  
        Xnwai15, Xnwai16, Xnwai17, Xnwai18, Xnwai19, Xnwai20,  
        Xnwai21, Xnwai22, Xnwai23, Xnwai24, Xnwai25, Xnwai26,  
        Xnwai27, Xnwai28, Xnwai29, Xnwai30, Xnwai31);  
 
--/ end if;  

    type X_New_Window_Attributes is  
       array (X_New_Window_Attributes_Index) of Boolean;  

--/ if Length_Clauses then  
    for X_New_Window_Attributes'Size use 32;  
--/ elsif Pack then  
    pragma Pack (X_New_Window_Attributes);  
--/ end if;  

    None_X_New_Window_Attributes : constant X_New_Window_Attributes :=  
       X_New_Window_Attributes'(others => False);  

    All_X_New_Window_Attributes : constant X_New_Window_Attributes :=  
       X_New_Window_Attributes'  
          (Xnwai31 | Xnwai30 | Xnwai29 | Xnwai28 | Xnwai27 | Xnwai26 |  
           Xnwai25 | Xnwai24 | Xnwai23 | Xnwai22 | Xnwai21 | Xnwai20 |  
           Xnwai19 | Xnwai18 | Xnwai17 | Xnwai16 | Xnwai15 => False, -- Unused  

           Cw_Cursor | Cw_Colormap | Cw_Dont_Propagate | Cw_Event_Mask |  
           Cw_Save_Under | Cw_Override_Redirect | Cw_Backing_Pixel |  
           Cw_Backing_Planes | Cw_Backing_Store | Cw_Win_Gravity |  
           Cw_Bit_Gravity | Cw_Border_Pixel | Cw_Border_Pixmap |  
           Cw_Background_Pixel | Cw_Background_Pixmap      => True);  

------------------------------------------------------------------------------  
-- X_Property_Mode  
------------------------------------------------------------------------------  

    type X_Property_Mode is (Prop_Mode_Replace,  
                             Prop_Mode_Prepend,  
                             Prop_Mode_Append);  

--/ if Length_Clauses then  
    for X_Property_Mode'Size use 8;  
--/ end if;  

------------------------------------------------------------------------------  
-- Property notification  
------------------------------------------------------------------------------  

    type X_Property_State is (Property_New_Value,  
                              Property_Delete);  

--/ if Length_Clauses then  
    for X_Property_State'Size use 8;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_Window_Changes_Mask  
------------------------------------------------------------------------------  

--/ if Bit0_Sign_Bit then  

    type X_Window_Changes_Mask_Index is  
       (Xwcmi15, Xwcmi14, Xwcmi13, Xwcmi12, Xwcmi11,  
        Xwcmi10, Xwcmi09, Xwcmi08, Xwcmi07, Cw_Stack_Mode,  
        Cw_Sibling,  
        Cw_Border_Width,  
        Cw_Height,  
        Cw_Width,  
        Cw_Y,  
        Cw_X);  

--/ else -- not Bit0_Sign_Bit then  
 
    type X_Window_Changes_Mask_Index is  
       (Cw_X,  
        Cw_Y,  
        Cw_Width,  
        Cw_Height,  
        Cw_Border_Width,  
        Cw_Sibling,  
        Cw_Stack_Mode,  
        Xwcmi07, Xwcmi08, Xwcmi09, Xwcmi10, Xwcmi11,  
        Xwcmi12, Xwcmi13, Xwcmi14, Xwcmi15);  
 
--/ end if;  

    type X_Window_Changes_Mask is  
       array (X_Window_Changes_Mask_Index) of Boolean;  

--/ if Length_Clauses then  
    for X_Window_Changes_Mask'Size use 16;  
--/ elsif Pack then  
    pragma Pack (X_Window_Changes_Mask);  
--/ end if;  

    None_X_Window_Changes_Mask : constant X_Window_Changes_Mask :=  
       X_Window_Changes_Mask'(others => False);  

    All_X_Window_Changes_Mask : constant X_Window_Changes_Mask :=  
       X_Window_Changes_Mask'(Xwcmi15 | Xwcmi14 | Xwcmi13 | Xwcmi12 | Xwcmi11 |  
                              Xwcmi10 | Xwcmi09 | Xwcmi08 | Xwcmi07 => False,  

                              Cw_Stack_Mode | Cw_Sibling | Cw_Border_Width |  
                              Cw_Height | Cw_Width | Cw_Y | Cw_X    => True);  

------------------------------------------------------------------------------  
-- X_Window_Class  
------------------------------------------------------------------------------  

    type X_Window_Class is (Copy_From_Parent,  
                            Input_Output,  
                            Input_Only);  

--/ if Length_Clauses then  
    for X_Window_Class'Size use 16;  
--/ end if;  

    None_X_Window_Class : constant X_Window_Class := X_Window_Class'Val (0);  

------------------------------------------------------------------------------  
-- X_Window_Gravity  
------------------------------------------------------------------------------  

    type X_Window_Gravity is (Unmap_Gravity,  
                              North_West_Gravity,  
                              North_Gravity,  
                              North_East_Gravity,  
                              West_Gravity,  
                              Center_Gravity,  
                              East_Gravity,  
                              South_West_Gravity,  
                              South_Gravity,  
                              South_East_Gravity,  
                              Static_Gravity);  

--/ if Length_Clauses then  
    for X_Window_Gravity'Size use 8;  
--/ end if;  

    None_X_Window_Gravity : constant X_Window_Gravity :=  
       X_Window_Gravity'Val (0);  

------------------------------------------------------------------------------  
-- X_Window_Stacking  
------------------------------------------------------------------------------  

    type X_Window_Stacking is (Above,  
                               Below,  
                               Top_If,  
                               Bottom_If,  
                               Opposite);  

--/ if Length_Clauses then  
    for X_Window_Stacking'Size use 8;  
--/ end if;  

    None_X_Window_Stacking : constant X_Window_Stacking :=  
       X_Window_Stacking'Val (0);  

end Xlbt_Window4;  

