with Xlbt_String;  
use Xlbt_String;  

package Exe_100 is  
------------------------------------------------------------------------------  
-- Test Procedure Variables - for Procedure types  
--  
-- Utility code for the other Exe_100/200/300 series tests.  
------------------------------------------------------------------------------  

    Executed_Real_Op : Boolean;  

    procedure Assert (Hypothesis : Boolean);  

    function Value                  return X_String;  
    function Value (Arg : X_String) return Boolean;  

    type Access_Type is access Boolean;  

    function Value                         return Access_Type;  
    function Out_Value                     return Access_Type;  
    function Value     (Arg : Access_Type) return Boolean;  
    function Out_Value (Arg : Access_Type) return Boolean;  

    type Enumeration_Type is (Red, Blue, Green);  

    function Value return Enumeration_Type;  
    function Out_Value return Enumeration_Type;  
    function Value     (Arg : Enumeration_Type) return Boolean;  
    function Out_Value (Arg : Enumeration_Type) return Boolean;  

    type Boolean_Type is new Boolean;  

    function Value                          return Boolean_Type;  
    function Out_Value                      return Boolean_Type;  
    function Value     (Arg : Boolean_Type) return Boolean;  
    function Out_Value (Arg : Boolean_Type) return Boolean;  

    type Fixed_Type is new Duration;  

    function Value                        return Fixed_Type;  
    function Out_Value                    return Fixed_Type;  
    function Value     (Arg : Fixed_Type) return Boolean;  
    function Out_Value (Arg : Fixed_Type) return Boolean;  

    type Float_Type is new Float;  

    function Value                        return Float_Type;  
    function Out_Value                    return Float_Type;  
    function Value     (Arg : Float_Type) return Boolean;  
    function Out_Value (Arg : Float_Type) return Boolean;  

    type Constrained_Record_Type is  
        record  
            S : String (1 .. 10);  
        end record;  

    function Value return Constrained_Record_Type;  
    function Out_Value return Constrained_Record_Type;  
    function Value     (Arg : Constrained_Record_Type) return Boolean;  
    function Out_Value (Arg : Constrained_Record_Type) return Boolean;  

    type Unconstrained_Record_Type (D : Integer) is  
        record  
            S : String (1 .. D);  
        end record;  

    function Value return Unconstrained_Record_Type;  
    function Out_Value return Unconstrained_Record_Type;  
    function Value     (Arg : Unconstrained_Record_Type) return Boolean;  
    function Out_Value (Arg : Unconstrained_Record_Type) return Boolean;  

    type Constrained_String_Type is new String (1 .. 10);  

    function Value return Constrained_String_Type;  
    function Out_Value return Constrained_String_Type;  
    function Value     (Arg : Constrained_String_Type) return Boolean;  
    function Out_Value (Arg : Constrained_String_Type) return Boolean;  

    type Unconstrained_String_Type is new String;  

    function Value return Unconstrained_String_Type;  
    function Out_Value return Unconstrained_String_Type;  
    function Value     (Arg : Unconstrained_String_Type) return Boolean;  
    function Out_Value (Arg : Unconstrained_String_Type) return Boolean;  

    generic  
        type Argument_Type is private;  

        Arg1 : in out Argument_Type;  

        with function Value     return Argument_Type is <>;  
        with function Out_Value return Argument_Type is <>;  

        with function Value     (Arg : Argument_Type) return Boolean is <>;  
        with function Out_Value (Arg : Argument_Type) return Boolean is <>;  
    package Test_Proc_Inout is  
        procedure Zot;  
    end Test_Proc_Inout;  

    generic  
        type Argument_Type is private;  

        with function Value return Argument_Type is <>;  

        with function Value (Arg : Argument_Type) return Boolean is <>;  
    package Test_Proc_In is  
        procedure Zot;  
    end Test_Proc_In;  

    generic  
        type Argument1_Type is private;  
        type Argument2_Type is private;  

        with function Value return Argument1_Type is <>;  
        with function Value return Argument2_Type is <>;  

        with function Value (Arg : Argument1_Type) return Boolean is <>;  
        with function Value (Arg : Argument2_Type) return Boolean is <>;  
    package Test_Proc_In_In is  
        procedure Zot;  
    end Test_Proc_In_In;  

    generic  
        type Argument1_Type is private;  
        type Argument2_Type is private;  
        type Argument3_Type is private;  

        with function Value return Argument1_Type is <>;  
        with function Value return Argument2_Type is <>;  
        with function Value return Argument3_Type is <>;  

        with function Value (Arg : Argument1_Type) return Boolean is <>;  
        with function Value (Arg : Argument2_Type) return Boolean is <>;  
        with function Value (Arg : Argument3_Type) return Boolean is <>;  
    package Test_Proc_In_In_In is  
        procedure Zot;  
    end Test_Proc_In_In_In;  

    generic  
        type Argument1_Type is private;  
        type Argument2_Type is private;  
        type Argument3_Type is private;  
        type Argument4_Type is private;  

        with function Value return Argument1_Type is <>;  
        with function Value return Argument2_Type is <>;  
        with function Value return Argument3_Type is <>;  
        with function Value return Argument4_Type is <>;  

        with function Value (Arg : Argument1_Type) return Boolean is <>;  
        with function Value (Arg : Argument2_Type) return Boolean is <>;  
        with function Value (Arg : Argument3_Type) return Boolean is <>;  
        with function Value (Arg : Argument4_Type) return Boolean is <>;  
    package Test_Proc_In_In_In_In is  
        procedure Zot;  
    end Test_Proc_In_In_In_In;  

    generic  
        type Argument1_Type  is private;  
        type Argument2_Type  is private;  
        type Argument3_Type  is private;  
        type Argument4_Type  is private;  
        type Argument5_Type  is private;  
        type Argument6_Type  is private;  
        type Argument7_Type  is private;  
        type Argument8_Type  is private;  
        type Argument9_Type  is private;  
        type Argument10_Type is private;  

        with function Value return Argument1_Type  is <>;  
        with function Value return Argument2_Type  is <>;  
        with function Value return Argument3_Type  is <>;  
        with function Value return Argument4_Type  is <>;  
        with function Value return Argument5_Type  is <>;  
        with function Value return Argument6_Type  is <>;  
        with function Value return Argument7_Type  is <>;  
        with function Value return Argument8_Type  is <>;  
        with function Value return Argument9_Type  is <>;  
        with function Value return Argument10_Type is <>;  

        with function Value (Arg : Argument1_Type)  return Boolean is <>;  
        with function Value (Arg : Argument2_Type)  return Boolean is <>;  
        with function Value (Arg : Argument3_Type)  return Boolean is <>;  
        with function Value (Arg : Argument4_Type)  return Boolean is <>;  
        with function Value (Arg : Argument5_Type)  return Boolean is <>;  
        with function Value (Arg : Argument6_Type)  return Boolean is <>;  
        with function Value (Arg : Argument7_Type)  return Boolean is <>;  
        with function Value (Arg : Argument8_Type)  return Boolean is <>;  
        with function Value (Arg : Argument9_Type)  return Boolean is <>;  
        with function Value (Arg : Argument10_Type) return Boolean is <>;  
    package Test_Proc_In10 is  
        procedure Zot;  
    end Test_Proc_In10;  

    generic  
        type Argument1_Type is private;  
        type Argument2_Type is private;  
        type Argument3_Type is private;  
        type Argument4_Type is private;  
        type Argument5_Type is private;  

        Arg4 : in out Argument4_Type;  
        Arg5 : in out Argument5_Type;  

        with function Value     return Argument1_Type is <>;  
        with function Value     return Argument2_Type is <>;  
        with function Value     return Argument3_Type is <>;  
        with function Value     return Argument4_Type is <>;  
        with function Value     return Argument5_Type is <>;  
        with function Out_Value return Argument4_Type is <>;  
        with function Out_Value return Argument5_Type is <>;  

        with function Value     (Arg : Argument1_Type) return Boolean is <>;  
        with function Value     (Arg : Argument2_Type) return Boolean is <>;  
        with function Value     (Arg : Argument3_Type) return Boolean is <>;  
        with function Out_Value (Arg : Argument4_Type) return Boolean is <>;  
        with function Out_Value (Arg : Argument5_Type) return Boolean is <>;  
    package Test_Proc_In_In_In_Out_Out is  
        procedure Zot;  
    end Test_Proc_In_In_In_Out_Out;  

    generic  
        type Argument1_Type is private;  
        type Argument2_Type is private;  
        type Argument3_Type is private;  
        type Argument4_Type is private;  

        Arg3 : in out Argument3_Type;  
        Arg4 : in out Argument4_Type;  

        with function Value     return Argument1_Type is <>;  
        with function Value     return Argument2_Type is <>;  
        with function Value     return Argument3_Type is <>;  
        with function Value     return Argument4_Type is <>;  
        with function Out_Value return Argument3_Type is <>;  
        with function Out_Value return Argument4_Type is <>;  

        with function Value     (Arg : Argument1_Type) return Boolean is <>;  
        with function Value     (Arg : Argument2_Type) return Boolean is <>;  
        with function Out_Value (Arg : Argument3_Type) return Boolean is <>;  
        with function Out_Value (Arg : Argument4_Type) return Boolean is <>;  
    package Test_Proc_In_In_Out_Out is  
        procedure Zot;  
    end Test_Proc_In_In_Out_Out;  

    generic  
        type Argument_Type is private;  
        type Result_Type   is private;  

        with function Value return Argument_Type;  
        with function Value return Result_Type;  

        with function Value (Arg : Argument_Type)  return Boolean;  
        with function Value (Result : Result_Type) return Boolean;  
    package Test_Func_In is  
        procedure Zot;  
    end Test_Func_In;  

    generic  
        type Argument_Type is private;  

        with function Value return Argument_Type;  

        with function Value (Arg : Argument_Type) return Boolean;  
    package Test_Func_In_X_String is  
        procedure Zot;  
    end Test_Func_In_X_String;  

    generic  
        type Argument1_Type is private;  
        type Argument2_Type is private;  
        type Argument3_Type is private;  

        with function Value return Argument1_Type;  
        with function Value return Argument2_Type;  
        with function Value return Argument3_Type;  

        with function Value (Arg : Argument1_Type) return Boolean;  
        with function Value (Arg : Argument2_Type) return Boolean;  
        with function Value (Arg : Argument3_Type) return Boolean;  
    package Test_Func_In_In_In_X_String is  
        procedure Zot;  
    end Test_Func_In_In_In_X_String;  

    generic  
        type Argument1_Type is private;  
        type Argument2_Type is private;  
        type Argument3_Type is private;  
        type Result_Type    is private;  

        with function Value return Argument1_Type;  
        with function Value return Argument2_Type;  
        with function Value return Argument3_Type;  
        with function Value return Result_Type;  

        with function Value (Arg : Argument1_Type) return Boolean;  
        with function Value (Arg : Argument2_Type) return Boolean;  
        with function Value (Arg : Argument3_Type) return Boolean;  
        with function Value (Result : Result_Type) return Boolean;  
    package Test_Func_In_In_In is  
        procedure Zot;  
    end Test_Func_In_In_In;  

    generic  
        type Argument1_Type is private;  
        type Argument2_Type is private;  
        type Argument3_Type is private;  
        type Argument4_Type is private;  
        type Argument5_Type is private;  
        type Result_Type    is private;  

        with function Value return Argument1_Type;  
        with function Value return Argument2_Type;  
        with function Value return Argument3_Type;  
        with function Value return Argument4_Type;  
        with function Value return Argument5_Type;  
        with function Value return Result_Type;  

        with function Value (Arg : Argument1_Type) return Boolean;  
        with function Value (Arg : Argument2_Type) return Boolean;  
        with function Value (Arg : Argument3_Type) return Boolean;  
        with function Value (Arg : Argument4_Type) return Boolean;  
        with function Value (Arg : Argument5_Type) return Boolean;  
        with function Value (Result : Result_Type) return Boolean;  
    package Test_Func_In5 is  
        procedure Zot;  
    end Test_Func_In5;  

    generic  
        type Argument1_Type  is private;  
        type Argument2_Type  is private;  
        type Argument3_Type  is private;  
        type Argument4_Type  is private;  
        type Argument5_Type  is private;  
        type Argument6_Type  is private;  
        type Argument7_Type  is private;  
        type Argument8_Type  is private;  
        type Argument9_Type  is private;  
        type Argument10_Type is private;  
        type Result_Type     is private;  

        with function Value return Argument1_Type;  
        with function Value return Argument2_Type;  
        with function Value return Argument3_Type;  
        with function Value return Argument4_Type;  
        with function Value return Argument5_Type;  
        with function Value return Argument6_Type;  
        with function Value return Argument7_Type;  
        with function Value return Argument8_Type;  
        with function Value return Argument9_Type;  
        with function Value return Argument10_Type;  
        with function Value return Result_Type;  

        with function Value (Arg : Argument1_Type)  return Boolean;  
        with function Value (Arg : Argument2_Type)  return Boolean;  
        with function Value (Arg : Argument3_Type)  return Boolean;  
        with function Value (Arg : Argument4_Type)  return Boolean;  
        with function Value (Arg : Argument5_Type)  return Boolean;  
        with function Value (Arg : Argument6_Type)  return Boolean;  
        with function Value (Arg : Argument7_Type)  return Boolean;  
        with function Value (Arg : Argument8_Type)  return Boolean;  
        with function Value (Arg : Argument9_Type)  return Boolean;  
        with function Value (Arg : Argument10_Type) return Boolean;  
        with function Value (Result : Result_Type)  return Boolean;  
    package Test_Func_In10 is  
        procedure Zot;  
    end Test_Func_In10;  

end Exe_100;  

