with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  
with Xlbt_Rm3;  
use Xlbt_Rm3;  
with Xlbt_String;  
use Xlbt_String;  
with Xlbt_String7;  
use Xlbt_String7;  

package body Rm_Test_Utilities is  

    function Image (Value : Xlbt_Rm3.X_Rm_Value) return String is  
        -- Return an image of a resource database value.  
    begin  
        if (Value = None_X_Rm_Value) then  
            return "no value";  
        end if;  

        case Value.Kind is  
            when Is_None =>  
                return "<none>";  
            when Is_X_Rm_File_Type =>  
                return "<file>";  
            when Is_Boolean =>  
                return "<boolean> " & Boolean'Image (Value.V_Boolean);  
            when Is_Float =>  
                return "<float>";  
            when Is_U_Char_List =>  
                return "<u_char_list>";  
            when Is_U_Char =>  
                return "<U_Char> " & U_Char'Image (Value.V_U_Char);  
            when Is_U_Short =>  
                return "<U_Short> " & U_Short'Image (Value.V_U_Short);  
            when Is_S_Char =>  
                return "<S_Char> " & S_Char'Image (Value.V_S_Char);  
            when Is_S_Short =>  
                return "<S_Short> " & S_Short'Image (Value.V_S_Short);  
            when Is_S_Long =>  
                return "<s_long> " & S_Long'Image (Value.V_S_Long);  
            when Is_X_String7_Pointer =>  
                if Value.V_X_String7_Pointer /= null then  
                    return "<string7> """ & Value.V_X_String7_Pointer.all & '"';  
                else  
                    return "<string7> null";  
                end if;  
            when Is_X_String_Pointer =>  
                if Value.V_X_String_Pointer /= null then  
                    return To_String ('"' & Value.V_X_String_Pointer.all & '"');  
                else  
                    return "<string> null";  
                end if;  
            when Is_X_String16_Pointer =>  
                return "<string16>";  
            when Is_X_Universal_Pointer =>  
                return "<pointer>";  

            when Is_X_Atom =>  
                return "<X_Atom>";  
            when Is_X_Color =>  
                return "<X_Color>";  
            when Is_X_Colormap =>  
                return "<X_Colormap>";  
            when Is_X_Cursor =>  
                return "<X_Cursor>";  
            when Is_X_Display =>  
                return "<X_Display>";  
            when Is_X_Font =>  
                return "<X_Font>";  
            when Is_X_Font_Struct =>  
                return "<X_Font_Struct>";  
            when Is_X_Initial_Window_State =>  
                return "<X_Initial_Window_State>";  
            when Is_X_Pixel =>  
                return "<X_Pixel>";  
            when Is_X_Pixmap =>  
                return "<X_Pixmap>";  
            when Is_X_Screen =>  
                return "<X_Screen>";  
            when Is_X_Time =>  
                return "<X_Time>";  
            when Is_X_Visual =>  
                return "<X_Visual>";  
            when Is_X_Window =>  
                return "<X_Window>";  
        end case;  
    end Image;  

end Rm_Test_Utilities;  

