------------------------------------------------------------------------------  
-- X Library Testing  
--  
-- Run_One_Test - Handles running one test in a suite.  
------------------------------------------------------------------------------  
-- Copyright 1990 - 1990 by Rational, Santa Clara, California.  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the name of Rational not be used in  
-- advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- Rational disclaims all warranties with regard to this software, including  
-- all implied warranties of merchantability and fitness, in no event shall  
-- Rational be liable for any special, indirect or consequential damages or  
-- any damages whatsoever resulting from loss of use, data or profits, whether  
-- in an action of contract, negligence or other tortious action, arising out  
-- of or in connection with the use or performance of this software.  
------------------------------------------------------------------------------  

generic  
    with procedure The_Test;      -- The test procedure we are to run.  
    Test_Name          : String;  -- Name of the test we are running.  
    Test_Description   : String;  -- A brief description of the current test.  
    Ignore_Case        : Boolean; -- Log file comparison, ignore case?  
    Ignore_Blank_Lines : Boolean; -- Log file comparison, ignore blank lines?  
procedure Run_One_Test;  
------------------------------------------------------------------------------  
--  The_Test            - Specifies the parameterless test procedure to run.  
--  Test_Name           - Specifies the name of the test; for log messages.  
--  Ignore_Case         - Specifies TRUE if we ignore letter case in logs.  
--  Ignore_Blank_Lines  - Specifies TRUE if we ignore space/tab filled "blank"  
--                          lines in logs  
--  
-- Called to run one test program and to log the results of the run.  Compares  
-- the new results with saved old results.  
------------------------------------------------------------------------------  

